﻿local GUI = LibStub("AceGUI-3.0")

--Options Interface--
local options = { 
	name = function(info)
			return "Guild Leader 1.2.0 By: Impurity aka 2liftedgames"
			end,
    handler = GuildLeader,
    type = 'group',
    childGroups = "tab",
    args = {
		gmheader = {
			type = 'header',
			name = function(info)
			if GuildLeader:GetGuildName()~=nil then
			return strjoin("","Settings for ",GuildLeader.db:GetCurrentProfile())
			else
			return "Guild Leader is disabled as you are not currently in a guild"
			end
			end,
			order = 1,
			},
		recruitment = {
			type = 'group',
			name = "Recruitment",
			desc = "Guild Recruitment Settings",
			disabled = function(info)
				if CanGuildInvite()~=true then 
				return true
				else
				return false
				end
				end,
			order = 2,
			args = {
			zonerecruitment = {
			type = 'group',
			name = "Zone Recruitment",
			desc = "Zone Recruitment Settings",
			disabled = function(info)
				if CanGuildInvite()~=true then 
				return true
				else
				return false
				end
				end,
			order = 1,
			args = {
				cityspam = {
			type = 'toggle',
			name = "City Message Enabled?",
			desc = "Should I message in cities?",
			disabled = function(info)
				if CanGuildInvite()~=true then 
				return true
				else
				return false
				end
				end,
			get = function(info)
						return GuildLeader.db.profile.cityspam
					end,
			set = function(info, newValue)
						GuildLeader.db.profile.cityspam = newValue
					end,
			order = 1,
		},
				zonespam = {
				type = 'toggle',
				name = "Zone Message Enabled?",
				desc = "Should I message in regular zones?",
				disabled = function(info)
				if CanGuildInvite()~=true then 
				return true
				else
				return false
				end
				end,
				get = function(info)
							return GuildLeader.db.profile.zonespam
						end,
				set = function(info, newValue)
							GuildLeader.db.profile.zonespam = newValue
						end,
				order = 2,
			},
				outpvpspam = {
				type = 'toggle',
				name = "Outdoor PVP Zones Enabled?",
				desc = "Should I message in outdoor pvp zones?",
				disabled = function(info)
				if CanGuildInvite()~=true then 
				return true
				else
				return false
				end
				end,
				get = function(info)
							return GuildLeader.db.profile.outpvpspam
						end,
				set = function(info, newValue)
							GuildLeader.db.profile.outpvpspam = newValue
						end,
				order = 3,
			},
				
				manspam = {
					type = 'execute',
					name = "Manual Spam",
					desc = "Spams current zone",
					disabled = function(info)
					if GuildLeader.db.profile.isOfficer==false or GuildLeader.db.profile.canInvite==false then 
					return true
					else
					return false
					end
					end,
					func = 	function(info)
					if (GuildLeader:IsCity()) then 
					GuildLeader:SpamZone("City")
					else
					GuildLeader:SpamZone(GetZoneText())
					end
					end,
			order = 5,
		},
		updatetext = {
					type = 'description',
					name = "With update 8.2.5 Blizzard has restricted addons from automatically sending messages in channels, you can still use this to click the manual spam instead of making a macro but with that change we will not be supporting the chat spam feature. Sorry for the inconvience!",
					order = 6,
					},
				msg = {
            type = 'input',
            multiline = true,
            width = "full",
            name = "General Chat Message",
            desc = "The message text that will be broadcast in General/Trade",
            usage = "<Your message here>",
            disabled = function(info)
				if CanGuildInvite()~=true then 
				return true
				else
				return false
				end
				end,
            get = function(info)
						return GuildLeader.db.profile.message
					end,
            set = function(info, newValue)
						GuildLeader.db.profile.message = newValue
					end,
			order = 7,
        },
				citychannel = {
			type = 'range',
			name = "City Channel Number",
			desc = "Lets you choose which channel number you would like to recruit on while in a city. NOTE: By default 1 will use General, 2 will use Trade but it varies depending on how you set up your chat channels.",
			min = 1,
			max = 10,
			step = 1,
			disabled = function(info)
				if CanGuildInvite()~=true then 
				return true
				else
				return false
				end
				end,			
			get = function(info)
						return GuildLeader.db.profile.citychannel
					end,
			set = function(info, newValue)
						GuildLeader.db.profile.citychannel = newValue
					end,
			order = 8,
		},
				zonechannel = {
			type = 'range',
			name = "Zone Channel Number",
			desc = "Lets you choose which channel number you would like to recruit on while in a general zone. NOTE: By default 1 will use General, 3 will use Local Defense but it varies depending on how you set up your chat channels.",
			disabled = function(info)
				if CanGuildInvite()~=true then 
				return true
				else
				return false
				end
				end,
			min = 1,
			max = 10,
			step = 1,			
			get = function(info)
						return GuildLeader.db.profile.zonechannel
					end,
			set = function(info, newValue)
						GuildLeader.db.profile.zonechannel = newValue
					end,
			order = 9,
		},
				},
			},
			whorecruitment = {
			type = 'group',
			childGroups = "tab",
			name = "Toon Recruitment",
			desc = "Character Recruitment Settings NOTE: You will need to create a macro or modify your macros by adding '/run GuildLeader:InviteAction()' to each one. See documentation for details.",
			disabled = function(info)
				if CanGuildInvite()~=true then 
				return true
				else
				return false
				end
				end,
			order = 2,
			args = {		
			runwho = {
					type = 'execute',
					name = "Run Who Search",
					desc = "Begins searching for players. Character Recruitment uses the UI. UI elements such as the Mail Box, The Map, Character Stats, Achievments, etc. will close during the course of a cycle. It is recomended that you run this cycle if you plan to be AFK or doing something that doesnt require the UI as much. Raiding, Questing, etc.",
					
					confirm = true,
					func = 	function(info) 
					GuildLeader:RunWhoSearch()
					end,
					order = 1,
					disabled = function(info)
					if GuildLeader.db.profile.isOfficer == false or GuildLeader.db.profile.canInvite==false then 
					return true
					else
					return false
					end
					end,
			},
			automationupdate = {
					type = 'description',
					name = "With update 8.2.5 Blizzard has restricted addons from automatically querying players, you can still click search but we will not be supporting automation.",
					order = 2,
					},
			iqcontrols = {
			type = 'execute',
			name = "Launch IQ Controls?",
			desc = "The Invite Queue is a list of ",
			disabled = function(info)
				if CanGuildInvite()~=true then 
				return true
				else
				return false
				end
				end,
			func = 	function(info)
			GuildLeader:IQUI()
				end,
			order = 3,
		},
			targetclass = {
			type = 'toggle',
				name = "Target Specific Classes",
				desc = "Target specific classes when searching for players. Otherwise will target all classes.",
				disabled = function(info)
				if GuildLeader.db.profile.automatewho==true or CanGuildInvite()~=true then 
				return true
				else
				return false
				end
				end,
				get = function(info)
							return GuildLeader.db.profile.targetclass
						end,
				set = function(info, newValue)
							GuildLeader.db.profile.targetclass = newValue
						end,
				order = 4,
			},
			whispmsg = {
            type = 'input',
            multiline = true,
            width = "full",
            name = "Whisper Message",
            desc = "The message text that will be sent to targeted players",
            usage = "<Your message here>",
            disabled = function(info)
				if GuildLeader.db.profile.automatewho==true or CanGuildInvite()~=true then 
				return true
				else
				return false
				end
				end,
            get = function(info)
						return GuildLeader.db.profile.whispmessage
					end,
            set = function(info, newValue)
						GuildLeader.db.profile.whispmessage = newValue
					end,
			order = 5,
        },	
			minlevel = {
					type = 'range',
					name = "Minimum Level",
					desc = "The minimum level of people you are looking for (used when scanning Who Search results)",
					min = 1,
					max = 60,
					step = 1,	
					disabled = function(info)
				if GuildLeader.db.profile.automatewho==true or CanGuildInvite()~=true then 
				return true
				else
				return false
				end
				end,		
					get = function(info)
								return GuildLeader.db.profile.minlevel
							end,
					set = function(info, newValue)
								if newValue > GuildLeader.db.profile.maxlevel then
									GuildLeader:Print("Cannot set a minimum level higher than the maximum")
								return
								end
								GuildLeader.db.profile.minlevel = newValue
							end,
					order = 6,
				},
			maxlevel = {
					type = 'range',
					name = "Maximum Level",
					desc = "The maximum level of people you are looking for (used when scanning Who Search Results)",
					min = 1,
					max = 60,
					step = 1,	
					disabled = function(info)
				if GuildLeader.db.profile.automatewho==true or CanGuildInvite()~=true then 
				return true
				else
				return false
				end
				end,		
					get = function(info)
								return GuildLeader.db.profile.maxlevel
							end,
					set = function(info, newValue)
								if newValue < GuildLeader.db.profile.minlevel then
									GuildLeader:Print("Cannot set a maximum level lower than the minimum")
									return
								end
								GuildLeader.db.profile.maxlevel = newValue
							end,
					order = 7,
				},
			classsettings = {
			type = 'group',
			name = "Class List",
			desc = "Select the classes you wish to target",
			disabled = function(info)
				if GuildLeader.db.profile.automatewho==true or CanGuildInvite()~=true then 
				return true
				else
				return false
				end
				end,
			order = 8,
			disabled = function(info)
								if GuildLeader.db.profile.targetclass then return false end
								return true
							end,
			args = {
				DKsearch = {
				type = 'toggle',
				name = "Death Knight",
				desc = "Recruit Death Knights?",
				disabled = function(info)
				if GuildLeader.db.profile.automatewho==true or CanGuildInvite()~=true then 
				return true
				else
				return false
				end
				end,
				get = function(info)
							return GuildLeader.db.profile.DKsearch
						end,
				set = function(info, newValue)
							GuildLeader.db.profile.DKsearch = newValue
						end,
				order = 1,
			},	
				DHsearch = {
				type = 'toggle',
				name = "Demon Hunter",
				desc = "Recruit Demon Hunters?",
				disabled = function(info)
				if GuildLeader.db.profile.automatewho==true or CanGuildInvite()~=true then 
				return true
				else
				return false
				end
				end,
				get = function(info)
							return GuildLeader.db.profile.DHsearch
						end,
				set = function(info, newValue)
							GuildLeader.db.profile.DHsearch = newValue
						end,
				order = 1,
			},
				Druidsearch = {
				type = 'toggle',
				name = "Druid",
				desc = "Recruit Druids?",
				disabled = function(info)
				if GuildLeader.db.profile.automatewho==true or CanGuildInvite()~=true then 
				return true
				else
				return false
				end
				end,
				get = function(info)
							return GuildLeader.db.profile.Druidsearch
						end,
				set = function(info, newValue)
							GuildLeader.db.profile.Druidsearch = newValue
						end,
				order = 1,
			},	
				Huntersearch = {
				type = 'toggle',
				name = "Hunters",
				desc = "Recruit Hunters?",
				disabled = function(info)
				if GuildLeader.db.profile.automatewho==true or CanGuildInvite()~=true then 
				return true
				else
				return false
				end
				end,
				get = function(info)
							return GuildLeader.db.profile.Huntersearch
						end,
				set = function(info, newValue)
							GuildLeader.db.profile.Huntersearch = newValue
						end,
				order = 1,
			},
				Magesearch = {
				type = 'toggle',
				name = "Mage",
				desc = "Recruit Mages?",
				disabled = function(info)
				if GuildLeader.db.profile.automatewho==true or CanGuildInvite()~=true then 
				return true
				else
				return false
				end
				end,
				get = function(info)
							return GuildLeader.db.profile.Magesearch
						end,
				set = function(info, newValue)
							GuildLeader.db.profile.Magesearch = newValue
						end,
				order = 1,
			},	
				Monksearch = {
				type = 'toggle',
				name = "Monk",
				desc = "Recruit Monks?",
				disabled = function(info)
				if GuildLeader.db.profile.automatewho==true or CanGuildInvite()~=true then 
				return true
				else
				return false
				end
				end,
				get = function(info)
							return GuildLeader.db.profile.Monksearch
						end,
				set = function(info, newValue)
							GuildLeader.db.profile.Monksearch = newValue
						end,
				order = 1,
			},	
				Paladinsearch = {
				type = 'toggle',
				name = "Paladin",
				desc = "Recruit Paladins?",
				disabled = function(info)
				if GuildLeader.db.profile.automatewho==true or CanGuildInvite()~=true then 
				return true
				else
				return false
				end
				end,
				get = function(info)
							return GuildLeader.db.profile.Paladinsearch
						end,
				set = function(info, newValue)
							GuildLeader.db.profile.Paladinsearch = newValue
						end,
				order = 1,
			},	
				Priestsearch = {
				type = 'toggle',
				name = "Priest",
				desc = "Recruit Priests?",
				disabled = function(info)
				if GuildLeader.db.profile.automatewho==true or CanGuildInvite()~=true then 
				return true
				else
				return false
				end
				end,
				get = function(info)
							return GuildLeader.db.profile.Priestsearch
						end,
				set = function(info, newValue)
							GuildLeader.db.profile.Priestsearch = newValue
						end,
				order = 1,
			},	
				Roguesearch = {
				type = 'toggle',
				name = "Rogue",
				desc = "Recruit Rogues?",
				disabled = function(info)
				if GuildLeader.db.profile.automatewho==true or CanGuildInvite()~=true then 
				return true
				else
				return false
				end
				end,
				get = function(info)
							return GuildLeader.db.profile.Roguesearch
						end,
				set = function(info, newValue)
							GuildLeader.db.profile.Roguesearch = newValue
						end,
				order = 1,
			},	
				Shamansearch = {
				type = 'toggle',
				name = "Shaman",
				desc = "Recruit Shamans?",
				disabled = function(info)
				if GuildLeader.db.profile.automatewho==true or CanGuildInvite()~=true then 
				return true
				else
				return false
				end
				end,
				get = function(info)
							return GuildLeader.db.profile.Shamansearch
						end,
				set = function(info, newValue)
							GuildLeader.db.profile.Shamansearch = newValue
						end,
				order = 1,
			},	
				Warlocksearch = {
				type = 'toggle',
				name = "Warlock",
				desc = "Recruit Warlocks?",
				disabled = function(info)
				if GuildLeader.db.profile.automatewho==true or CanGuildInvite()~=true then 
				return true
				else
				return false
				end
				end,
				get = function(info)
							return GuildLeader.db.profile.Warlocksearch
						end,
				set = function(info, newValue)
							GuildLeader.db.profile.Warlocksearch = newValue
						end,
				order = 1,
			},	
				Warriorsearch = {
				type = 'toggle',
				name = "Warrior",
				desc = "Recruit Warriors?",
				disabled = function(info)
				if GuildLeader.db.profile.automatewho==true or CanGuildInvite()~=true then 
				return true
				else
				return false
				end
				end,
				get = function(info)
							return GuildLeader.db.profile.Warriorsearch
						end,
				set = function(info, newValue)
							GuildLeader.db.profile.Warriorsearch = newValue
						end,
				order = 1,
			},	
				},
			},
			},
			},
			invitecontrols = {
			type = 'group',
			childGroups = "tab",
			name = "Invitation Control",
			desc = "Do Not Invite List (Antispam Measure) and Member Cap Settings.",
			order = 3,
			args = {
			dnilcontrols = {
			type = 'execute',
			name = "Launch DNIL Controls?",
			desc = "WARNING: Over time the Do Not Invite List will get huge. If you MUST modify or purge the list be prepared for your UI to freeze for 30-60 seconds while the controls load.",
			confirm = true,
			func = 	function(info)
			GuildLeader:DNIUI()
				end,
			order = 1,
		},
			membercap = {
				type = 'range',
					width = "normal",
					name = "Member Maximum",
					desc = "Will stop recruiting if the guild population is at or above a certain threshold. If undefined it will assume 1000.",
					disabled = function(info)
				if CanGuildInvite()~=true then 
				return true
				else
				return false
				end
				end,
					min = 1,
					max = 1000,
					step = 1,
					get = function(info)
						return GuildLeader.db.profile.membercap
							end,
					set = function(info, newValue)
							GuildLeader.db.profile.membercap = newValue
							end,
					order = 2,
				},
			whohalt = {
			type = 'execute',
			name = "Stop!",
			desc = "Emergency button that halts a Character Recruitment Cycle",
			func = 	function(info)
			if WhoCycle==1 then
			GuildLeader:Print('Halting Character Recruitment Cycle')
			WhoHalt=1
			GuildLeader:CancelAllTimers()
			if GuildLeader.db.profile.automatewho==true then
			GuildLeader.db.profile.automatewho=false
			GuildLeader:Print('Disabling Character Recruitment Automation')
			end
			else
			GuildLeader:Print('Character Recruitment Cycle is NOT currently running')
			end
				end,
			order = 3,
		},
			welcomeannounce = {
					type = "select",
					order = 4,
					name = "Announce New Members",
					desc = "Choose to announce when a member is added to the guild",
					disabled = function(info)
				if CanGuildInvite()~=true then 
				return true
				else
				return false
				end
				end,
					values = {"None","Officer","Guild"},
					get = function(info)
						return GuildLeader.db.profile.welcomeannounce
							end,
					set = function(info, newValue)
							GuildLeader.db.profile.welcomeannounce = newValue
							end,
					},
			welcomewhisp = {
            type = 'input',
            multiline = true,
            width = "full",
            name = "Guild Welcome Whisper",
            desc = "The message text that will be sent to the new guild member. If you don't want to send a whisper, leave blank.",
            usage = "<Your message here>",
            disabled = function(info)
				if CanGuildInvite()~=true then 
				return true
				else
				return false
				end
				end,
            get = function(info)
						return GuildLeader.db.profile.welcomewhisp
					end,
            set = function(info, newValue)
						GuildLeader.db.profile.welcomewhisp = newValue
					end,
			order = 5,
        },
			declinewhisp = {
            type = 'input',
            multiline = true,
            width = "full",
            name = "Guild Invite Decline Whisper",
            desc = "The message text that will be sent to someone who declines your guild invitation. If you don't want to send a whisper, leave blank.",
            usage = "<Your message here>",
            disabled = function(info)
				if CanGuildInvite()~=true then 
				return true
				else
				return false
				end
				end,
            get = function(info)
						return GuildLeader.db.profile.declinewhisp
					end,
            set = function(info, newValue)
						GuildLeader.db.profile.declinewhisp = newValue
					end,
			order = 6,
        },
			whisperinvite = {
				type = 'toggle',
				name = "Invite on Whisper",
				desc = 'Will Invite players to your guild who say "LF Guild" in a whisper message. (whisper is not case-sensetive) WARNING: Cannot be used with Whisper Only! NOTE: Be sure to include this in your Zone Message, Recruitment Message, and/or AFK/DND message so that applicants know what to say! Will NOT invite players on the Black List!',
				disabled = function(info)
				if CanGuildInvite()~=true or GuildLeader.db.profile.whisperonly then 
				return true
				else
				return false
				end
				end,
				get = function(info)
							return GuildLeader.db.profile.whisperinvite
						end,
				set = function(info, newValue)
							GuildLeader.db.profile.whisperinvite = newValue
						end,
				order = 7,
				},
			whisperonly = {
				type = 'toggle',
				name = "Whisper Only",
				desc = 'This will cause only a whisper to go out instead of a whisper and a guild invite. WARNING: Cannot be used with Invite on Whisper! NOTE: There is an issue where guilded members show up in the Who list as not guilded. Using this feature will result in guilded players getting your invite message.',
				disabled = function(info)
				if CanGuildInvite()~=true or GuildLeader.db.profile.whisperinvite then 
				return true
				else
				return false
				end
				end,
				get = function(info)
							return GuildLeader.db.profile.whisperonly
						end,
				set = function(info, newValue)
							GuildLeader.db.profile.whisperonly = newValue
						end,
				order = 8,
				},
			},
			},
			
		},
		},
		pruning = {
			type = 'group',
			childGroups = "tab",
			name = "Pruning",
			desc = "Guild Pruning Settings",
			order = 3,
			args = {
				manprune = {
				type = 'execute',
			name = "Prune",
			desc = "Manually remove players from your guild",
			func = 	function(info) 
					GuildLeader:GKRun()
					end,
			order = 1,
			disabled = function(info)
								if GuildLeader.db.profile.automateprune then return true end
								return false
							end,
				},
				removeinactive = {
				type = 'toggle',
				name = "Remove Inactive",
				desc = "Remove members based on inactivity",
				get = function(info)
							return GuildLeader.db.profile.removeinactive
						end,
				set = function(info, newValue)
							GuildLeader.db.profile.removeinactive = newValue
						end,
				order = 2,
				},
				removelevels = {
				type = 'toggle',
				name = "Remove Low Levels",
				desc = "Remove Low Level Members",
				get = function(info)
							return GuildLeader.db.profile.removelevels
						end,
				set = function(info, newValue)
							GuildLeader.db.profile.removelevels = newValue
						end,
				order = 3,
				},
				automateprune = {
				type = 'toggle',
				name = "Automate",
				desc = "Prune members automatically & continuously",
				get = function(info)
							return GuildLeader.db.profile.automateprune
						end,
				set = function(info, newValue)
							GuildLeader.db.profile.automateprune = newValue
						end,
				order = 4,
				},
				daysinactive = {
				type = 'range',
					width = "normal",
					name = "Days Offline",
					desc = "Inactivity Threshold",
					min = 1,
					max = 365,
					step = 1,
					disabled = function(info)
								if GuildLeader.db.profile.removeinactive then return false end
								return true
							end,
					get = function(info)
						return GuildLeader.db.profile.daysinactive
							end,
					set = function(info, newValue)
							GuildLeader.db.profile.daysinactive = newValue
							end,
					order = 5,
				},
				levelthreshold = {
				type = 'range',
					width = "normal",
					name = "Low Level",
					desc = "Low Level Threshhold. Members at or below this level will be removed.",
					min = 1,
					max = 60,
					step = 1,
					disabled = function(info)
								if GuildLeader.db.profile.removelevels then return false end
								return true
							end,
					get = function(info)
						return GuildLeader.db.profile.levelthreshold
							end,
					set = function(info, newValue)
							GuildLeader.db.profile.levelthreshold = newValue
							end,
					order = 6,
				 },
				pruneannounce = {
					type = "select",
					order = 7,
					name = "Announce Prunes",
					desc = "Choose to announce why members were removed from the guild.",
					values = {"None","Officer","Guild"},
					get = function(info)
						return GuildLeader.db.profile.pruneannounce
							end,
					set = function(info, newValue)
							GuildLeader.db.profile.pruneannounce = newValue
							end,
					},
				blackcontrols = {
			type = 'execute',
			name = "Launch Black List Controls?",
			desc = "WARNING: Over time the Black List can get huge. If you MUST modify or purge the list be prepared for your UI to freeze for 30-60 seconds while the controls load.",
			confirm = true,
			func = 	function(info)
			GuildLeader:BlackUI()
				end,
			order = 8,
		},
				pruneexemptcontrols = {
			type = 'execute',
			name = "Launch Prune Exempt Controls?",
			desc = "WARNING: Over time the Prune Exemption List can get huge. If you MUST modify or purge the list be prepared for your UI to freeze for 30-60 seconds while the controls load.",
			confirm = true,
			func = 	function(info)
			GuildLeader:PruneExemptUI()
				end,
			order = 9,
		},
				exemptalt = {
				type = 'toggle',
				name = "Alts Exempt",
				desc = "Exempts Alts from pruning. MUST HAVE THE WORD 'ALT' in either their public or private note!",
				get = function(info)
							return GuildLeader.db.profile.exemptalt
						end,
				set = function(info, newValue)
							GuildLeader.db.profile.exemptalt = newValue
						end,
				order = 10,
				},
				exemptranks = {
				type = 'toggle',
				name = "Exempt Ranks",
				desc = "Exempts selected Ranks from pruning",
				get = function(info)
							return GuildLeader.db.profile.exemptranks
						end,
				set = function(info, newValue)
							GuildLeader.db.profile.exemptranks = newValue
						end,
				order = 11,
				},
				removefromdnil = {
				type = 'toggle',
				name = "Remove from DNIL",
				desc = "Removes a kicked player from the Do Not Invite List so that they may be reinvited in future should they meet your recruitment criteria.",
				get = function(info)
							return GuildLeader.db.profile.removefromdnil
						end,
				set = function(info, newValue)
							GuildLeader.db.profile.removefromdnil = newValue
						end,
				order = 11,
				},
				ranktable = {
					type = 'group',
					childGroups = "tab",
					name = "Rank Exemption List",
					desc = "List of ranks exempt from pruning.",
					order = 12,
					disabled = function(info)
								if GuildLeader.db.profile.exemptranks then return false end
								return true
							end,
					args = {
						exemptrank1 = {
							type = 'toggle',
							name = function(info)
									if GuildControlGetRankName(2)==nil then return "Rank 2" end
									return GuildControlGetRankName(2)
									end,
							desc = "Exempt this rank from pruning?",
							hidden = function(info)
									if GuildControlGetNumRanks()<=1 then 
									GuildLeader.db.profile.exemptrank1=false
									return true end
									return false
									end,
							get = function(info)
										return GuildLeader.db.profile.exemptrank1
									end,
							set = function(info, newValue)
										GuildLeader.db.profile.exemptrank1 = newValue
									end,
							order = 1,
						},
						exemptrank2 = {
						type = 'toggle',
							name = function(info)
									if GuildControlGetRankName(3)==nil then return "Rank 3" end
									return GuildControlGetRankName(3)
									end,
							desc = "Exempt this rank from pruning?",
							hidden = function(info)
									if GuildControlGetNumRanks()<=2 then 
									GuildLeader.db.profile.exemptrank2=false
									return true end
									return false
									end,
							get = function(info)
										return GuildLeader.db.profile.exemptrank2
									end,
							set = function(info, newValue)
										GuildLeader.db.profile.exemptrank2 = newValue
									end,
							order = 2,
						},
						exemptrank3 = {
						type = 'toggle',
							name = function(info)
									if GuildControlGetRankName(4)==nil then return "Rank 4" end
									return GuildControlGetRankName(4)
									end,
							desc = "Exempt this rank from pruning?",
							hidden = function(info)
									if GuildControlGetNumRanks()<=3 then 
									GuildLeader.db.profile.exemptrank3=false
									return true end
									return false
									end,
							get = function(info)
										return GuildLeader.db.profile.exemptrank3
									end,
							set = function(info, newValue)
										GuildLeader.db.profile.exemptrank3 = newValue
									end,
							order = 3,
						},
						exemptrank4 = {
						type = 'toggle',
							name = function(info)
									if GuildControlGetRankName(5)==nil then return "Rank 5" end
									return GuildControlGetRankName(5)
									end,
							desc = "Exempt this rank from pruning?",
							hidden = function(info)
									if GuildControlGetNumRanks()<=4 then 
									GuildLeader.db.profile.exemptrank4=false
									return true end
									return false
									end,
							get = function(info)
										return GuildLeader.db.profile.exemptrank4
									end,
							set = function(info, newValue)
										GuildLeader.db.profile.exemptrank4 = newValue
									end,
							order = 4,
						},
						exemptrank5 = {
						type = 'toggle',
							name = function(info)
									if GuildControlGetRankName(6)==nil then return "Rank 6" end
									return GuildControlGetRankName(6)
									end,
							desc = "Exempt this rank from pruning?",
							hidden = function(info)
									if GuildControlGetNumRanks()<=5 then 
									GuildLeader.db.profile.exemptrank5=false
									return true end
									return false
									end,
							get = function(info)
										return GuildLeader.db.profile.exemptrank5
									end,
							set = function(info, newValue)
										GuildLeader.db.profile.exemptrank5 = newValue
									end,
							order = 5,
						},
						exemptrank6 = {
						type = 'toggle',
							name = function(info)
									if GuildControlGetRankName(7)==nil then return "Rank 7" end
									return GuildControlGetRankName(7)
									end,
							desc = "Exempt this rank from pruning?",
							hidden = function(info)
									if GuildControlGetNumRanks()<=6 then 
									GuildLeader.db.profile.exemptrank6=false
									return true end
									return false
									end,
							get = function(info)
										return GuildLeader.db.profile.exemptrank6
									end,
							set = function(info, newValue)
										GuildLeader.db.profile.exemptrank6 = newValue
									end,
							order = 6,
						},
						exemptrank7 = {
						type = 'toggle',
							name = function(info)
									if GuildControlGetRankName(8)==nil then return "Rank 8" end
									return GuildControlGetRankName(8)
									end,
							desc = "Exempt this rank from pruning?",
							hidden = function(info)
									if GuildControlGetNumRanks()<=7 then 
									GuildLeader.db.profile.exemptrank7=false
									return true end
									return false
									end,
							get = function(info)
										return GuildLeader.db.profile.exemptrank7
									end,
							set = function(info, newValue)
										GuildLeader.db.profile.exemptrank7 = newValue
									end,
							order = 7,
						},
						exemptrank8 = {
						type = 'toggle',
							name = function(info)
									if GuildControlGetRankName(9)==nil then return "Rank 9" end
									return GuildControlGetRankName(9)
									end,
							desc = "Exempt this rank from pruning?",
							hidden = function(info)
									if GuildControlGetNumRanks()<=8 then 
									GuildLeader.db.profile.exemptrank8=false
									return true end
									return false
									end,
							get = function(info)
										return GuildLeader.db.profile.exemptrank8
									end,
							set = function(info, newValue)
										GuildLeader.db.profile.exemptrank8 = newValue
									end,
							order = 8,
						},
						exemptrank9 = {
						type = 'toggle',
							name = function(info)
									if GuildControlGetRankName(10)==nil then return "Rank 10" end
									return GuildControlGetRankName(10)
									end,
							desc = "Exempt this rank from pruning?",
							hidden = function(info)
									if GuildControlGetNumRanks()<=9 then 
									GuildLeader.db.profile.exemptrank9=false
									return true end
									return false
									end,
							get = function(info)
										return GuildLeader.db.profile.exemptrank9
									end,
							set = function(info, newValue)
										GuildLeader.db.profile.exemptrank9 = newValue
									end,
							order = 9,
						},
						},
					},
				
		},
		},
		promotion = {
			type = 'group',
			name = "Promotion",
			desc = "Guild Promotion Settings",
			order = 4,
			args = {
			manpromote = {
				type = 'execute',
			name = "Run Promotions",
			desc = "Manually runs the promoter WARNING: Whenever you move, add, or delete ranks be sure to update your promote settings! Not doing so may have unintended side effects!",
			order = 1,
			confirm = true,
			func = 	function(info) 
					GuildLeader:GLPromoteErrorChecking()
					end,
			disabled = function(info)
								if GuildLeader.db.profile.automatepromote then return true end
								return false
							end,
				},
			automatepromote = {
			type = 'toggle',
			name = "Automate",
			confirm = true,
			desc = "Will automatically and continously promote members who meet the specificed standards. WARNING: Whenever you move, add, or delete ranks be sure to update your promote settings! Not doing so may have unintended side effects!",
			get = function(info)
					return GuildLeader.db.profile.automatepromote
				end,
			set = function(info, newValue)
					GuildLeader.db.profile.automatepromote = newValue
				end,
			order = 2,
			},
			demotemode = {
			type = 'toggle',
			name = "Demote Mode",
			desc = "Demotes members who no longer qualify for the rank they hold based on the below settings.",
			get = function(info)
					return GuildLeader.db.profile.demotemode
				end,
			set = function(info, newValue)
					GuildLeader.db.profile.demotemode = newValue
				end,
			order = 3,
			},
			promoteannounce = {
					type = "select",
					order = 4,
					name = "Announce Promotions/Demotions",
					desc = "Choose to announce why members were promoted or demoted. Will also state how one can become promoted.",
					values = {"None","Officer","Guild"},
					get = function(info)
						return GuildLeader.db.profile.promoteannounce
							end,
					set = function(info, newValue)
							GuildLeader.db.profile.promoteannounce = newValue
							end,
					},		
			rankpromotesearch = {
			type = 'group',
			name = "Promote From Ranks",
			desc = "Ranks that Guild Promoter will look at when finding qualified candidates",
			order = 6,
			args = {
				rank1promotesearch = {
			type = 'toggle',
			name = function(info)
					if GuildControlGetRankName(2)==nil then return "Rank 2" end
					return GuildControlGetRankName(2)
					end,
			desc = "Toggles this rank as a rank that promoter will promote FROM.",
			hidden = function(info)
									if GuildControlGetNumRanks()<=1 then 
									GuildLeader.db.profile.rank1promotesearch=false
									return true end
									return false
									end,
			get = function(info)
					return GuildLeader.db.profile.rank1promotesearch
				end,
			set = function(info, newValue)
					GuildLeader.db.profile.rank1promotesearch = newValue
				end,
			order = 1,
			},
				rank2promotesearch = {
			type = 'toggle',
			name = function(info)
					if GuildControlGetRankName(3)==nil then return "Rank 3" end
					return GuildControlGetRankName(3)
					end,
			desc = "Toggles this rank as a rank that promoter will promote FROM.",
			hidden = function(info)
									if GuildControlGetNumRanks()<=2 then 
									GuildLeader.db.profile.rank2promotesearch=false
									return true end
									return false
									end,
			get = function(info)
					return GuildLeader.db.profile.rank2promotesearch
				end,
			set = function(info, newValue)
					GuildLeader.db.profile.rank2promotesearch = newValue
				end,
			order = 2,
			},
				rank3promotesearch = {
			type = 'toggle',
			name = function(info)
					if GuildControlGetRankName(4)==nil then return "Rank 4" end
					return GuildControlGetRankName(4)
					end,
			desc = "Toggles this rank as a rank that promoter will promote FROM.",
			hidden = function(info)
									if GuildControlGetNumRanks()<=3 then 
									GuildLeader.db.profile.rank3promotesearch=false
									return true end
									return false
									end,
			get = function(info)
					return GuildLeader.db.profile.rank3promotesearch
				end,
			set = function(info, newValue)
					GuildLeader.db.profile.rank3promotesearch = newValue
				end,
			order = 3,
			},
				rank4promotesearch = {
			type = 'toggle',
			name = function(info)
					if GuildControlGetRankName(5)==nil then return "Rank 5" end
					return GuildControlGetRankName(5)
					end,
			desc = "Toggles this rank as a rank that promoter will promote FROM.",
			hidden = function(info)
									if GuildControlGetNumRanks()<=4 then 
									GuildLeader.db.profile.rank4promotesearch=false
									return true end
									return false
									end,
			get = function(info)
					return GuildLeader.db.profile.rank4promotesearch
				end,
			set = function(info, newValue)
					GuildLeader.db.profile.rank4promotesearch = newValue
				end,
			order = 4,
			},
				rank5promotesearch = {
			type = 'toggle',
			name = function(info)
					if GuildControlGetRankName(6)==nil then return "Rank 6" end
					return GuildControlGetRankName(6)
					end,
			desc = "Toggles this rank as a rank that promoter will promote FROM.",
			hidden = function(info)
									if GuildControlGetNumRanks()<=5 then 
									GuildLeader.db.profile.rank5promotesearch=false
									return true end
									return false
									end,
			get = function(info)
					return GuildLeader.db.profile.rank5promotesearch
				end,
			set = function(info, newValue)
					GuildLeader.db.profile.rank5promotesearch = newValue
				end,
			order = 5,
			},
				rank6promotesearch = {
			type = 'toggle',
			name = function(info)
					if GuildControlGetRankName(7)==nil then return "Rank 7" end
					return GuildControlGetRankName(7)
					end,
			desc = "Toggles this rank as a rank that promoter will promote FROM.",
			hidden = function(info)
									if GuildControlGetNumRanks()<=6 then 
									GuildLeader.db.profile.rank6promotesearch=false
									return true end
									return false
									end,
			get = function(info)
					return GuildLeader.db.profile.rank6promotesearch
				end,
			set = function(info, newValue)
					GuildLeader.db.profile.rank6promotesearch = newValue
				end,
			order = 6,
			},
				rank7promotesearch = {
			type = 'toggle',
			name = function(info)
					if GuildControlGetRankName(8)==nil then return "Rank 8" end
					return GuildControlGetRankName(8)
					end,
			desc = "Toggles this rank as a rank that promoter will promote FROM.",
			hidden = function(info)
									if GuildControlGetNumRanks()<=7 then 
									GuildLeader.db.profile.rank7promotesearch=false
									return true end
									return false
									end,
			get = function(info)
					return GuildLeader.db.profile.rank7promotesearch
				end,
			set = function(info, newValue)
					GuildLeader.db.profile.rank7promotesearch = newValue
				end,
			order = 7,
			},
				rank8promotesearch = {
			type = 'toggle',
			name = function(info)
					if GuildControlGetRankName(9)==nil then return "Rank 9" end
					return GuildControlGetRankName(9)
					end,
			desc = "Toggles this rank as a rank that promoter will promote FROM.",
			hidden = function(info)
									if GuildControlGetNumRanks()<=8 then 
									GuildLeader.db.profile.rank8promotesearch=false
									return true end
									return false
									end,
			get = function(info)
					return GuildLeader.db.profile.rank8promotesearch
				end,
			set = function(info, newValue)
					GuildLeader.db.profile.rank8promotesearch = newValue
				end,
			order = 8,
			},
				rank9promotesearch = {
			type = 'toggle',
			name = function(info)
					if GuildControlGetRankName(10)==nil then return "Rank 10" end
					return GuildControlGetRankName(10)
					end,
			desc = "Toggles this rank as a rank that promoter will promote FROM.",
			hidden = function(info)
									if GuildControlGetNumRanks()<=9 then 
									GuildLeader.db.profile.rank9promotesearch=false
									return true end
									return false
									end,
			get = function(info)
					return GuildLeader.db.profile.rank9promotesearch
				end,
			set = function(info, newValue)
					GuildLeader.db.profile.rank9promotesearch = newValue
				end,
			order = 9,
			},
					},
				},
			rankpromoteplacelevel = {
			type = 'group',
			name = "Promote To By Level",
			desc = "Ranks that Guild Promoter will look at when placing qualified candidates",
			order = 8,
			args = {
				rank1promote = {
			type = 'toggle',
			name = function(info)
					if GuildControlGetRankName(2)==nil then return "Rank 2" end
					return GuildControlGetRankName(2)
					end,
			desc = "Toggles this rank as a rank that promoter will promote TO.",
			hidden = function(info)
									if GuildControlGetNumRanks()<=2 then 
									GuildLeader.db.profile.rank1promote=false
									return true end
									return false
									end,
			get = function(info)
					return GuildLeader.db.profile.rank1promote
				end,
			set = function(info, newValue)
					GuildLeader.db.profile.rank1promote = newValue
				end,
			order = 3,
			},
				rank1level = {
				type = 'range',
					width = "normal",
					max = 60,
					min = 1,
					name = strjoin(" ",GuildControlGetRankName(2),"Level Threshold"),
					desc = strjoin(" ","Input for",GuildControlGetRankName(2),"Level Threshold"),
					step = 1,
					disabled = function(info)
								if GuildLeader.db.profile.rank1promote then return false end
								return true
							end,
					hidden = function(info)
									if GuildControlGetNumRanks()<=2 then 
									GuildLeader.db.profile.rank1level=60
									return true end
									return false
									end,
					get = function(info)
						return GuildLeader.db.profile.rank1level
							end,
					set = function(info, newValue)
							GuildLeader.db.profile.rank1level = newValue
							end,
					order = 4,
				},
				rank2promote = {
			type = 'toggle',
			name = function(info)
					if GuildControlGetRankName(3)==nil then return "Rank 3" end
					return GuildControlGetRankName(3)
					end,
			desc = "Toggles this rank as a rank that promoter will promote TO.",
			hidden = function(info)
									if GuildControlGetNumRanks()<=3 then 
									GuildLeader.db.profile.rank2promote=false
									return true end
									return false
									end,
			get = function(info)
					return GuildLeader.db.profile.rank2promote
				end,
			set = function(info, newValue)
					GuildLeader.db.profile.rank2promote = newValue
				end,
			order = 5,
			},
				rank2level = {
				type = 'range',
					width = "normal",
					max = 60,
					min = 1,
					name = strjoin(" ",GuildControlGetRankName(3),"Level Threshold"),
					desc = strjoin(" ","Input for",GuildControlGetRankName(3),"Level Threshold"),
					step = 1,
					disabled = function(info)
								if GuildLeader.db.profile.rank2promote then return false end
								return true
							end,
					hidden = function(info)
									if GuildControlGetNumRanks()<=3 then 
									GuildLeader.db.profile.rank2level=60
									return true end
									return false
									end,
					get = function(info)
						return GuildLeader.db.profile.rank2level
							end,
					set = function(info, newValue)
							GuildLeader.db.profile.rank2level = newValue
							end,
					order = 6,
				},
				rank3promote = {
			type = 'toggle',
			name = function(info)
					if GuildControlGetRankName(4)==nil then return "Rank 4" end
					return GuildControlGetRankName(4)
					end,
			desc = "Toggles this rank as a rank that promoter will promote TO.",
			hidden = function(info)
									if GuildControlGetNumRanks()<=4 then 
									GuildLeader.db.profile.rank3promote=false
									return true end
									return false
									end,
			get = function(info)
					return GuildLeader.db.profile.rank3promote
				end,
			set = function(info, newValue)
					GuildLeader.db.profile.rank3promote = newValue
				end,
			order = 7,
			},
				rank3level = {
				type = 'range',
					width = "normal",
					max = 60,
					min = 1,
					name = strjoin(" ",GuildControlGetRankName(4),"Level Threshold"),
					desc = strjoin(" ","Input for",GuildControlGetRankName(4),"Level Threshold"),
					step = 1,
					disabled = function(info)
								if GuildLeader.db.profile.rank3promote then return false end
								return true
							end,
					hidden = function(info)
									if GuildControlGetNumRanks()<=4 then 
									GuildLeader.db.profile.rank3level=60
									return true end
									return false
									end,
					get = function(info)
						return GuildLeader.db.profile.rank3level
							end,
					set = function(info, newValue)
							GuildLeader.db.profile.rank3level = newValue
							end,
					order = 8,
				},
				rank4promote = {
			type = 'toggle',
			name = function(info)
					if GuildControlGetRankName(5)==nil then return "Rank 5" end
					return GuildControlGetRankName(5)
					end,
			desc = "Toggles this rank as a rank that promoter will promote TO.",
			hidden = function(info)
									if GuildControlGetNumRanks()<=5 then 
									GuildLeader.db.profile.rank4promote=false
									return true end
									return false
									end,
			get = function(info)
					return GuildLeader.db.profile.rank4promote
				end,
			set = function(info, newValue)
					GuildLeader.db.profile.rank4promote = newValue
				end,
			order = 9,
			},
				rank4level = {
				type = 'range',
					width = "normal",
					max = 60,
					min = 1,
					name = strjoin(" ",GuildControlGetRankName(5),"Level Threshold"),
					desc = strjoin(" ","Input for",GuildControlGetRankName(5),"Level Threshold"),
					step = 1,
					disabled = function(info)
								if GuildLeader.db.profile.rank4promote then return false end
								return true
							end,
					hidden = function(info)
									if GuildControlGetNumRanks()<=5 then 
									GuildLeader.db.profile.rank4level=60
									return true end
									return false
									end,
					get = function(info)
						return GuildLeader.db.profile.rank4level
							end,
					set = function(info, newValue)
							GuildLeader.db.profile.rank4level = newValue
							end,
					order = 10,
				},
				rank5promote = {
			type = 'toggle',
			name = function(info)
					if GuildControlGetRankName(6)==nil then return "Rank 6" end
					return GuildControlGetRankName(6)
					end,
			desc = "Toggles this rank as a rank that promoter will promote TO.",
			hidden = function(info)
									if GuildControlGetNumRanks()<=6 then 
									GuildLeader.db.profile.rank5promote=false
									return true end
									return false
									end,
			get = function(info)
					return GuildLeader.db.profile.rank5promote
				end,
			set = function(info, newValue)
					GuildLeader.db.profile.rank5promote = newValue
				end,
			order = 11,
			},
				rank5level = {
				type = 'range',
					width = "normal",
					max = 60,
					min = 1,
					name = strjoin(" ",GuildControlGetRankName(6),"Level Threshold"),
					desc = strjoin(" ","Input for",GuildControlGetRankName(6),"Level Threshold"),
					step = 1,
					disabled = function(info)
								if GuildLeader.db.profile.rank5promote then return false end
								return true
							end,
					hidden = function(info)
									if GuildControlGetNumRanks()<=6 then 
									GuildLeader.db.profile.rank5level=60
									return true end
									return false
									end,
					get = function(info)
						return GuildLeader.db.profile.rank5level
							end,
					set = function(info, newValue)
							GuildLeader.db.profile.rank5level = newValue
							end,
					order = 12,
				},
				rank6promote = {
			type = 'toggle',
			name = function(info)
					if GuildControlGetRankName(7)==nil then return "Rank 7" end
					return GuildControlGetRankName(7)
					end,
			desc = "Toggles this rank as a rank that promoter will promote TO.",
			hidden = function(info)
									if GuildControlGetNumRanks()<=7 then 
									GuildLeader.db.profile.rank6promote=false
									return true end
									return false
									end,
			get = function(info)
					return GuildLeader.db.profile.rank6promote
				end,
			set = function(info, newValue)
					GuildLeader.db.profile.rank6promote = newValue
				end,
			order = 13,
			},
				rank6level = {
				type = 'range',
					width = "normal",
					max = 60,
					min = 1,
					name = strjoin(" ",GuildControlGetRankName(7),"Level Threshold"),
					desc = strjoin(" ","Input for",GuildControlGetRankName(7),"Level Threshold"),
					step = 1,
					disabled = function(info)
								if GuildLeader.db.profile.rank6promote then return false end
								return true
							end,
					hidden = function(info)
									if GuildControlGetNumRanks()<=7 then 
									GuildLeader.db.profile.rank6level=60
									return true end
									return false
									end,
					get = function(info)
						return GuildLeader.db.profile.rank6level
							end,
					set = function(info, newValue)
							GuildLeader.db.profile.rank6level = newValue
							end,
					order = 14,
				},
				rank7promote = {
			type = 'toggle',
			name = function(info)
					if GuildControlGetRankName(8)==nil then return "Rank 8" end
					return GuildControlGetRankName(8)
					end,
			desc = "Toggles this rank as a rank that promoter will promote TO.",
			hidden = function(info)
									if GuildControlGetNumRanks()<=8 then 
									GuildLeader.db.profile.rank7promote=false
									return true end
									return false
									end,
			get = function(info)
					return GuildLeader.db.profile.rank7promote
				end,
			set = function(info, newValue)
					GuildLeader.db.profile.rank7promote = newValue
				end,
			order = 15,
			},
				rank7level = {
				type = 'range',
					width = "normal",
					max = 60,
					min = 1,
					name = strjoin(" ",GuildControlGetRankName(8),"Level Threshold"),
					desc = strjoin(" ","Input for",GuildControlGetRankName(8),"Level Threshold"),
					step = 1,
					disabled = function(info)
								if GuildLeader.db.profile.rank7promote then return false end
								return true
							end,
					hidden = function(info)
									if GuildControlGetNumRanks()<=8 then 
									GuildLeader.db.profile.rank7level=60
									return true end
									return false
									end,
					get = function(info)
						return GuildLeader.db.profile.rank7level
							end,
					set = function(info, newValue)
							GuildLeader.db.profile.rank7level = newValue
							end,
					order = 16,
				},
				rank8promote = {
			type = 'toggle',
			name = function(info)
					if GuildControlGetRankName(9)==nil then return "Rank 9" end
					return GuildControlGetRankName(9)
					end,
			desc = "Toggles this rank as a rank that promoter will promote TO.",
			hidden = function(info)
									if GuildControlGetNumRanks()<=9 then 
									GuildLeader.db.profile.rank8promote=false
									return true end
									return false
									end,
			get = function(info)
					return GuildLeader.db.profile.rank8promote
				end,
			set = function(info, newValue)
					GuildLeader.db.profile.rank8promote = newValue
				end,
			order = 17,
			},
				rank8level = {
				type = 'range',
					max = 60,
					min = 1,
					name = strjoin(" ",GuildControlGetRankName(9),"Level Threshold"),
					desc = strjoin(" ","Input for",GuildControlGetRankName(9),"Level Threshold"),
					step = 1,
					disabled = function(info)
								if GuildLeader.db.profile.rank8promote then return false end
								return true
							end,
					hidden = function(info)
									if GuildControlGetNumRanks()<=9 then 
									GuildLeader.db.profile.rank8level=60
									return true end
									return false
									end,
					get = function(info)
						return GuildLeader.db.profile.rank8level
							end,
					set = function(info, newValue)
							GuildLeader.db.profile.rank8level = newValue
							end,
					order = 18,
				},
					},
				},	
			demoteexemptlist = {
					type = 'group',
					childGroups = "tab",
					name = "Player Exemption List",
					desc = "List of players who are exempt from demotion.",
					order = 9,
					disabled = function(info)
								if GuildLeader.db.profile.demotemode then return false end
								return true
							end,
					args = {
					demoteexemptcontrols = {
			type = 'execute',
			name = "Launch Demote Exempt Controls?",
			desc = "WARNING: Over time the Demote Exemption List can get huge. If you MUST modify or purge the list be prepared for your UI to freeze for 30-60 seconds while the controls load.",
			confirm = true,
			func = 	function(info)
			GuildLeader:DemoteExemptUI()
				end,
			order = 11,
		},
					},
					},
			
			},
		},
		announcments = {
			type = 'group',
			name = "Announcements",
			desc = "Guild Announcment Settings",
			order = 5,
			args = {
				annoucementstats= {
					type = 'execute',
					name = "Annoucement Stats",
					desc = "Prints which message was spammed last and when it was spammed.",
					func = 	function()
					if ValidMessages==1 then
					GuildLeader:Print(strjoin(" ","A Guild Annoucnement was made",(GuildLeader:GetTime()-GuildLeader.db.profile.lastanntime),"minutes ago. Guild Announcement",GuildLeader.db.profile.announcenext,"is due to print in",(GuildLeader.db.profile.lastanntime+GuildLeader.db.profile.nextannouncetime)-GuildLeader:GetTime(),"minutes."))
					else
					GuildLeader:Print("There Are No Valid Messages!")
					end
							end,
			order = 1,
		},
				annoucementskip= {
					type = 'execute',
					name = "Skip Announcement",
					desc = "Skips the next upcoming announcement and loads the one after that.",
					func = 	function()
					if ValidMessages==1 then
					GuildLeader:Print(strjoin(" ","Skipping Guild Announcement",GuildLeader.db.profile.announcenext))
					announcementskip=1
					GuildLeader:LoadNextAnnouncement()
					announcementskip=0
					GuildLeader:Print(strjoin(" ","Guild Announcement",GuildLeader.db.profile.announcenext,"Loaded"))
					else 
					GuildLeader:Print("There Are No Valid Messages!")
					end
					end,
			order = 2,
		},
				announcmentoverride = {
					type = 'execute',
					name = "Announce Now",
					desc = "Overrides the timer and broadcasts the next upcoming announcment.",
					func = 	function()
					if ValidMessages==1 then
					GuildLeader:ExecuteAnnouncement()
					else
					GuildLeader:Print("There Are No Valid Messages!")
					end
					end,
			order = 3,
		},
				announcement1 = {
            type = 'input',
            multiline = true,
            width = "full",
            name = "Announcement 1",
            desc = "The message text that will be broadcast in Guild/Officer",
            usage = "<Your message here>",
            get = function(info)
						return GuildLeader.db.profile.announcement1
					end,
            set = function(info, newValue)
						GuildLeader.db.profile.announcement1 = newValue
					end,
			order = 4,
        },
				announcementtimer1 = {
					type = 'range',
					name = "Annoucement 1 Timer",
					desc = "Set the amount of time between the PREVIOUS message and THIS message.",
					min = 1,
					max = 60,
					step = 1,
					get = function(info)
						return GuildLeader.db.profile.announcementtimer1
							end,
					set = function(info, newValue)
							GuildLeader.db.profile.announcementtimer1 = newValue
							end,
					order = 5,
				},
				announcementto1 = {
					type = "select",
					order = 6,
					name = "Announce to Officer/Guild 1",
					desc = "Choose which channel to make this announcement in OR disable it.",
					values = {"Disabled","Officer","Guild"},
					get = function(info)
						return GuildLeader.db.profile.announcementto1
							end,
					set = function(info, newValue)
							GuildLeader.db.profile.announcementto1 = newValue
							end,
					},
				announcementborder1 = {
					type = "select",
					order = 7,
					name = "Announce Border 1",
					desc = "Border style to wrap around the annoucnement. Great for annoucnements that exceed the single message character limit.",
					values = {"None","Star","Cricle","Diamond","Triangle","Moon","Square","Cross","Skull"},
					get = function(info)
						return GuildLeader.db.profile.announcementborder1
							end,
					set = function(info, newValue)
							GuildLeader.db.profile.announcementborder1 = newValue
							end,
					},
				announcement2 = {
            type = 'input',
            multiline = true,
            width = "full",
            name = "Announcement 2",
            desc = "The message text that will be broadcast in Guild/Officer",
            usage = "<Your message here>",
            get = function(info)
						return GuildLeader.db.profile.announcement2
					end,
            set = function(info, newValue)
						GuildLeader.db.profile.announcement2 = newValue
					end,
			order = 8,
        },
				announcementtimer2 = {
					type = 'range',
					name = "Annoucement 2 Timer",
					desc = "Set the amount of time between the PREVIOUS message and THIS message.",
					min = 1,
					max = 60,
					step = 1,
					get = function(info)
						return GuildLeader.db.profile.announcementtimer2
							end,
					set = function(info, newValue)
							GuildLeader.db.profile.announcementtimer2 = newValue
							end,
					order = 9,
				},
				announcementto2 = {
					type = "select",
					order = 10,
					name = "Announce to Officer/Guild 2",
					desc = "Choose which channel to make this announcement in OR disable it.",
					values = {"Disabled","Officer","Guild"},
					get = function(info)
						return GuildLeader.db.profile.announcementto2
							end,
					set = function(info, newValue)
							GuildLeader.db.profile.announcementto2 = newValue
							end,
					},
				announcementborder2 = {
					type = "select",
					order = 11,
					name = "Announce Border 2",
					desc = "Border style to wrap around the annoucnement. Great for annoucnements that exceed the single message character limit.",
					values = {"None","Star","Cricle","Diamond","Triangle","Moon","Square","Cross","Skull"},
					get = function(info)
						return GuildLeader.db.profile.announcementborder2
							end,
					set = function(info, newValue)
							GuildLeader.db.profile.announcementborder2 = newValue
							end,
					},
				announcement3 = {
            type = 'input',
            multiline = true,
            width = "full",
            name = "Announcement 3",
            desc = "The message text that will be broadcast in Guild/Officer",
            usage = "<Your message here>",
            get = function(info)
						return GuildLeader.db.profile.announcement3
					end,
            set = function(info, newValue)
						GuildLeader.db.profile.announcement3 = newValue
					end,
			order = 12,
        },
				announcementtimer3 = {
					type = 'range',
					name = "Annoucement 3 Timer",
					desc = "Set the amount of time between the PREVIOUS message and THIS message.",
					min = 1,
					max = 60,
					step = 1,
					get = function(info)
						return GuildLeader.db.profile.announcementtimer3
							end,
					set = function(info, newValue)
							GuildLeader.db.profile.announcementtimer3 = newValue
							end,
					order = 13,
				},
				announcementto3 = {
					type = "select",
					order = 14,
					name = "Announce to Officer/Guild 3",
					desc = "Choose which channel to make this announcement in OR disable it.",
					values = {"Disabled","Officer","Guild"},
					get = function(info)
						return GuildLeader.db.profile.announcementto3
							end,
					set = function(info, newValue)
							GuildLeader.db.profile.announcementto3 = newValue
							end,
					},
				announcementborder3 = {
					type = "select",
					order = 15,
					name = "Announce Border 3",
					desc = "Border style to wrap around the annoucnement. Great for annoucnements that exceed the single message character limit.",
					values = {"None","Star","Cricle","Diamond","Triangle","Moon","Square","Cross","Skull"},
					get = function(info)
						return GuildLeader.db.profile.announcementborder3
							end,
					set = function(info, newValue)
							GuildLeader.db.profile.announcementborder3 = newValue
							end,
					},
				announcement4 = {
            type = 'input',
            multiline = true,
            width = "full",
            name = "Announcement 4",
            desc = "The message text that will be broadcast in Guild/Officer",
            usage = "<Your message here>",
            get = function(info)
						return GuildLeader.db.profile.announcement4
					end,
            set = function(info, newValue)
						GuildLeader.db.profile.announcement4 = newValue
					end,
			order = 16,
        },
				announcementtimer4 = {
					type = 'range',
					name = "Annoucement 4 Timer",
					desc = "Set the amount of time between the PREVIOUS message and THIS message.",
					min = 1,
					max = 60,
					step = 1,
					get = function(info)
						return GuildLeader.db.profile.announcementtimer4
							end,
					set = function(info, newValue)
							GuildLeader.db.profile.announcementtimer4 = newValue
							end,
					order = 17,
				},
				announcementto4 = {
					type = "select",
					order = 18,
					name = "Announce to Officer/Guild 4",
					desc = "Choose which channel to make this announcement in OR disable it.",
					values = {"Disabled","Officer","Guild"},
					get = function(info)
						return GuildLeader.db.profile.announcementto4
							end,
					set = function(info, newValue)
							GuildLeader.db.profile.announcementto4 = newValue
							end,
					},
				announcementborder4 = {
					type = "select",
					order = 19,
					name = "Announce Border 4",
					desc = "Border style to wrap around the annoucnement. Great for annoucnements that exceed the single message character limit.",
					values = {"None","Star","Cricle","Diamond","Triangle","Moon","Square","Cross","Skull"},
					get = function(info)
						return GuildLeader.db.profile.announcementborder4
							end,
					set = function(info, newValue)
							GuildLeader.db.profile.announcementborder4 = newValue
							end,
					},
				announcement5 = {
            type = 'input',
            multiline = true,
            width = "full",
            name = "Announcement 5",
            desc = "The message text that will be broadcast in Guild/Officer",
            usage = "<Your message here>",
            get = function(info)
						return GuildLeader.db.profile.announcement5
					end,
            set = function(info, newValue)
						GuildLeader.db.profile.announcement5 = newValue
					end,
			order = 20,
        },
				announcementtimer5 = {
					type = 'range',
					name = "Annoucement 5 Timer",
					desc = "Set the amount of time between the PREVIOUS message and THIS message.",
					min = 1,
					max = 60,
					step = 1,
					get = function(info)
						return GuildLeader.db.profile.announcementtimer5
							end,
					set = function(info, newValue)
							GuildLeader.db.profile.announcementtimer5 = newValue
							end,
					order = 21,
				},
				announcementto5 = {
					type = "select",
					order = 22,
					name = "Announce to Officer/Guild 5",
					desc = "Choose which channel to make this announcement in OR disable it.",
					values = {"Disabled","Officer","Guild"},
					get = function(info)
						return GuildLeader.db.profile.announcementto5
							end,
					set = function(info, newValue)
							GuildLeader.db.profile.announcementto5 = newValue
							end,
					},
				announcementborder5 = {
					type = "select",
					order = 23,
					name = "Announce Border 5",
					desc = "Border style to wrap around the annoucnement. Great for annoucnements that exceed the single message character limit.",
					values = {"None","Star","Cricle","Diamond","Triangle","Moon","Square","Cross","Skull"},
					get = function(info)
						return GuildLeader.db.profile.announcementborder5
							end,
					set = function(info, newValue)
							GuildLeader.db.profile.announcementborder5 = newValue
							end,
					},


				
		},
		},
	},
}

--Right Click Menu--
local EasyGInv = CreateFrame("Frame","EasyGInvFrame")
EasyGInv:SetScript("OnEvent", function() hooksecurefunc("UnitPopup_ShowMenu", EasyGInvCheck) end)
EasyGInv:RegisterEvent("PLAYER_LOGIN")

local PopupUnits = {"PARTY", "PLAYER", "RAID_PLAYER", "RAID", "FRIEND", "TEAM", "CHAT_ROSTER", "TARGET", "FOCUS", "GUILD", "GUILD_OFFLINE"}

local GInvButtonInfo = {
	text = "Invite To Guild",
	value = "EZ_GINV",
	func = function()
	if string.match(UIDROPDOWNMENU_OPEN_MENU.name, "-") then
	playerrealmname = UIDROPDOWNMENU_OPEN_MENU.name;
	else
	playerrealmname = strjoin("-",UIDROPDOWNMENU_OPEN_MENU.name,GetRealmName());
	end
	if CheckTable(GuildLeader.db.profile.GLDNIt, playerrealmname)==0 then
	table.insert(GuildLeader.db.profile.GLDNIt, playerrealmname)
	GLDNIt=GuildLeader.db.profile.GLDNIt
	pairsByKeysDNI(GLDNIt)
	end
	GuildInvite(playerrealmname)
	GuildLeader:Print(strjoin(" ",playerrealmname,"was invited and added to the Do Not Invite List!"))
	end,
	notCheckable = 1,
}

local DNILaddButtonInfo = {
	text = "Add to DNIL",
	value = "EZ_DNIL",
	func = function()
	if string.match(UIDROPDOWNMENU_OPEN_MENU.name, "-") then
	playerrealmname = UIDROPDOWNMENU_OPEN_MENU.name;
	else
	playerrealmname = strjoin("-",UIDROPDOWNMENU_OPEN_MENU.name,GetRealmName());
	end
	table.insert(GuildLeader.db.profile.GLDNIt, playerrealmname)
	GLDNIt=GuildLeader.db.profile.GLDNIt
	pairsByKeysDNI(GLDNIt)
	GuildLeader:Print(strjoin(" ",playerrealmname,"was added to the Do Not Invite List!"))
	end,
	notCheckable = 1,
}

local DNILremoveButtonInfo = {
	text = "Remove from DNIL",
	value = "EZ_DNILREM",
	func = function()
	if string.match(UIDROPDOWNMENU_OPEN_MENU.name, "-") then
	playerrealmname = UIDROPDOWNMENU_OPEN_MENU.name;
	else
	playerrealmname = strjoin("-",UIDROPDOWNMENU_OPEN_MENU.name,GetRealmName());
	end
	indexValue=CheckTable(GuildLeader.db.profile.GLDNIt, playerrealmname)
	RemoveTableValue(GuildLeader.db.profile.GLDNIt, indexValue)
	GuildLeader:Print(strjoin(" ",playerrealmname,"was removed from the Do Not Invite List!"))
	end,
	notCheckable = 1,
}

local BlackaddButtonInfo = {
	text = "Add to Black List",
	value = "EZ_BLACK",
	func = function()
	if string.match(UIDROPDOWNMENU_OPEN_MENU.name, "-") then
	playerrealmname = UIDROPDOWNMENU_OPEN_MENU.name;
	else
	playerrealmname = strjoin("-",UIDROPDOWNMENU_OPEN_MENU.name,GetRealmName());
	end
	table.insert(GuildLeader.db.profile.GLBlackt, playerrealmname)
	GLBlackt=GuildLeader.db.profile.GLBlackt
	pairsByKeysBlack(GLBlackt)
	GuildLeader:Print(strjoin(" ",playerrealmname,"was added to the Black List!"))
	if GuildLeader.db.profile.pruneannounce==3 then
	SendChatMessage(strjoin(" ",playerrealmname,"has been banned from the guild. They will be autokicked if found on the roster."),"guild", nil,"GUILD")
	end
	if GuildLeader.db.profile.pruneannounce==2 then
	SendChatMessage(strjoin(" ",playerrealmname,"has been banned from the guild. They will be autokicked if found on the roster."),"officer", nil,"OFFICER")
	end
	end,
	notCheckable = 1,
}

local BlackremoveButtonInfo = {
	text = "Remove from Black List",
	value = "EZ_BLACKREM",
	func = function()
	if string.match(UIDROPDOWNMENU_OPEN_MENU.name, "-") then
	playerrealmname = UIDROPDOWNMENU_OPEN_MENU.name;
	else
	playerrealmname = strjoin("-",UIDROPDOWNMENU_OPEN_MENU.name,GetRealmName());
	end
	indexValue=CheckTable(GuildLeader.db.profile.GLBlackt, playerrealmname)
	RemoveTableValue(GuildLeader.db.profile.GLBlackt, indexValue)
	GuildLeader:Print(strjoin(" ",playerrealmname,"was removed from the Black List!"))
	if GuildLeader.db.profile.pruneannounce==3 then
	SendChatMessage(strjoin(" ",playerrealmname,"is no longer banned from the guild."),"guild", nil,"GUILD")
	end
	if GuildLeader.db.profile.pruneannounce==2 then
	SendChatMessage(strjoin(" ",playerrealmname,"is no longer banned from the guild."),"officer", nil,"OFFICER")
	end
	end,
	notCheckable = 1,
}

local KickButtonInfo = {
	text = "Kick from Guild",
	value = "EZ_KICK",
	func = function()
	if string.match(UIDROPDOWNMENU_OPEN_MENU.name, "-") then
	playerrealmname = UIDROPDOWNMENU_OPEN_MENU.name;
	else
	playerrealmname = strjoin("-",UIDROPDOWNMENU_OPEN_MENU.name,GetRealmName());
	end
	GuildUninvite(playerrealmname) 
	if CheckTable(GuildLeader.db.profile.GLDNIt, playerrealmname)~=0 and GuildLeader.db.profile.removefromdnil==true then
	indexValue=CheckTable(GuildLeader.db.profile.GLDNIt, playerrealmname)
	RemoveTableValue(GuildLeader.db.profile.GLDNIt, indexValue)
	GuildLeader:Print(strjoin(" ",playerrealmname,"was removed from the Do Not Invite List"))
	end
	end,
	notCheckable = 1,
}

local BanButtonInfo = {
	text = "Ban from Guild",
	value = "EZ_BAN",
	func = function()
	if string.match(UIDROPDOWNMENU_OPEN_MENU.name, "-") then
	playerrealmname = UIDROPDOWNMENU_OPEN_MENU.name;
	else
	playerrealmname = strjoin("-",UIDROPDOWNMENU_OPEN_MENU.name,GetRealmName());
	end
	GuildUninvite(playerrealmname)
	table.insert(GuildLeader.db.profile.GLBlackt, playerrealmname)
	GLBlackt=GuildLeader.db.profile.GLBlackt
	pairsByKeysBlack(GLBlackt)
	GuildLeader:Print(strjoin(" ",playerrealmname,"was added to the Black List!"))
	if GuildLeader.db.profile.pruneannounce==3 then
	SendChatMessage(strjoin(" ",playerrealmname,"has been banned from the guild. They will be autokicked if found on the roster."),"guild", nil,"GUILD")
	end
	if GuildLeader.db.profile.pruneannounce==2 then
	SendChatMessage(strjoin(" ",playerrealmname,"has been banned from the guild. They will be autokicked if found on the roster."),"officer", nil,"OFFICER")
	end
	end,
	notCheckable = 1,
}

local PruneaddButtonInfo = {
	text = "Exempt from Pruning",
	value = "EZ_PRUNE",
	func = function()
	if string.match(UIDROPDOWNMENU_OPEN_MENU.name, "-") then
	playerrealmname = UIDROPDOWNMENU_OPEN_MENU.name;
	else
	playerrealmname = strjoin("-",UIDROPDOWNMENU_OPEN_MENU.name,GetRealmName());
	end
	table.insert(GuildLeader.db.profile.GLPruneExemptt, playerrealmname)
	GLPruneExemptt=GuildLeader.db.profile.GLPruneExemptt
	pairsByKeysPruneExempt(GLPruneExemptt)
	GuildLeader:Print(strjoin(" ",playerrealmname,"is no longer subject to Auto-Kicks. (Unless Blacklisted)"))
	end,
	notCheckable = 1,
}

local PruneremoveButtonInfo = {
	text = "Unexempt from Pruning",
	value = "EZ_PRUNEREM",
	func = function()
	if string.match(UIDROPDOWNMENU_OPEN_MENU.name, "-") then
	playerrealmname = UIDROPDOWNMENU_OPEN_MENU.name;
	else
	playerrealmname = strjoin("-",UIDROPDOWNMENU_OPEN_MENU.name,GetRealmName());
	end
	indexValue=CheckTable(GuildLeader.db.profile.GLPruneExemptt, playerrealmname)
	RemoveTableValue(GuildLeader.db.profile.GLPruneExemptt, indexValue)
	GuildLeader:Print(strjoin(" ",playerrealmname,"is subject to Auto-Kicks."))
	end,
	notCheckable = 1,
}

local DemoteaddButtonInfo = {
	text = "Exempt from Demotion",
	value = "EZ_DEMOTE",
	func = function()
	if string.match(UIDROPDOWNMENU_OPEN_MENU.name, "-") then
	playerrealmname = UIDROPDOWNMENU_OPEN_MENU.name;
	else
	playerrealmname = strjoin("-",UIDROPDOWNMENU_OPEN_MENU.name,GetRealmName());
	end
	table.insert(GuildLeader.db.profile.GLDemoteExemptt, playerrealmname)
	GLDemoteExemptt=GuildLeader.db.profile.GLDemoteExemptt
	pairsByKeysDemoteExempt(GLDemoteExemptt)
	GuildLeader:Print(strjoin(" ",playerrealmname,"is no longer subject to Auto-Demotions."))
	end,
	notCheckable = 1,
}

local DemoteremoveButtonInfo = {
	text = "Unexempt from Demotion",
	value = "EZ_DEMOTEREM",
	func = function()
	if string.match(UIDROPDOWNMENU_OPEN_MENU.name, "-") then
	playerrealmname = UIDROPDOWNMENU_OPEN_MENU.name;
	else
	playerrealmname = strjoin("-",UIDROPDOWNMENU_OPEN_MENU.name,GetRealmName());
	end
	indexValue=CheckTable(GuildLeader.db.profile.GLDemoteExemptt, playerrealmname)
	RemoveTableValue(GuildLeader.db.profile.GLDemoteExemptt, indexValue)
	GuildLeader:Print(strjoin(" ",playerrealmname,"is subject to Auto-Demotions."))
	end,
	notCheckable = 1,
}

local CancelButtonInfo = {
	text = "Cancel",
	value = "EZ_CANCEL",
	notCheckable = 1
}

function CheckTable(checkT, name)
	for i, n in pairs(checkT) do
		if n==name then
			return i
		end
	end
	return 0
end

function RemoveTableValue(removeT, index)
	table.remove(removeT, index)
end

function EasyGInvCheck()
	if GuildLeader.db.profile.isOfficer==true or GuildLeader.db.profile.canInvite==true then		
		local PossibleButton = getglobal("DropDownList1Button"..(DropDownList1.numButtons)-1)
		if PossibleButton["value"] ~= "EZ_CANCEL" then	
			if (UIDROPDOWNMENU_MENU_LEVEL > 1) then return; end					
			local GoodUnit = false
			for i=1, #PopupUnits do
			if OPEN_DROPDOWNMENUS[1]["which"] == PopupUnits[i] then
				GoodUnit = true
				end
			end
														
			if UIDROPDOWNMENU_OPEN_MENU["unit"] == "target" and ((not UnitIsPlayer("target"))) then
				GoodUnit = false									
			end
			
			if GoodUnit then										
					CreateEasyGInvButton()		
			end
		end
	end
end

function CreateEasyGInvButton()
		local CancelButtonFrame = getglobal("DropDownList1Button"..DropDownList1.numButtons)
		CancelButtonFrame:Hide() 								
		DropDownList1.numButtons = DropDownList1.numButtons - 1		
		if string.match(UIDROPDOWNMENU_OPEN_MENU.name, "-") then
		playerrealmname = UIDROPDOWNMENU_OPEN_MENU.name;
		else
		playerrealmname = strjoin("-",UIDROPDOWNMENU_OPEN_MENU.name,GetRealmName());
		end
		GLRoster = {}
		for i=1,GetNumGuildMembers(true) do local name,_,_,_,_,_,note,officer = GetGuildRosterInfo(i);
		if string.match(name, "-") then
		else
		name = strjoin("-",name,GetRealmName());
		end
		table.insert(GLRoster, name)
		end
		CurrentPlayerName = GetUnitName("player")
		if string.match(CurrentPlayerName, "-") then
		else
		CurrentPlayerName = strjoin("-",CurrentPlayerName,GetRealmName())
		end
		if CheckTable(GLRoster, playerrealmname)==0 and CurrentPlayerName~=playerrealmname then
		if CheckTable(GuildLeader.db.profile.GLBlackt, playerrealmname)==0 then
		if CheckTable(GuildLeader.db.profile.GLDNIt, playerrealmname)==0 then
		UIDropDownMenu_AddButton(GInvButtonInfo)
		end
		end
		if CheckTable(GuildLeader.db.profile.GLDNIt, playerrealmname)==0 then
		UIDropDownMenu_AddButton(DNILaddButtonInfo)
		else
		UIDropDownMenu_AddButton(DNILremoveButtonInfo)
		end
		if CheckTable(GuildLeader.db.profile.GLBlackt, playerrealmname)==0 then
		UIDropDownMenu_AddButton(BlackaddButtonInfo)
		else
		UIDropDownMenu_AddButton(BlackremoveButtonInfo)
		end
		elseif CurrentPlayerName~=playerrealmname then
		UIDropDownMenu_AddButton(KickButtonInfo)
		UIDropDownMenu_AddButton(BanButtonInfo)
		if CheckTable(GuildLeader.db.profile.GLPruneExemptt, playerrealmname)==0 then
		UIDropDownMenu_AddButton(PruneaddButtonInfo)
		else
		UIDropDownMenu_AddButton(PruneremoveButtonInfo)
		end
		if CheckTable(GuildLeader.db.profile.GLDemoteExemptt, playerrealmname)==0 then
		UIDropDownMenu_AddButton(DemoteaddButtonInfo)
		else
		UIDropDownMenu_AddButton(DemoteremoveButtonInfo)
		end
		else
		end
		UIDropDownMenu_AddButton(CancelButtonInfo) 
end

local function ChatCmd(input)
	if not input or input:trim() == "" then
		InterfaceOptionsFrame_OpenToCategory(GuildLeader.optionsframe)
		InterfaceOptionsFrame_OpenToCategory(GuildLeader.optionsframe)
	else
		LibStub("AceConfigCmd-3.0").HandleCommand(GuildLeader, "gl", "GuildLeader", input:trim() ~= "help" and input or "")
	end
end

GuildLeader = LibStub("AceAddon-3.0"):NewAddon("GuildLeader", "AceTimer-3.0", "AceEvent-3.0", "AceConsole-3.0", "AceComm-3.0", "AceSerializer-3.0", "AceHook-3.0")
GuildLeader:RegisterChatCommand("GuildLeader", ChatCmd)
GuildLeader:RegisterChatCommand("gl", ChatCmd)

local function SetLayout(this)
  dewdrop:Close()
  if not t1 then
    t1 = this:CreateFontString(nil, "ARTWORK")
    t1:SetFontObject(GameFontNormalLarge)
    t1:SetJustifyH("LEFT") 
    t1:SetJustifyV("TOP")
    t1:SetPoint("TOPLEFT", 16, -16)
    t1:SetText(this.name)


    local t2 = this:CreateFontString(nil, "ARTWORK")
    t2:SetFontObject(GameFontHighlightSmall)
    t2:SetJustifyH("LEFT") 
    t2:SetJustifyV("TOP")
    t2:SetHeight(43)
    t2:SetPoint("TOPLEFT", t1, "BOTTOMLEFT", 0, -8)
    t2:SetPoint("RIGHT", this, "RIGHT", -32, 0)
    t2:SetNonSpaceWrap(true)
    local function GetInfo(field)
      return GetAddOnMetadata(this.addon, field) or "N/A"
    end
    t2:SetFormattedText("Notes: %s\nAuthor: %s\nVersion: %s\nRevision: %s", GetInfo("Notes"), GetInfo("Author"), GetInfo("Version"), GetInfo("X-Build"))

    local b = CreateFrame("Button", nil, this, "UIPanelButtonTemplate")
    b:SetWidth(120)
    b:SetHeight(20)
    b:SetText("Options Menu")
    b:SetScript("OnClick", GuildLeader.DewOptions)
    b:SetPoint("TOPLEFT", t2, "BOTTOMLEFT", -2, -8)
  end
end

function GuildLeader:DewOptions()
	dewdrop:Open('dummy', 'children', function() dewdrop:FeedAceOptionsTable(options) end, 'cursorX', true, 'cursorY', true)
end

local function CreateUIOptionsFrame(addon) 
  local panel = CreateFrame("Frame")
  panel.name = GetAddOnMetadata(addon, "Title") or addon
  panel.addon = addon
  panel:SetScript("OnShow", SetLayout)
  InterfaceOptions_AddCategory(panel)
end

function GuildLeader:ToggleActive(state)
	active = state
end

--Table Interfaces--
function GuildLeader:IQUI()
local IQframe = GUI:Create("Frame")
IQframe:SetTitle("Invite Queue Control")
IQframe:SetCallback("OnClose", function(widget) GUI:Release(widget) end)
IQframe:SetWidth(350)
IQframe:SetHeight(200)
IQframe:SetLayout("Flow")

local addIQbutton = GUI:Create("Button")
addIQbutton:SetText("Add Name")
addIQbutton:SetWidth(150)
addIQbutton:SetCallback("OnClick", function()
if GLIQAddName~=nil then
if string.match(GLIQAddName, "-") then
else
GLIQAddName = strjoin("-",GLIQAddName,GetRealmName());
end
if CheckTable(GuildLeader.db.profile.GLIQt, GLIQAddName)==0 then
table.insert(GuildLeader.db.profile.GLIQt, GLIQAddName)
GLIQt=GuildLeader.db.profile.GLIQt
pairsByKeysIQ(GLIQt)
GuildLeader:Print(strjoin(" ",GLIQAddName,"has been added to the Invite Queue"))
else
GuildLeader:Print(strjoin(" ",GLIQAddName,"is on the Invite Queue. The list will update when the interface closes."))
end
else
GuildLeader:Print("ERROR! You must type a name!")
end
end)
IQframe:AddChild(addIQbutton)

local addIQ = GUI:Create("EditBox")
addIQ:SetLabel("Insert Name:")
addIQ:SetWidth(150)
addIQ:SetCallback("OnEnterPressed", function(GLIQtext) 
for k,v in pairs(GLIQtext) do 
 if (k=="lasttext") then 
 GLIQAddName=v
 end
 end
end)
IQframe:AddChild(addIQ)

local removeIQbutton = GUI:Create("Button")
removeIQbutton:SetText("Remove Name")
removeIQbutton:SetWidth(150)
removeIQbutton:SetCallback("OnClick", function()
	if GLIQChoice~=nil then
		nameIndex=CheckTable(GuildLeader.db.profile.GLIQt, GLIQChoice)
		if nameIndex~=0 then
			RemoveTableValue(GuildLeader.db.profile.GLIQt, nameIndex)
			GuildLeader:Print(strjoin(" ",GLIQChoice,"has been removed from the Invite Queue. The list will update when the interface closes."))

		else
			GuildLeader:Print(strjoin(" ",GLIQChoice,"is not in the Invite Queue. If you still see them the list will update when the interface closes."))
		end
else
GuildLeader:Print("ERROR! You must select a name!")
end
end)
IQframe:AddChild(removeIQbutton)

local IQDropDown = GUI:Create("Dropdown")
IQDropDown:SetList(GuildLeader.db.profile.GLIQt)
IQDropDown:SetWidth(150)
IQDropDown:SetCallback("OnValueChanged", function(IQChoice)
 for k,v in pairs(IQChoice) do 
 if (k=="value") then 
 GLIQChoiceindex=v 
 end
 end
 for k,v in pairs(GuildLeader.db.profile.GLIQt) do
 if GLIQChoiceindex==k then
 GLIQChoice=v
 end
 end
  end)
IQframe:AddChild(IQDropDown)

local purgeIQbutton = GUI:Create("Button")
purgeIQbutton:SetText("Purge List")
purgeIQbutton:SetWidth(150)
purgeIQbutton:SetCallback("OnClick", function()
if GuildLeader.db.profile.GLIQt~={} then
GuildLeader.db.profile.GLIQt = {}
GuildLeader:Print("The Invite Queue has been purged")
else
GuildLeader:Print("The Invite Queue is empty. It will update when the interface closes.")
end
end)
IQframe:AddChild(purgeIQbutton)

local inviteIQbutton = GUI:Create("Button")
inviteIQbutton:SetText("Invite!")
inviteIQbutton:SetWidth(150)
inviteIQbutton:SetCallback("OnClick", function()
if #(GuildLeader.db.profile.GLIQt)~=0 then
for k,v in pairs(GuildLeader.db.profile.GLIQt) do
if 1==k then
GLIQtop=v
if string.match(GLIQtop, "-") then
else
GLIQtop = strjoin("-",GLIQtop,GetRealmName());
end
if CheckTable(GuildLeader.db.profile.GLDNIt, GLIQtop)==0 then
table.insert(GuildLeader.db.profile.GLDNIt, GLIQtop)
GLDNIt=GuildLeader.db.profile.GLDNIt
pairsByKeysDNI(GLDNIt)
end
 end
 end
if GuildLeader.db.profile.whisperonly==false then
GuildInvite(GLIQtop)
else
SendChatMessage(GuildLeader.db.profile.whispmessage,"WHISPER",nil,GLIQtop)
end

indexValue=CheckTable(GuildLeader.db.profile.GLIQt, GLIQtop)
RemoveTableValue(GuildLeader.db.profile.GLIQt, indexValue)
else
GuildLeader:Print("The Invitation Queue is Empty!")
end
end)
IQframe:AddChild(inviteIQbutton)
end

function GuildLeader:DNIUI()
local DNIframe = GUI:Create("Frame")
DNIframe:SetTitle("Do Not Invite List Control")
DNIframe:SetCallback("OnClose", function(widget) GUI:Release(widget) end)
DNIframe:SetWidth(350)
DNIframe:SetHeight(200)
DNIframe:SetLayout("Flow")

local addDNIbutton = GUI:Create("Button")
addDNIbutton:SetText("Add Name")
addDNIbutton:SetWidth(150)
addDNIbutton:SetCallback("OnClick", function()
if GLDNIAddName~=nil then
if string.match(GLDNIAddName, "-") then
else
GLDNIAddName = strjoin("-",GLDNIAddName,GetRealmName());
end
if CheckTable(GuildLeader.db.profile.GLDNIt, GLDNIAddName)==0 then
table.insert(GuildLeader.db.profile.GLDNIt, GLDNIAddName)
GLDNIt=GuildLeader.db.profile.GLDNIt
pairsByKeysDNI(GLDNIt)
GuildLeader:Print(strjoin(" ",GLDNIAddName,"has been added to the Do Not Invite List."))
else
GuildLeader:Print(strjoin(" ",GLDNIAddName,"is on the Do Not Invite List. The list will update when the interface closes."))
end
else
GuildLeader:Print("ERROR! You must type a name!")
end
end)
DNIframe:AddChild(addDNIbutton)

local addDNI = GUI:Create("EditBox")
addDNI:SetLabel("Insert Name:")
addDNI:SetWidth(150)
addDNI:SetCallback("OnEnterPressed", function(GLDNItext) 
for k,v in pairs(GLDNItext) do 
 if (k=="lasttext") then 
 GLDNIAddName=v
 end
 end
end)
DNIframe:AddChild(addDNI)

local removeDNIbutton = GUI:Create("Button")
removeDNIbutton:SetText("Remove Name")
removeDNIbutton:SetWidth(150)
removeDNIbutton:SetCallback("OnClick", function()
	if GLDNIChoice~=nil then
		nameIndex=CheckTable(GuildLeader.db.profile.GLDNIt, GLDNIChoice)
		if nameIndex~=0 then
			RemoveTableValue(GuildLeader.db.profile.GLDNIt, nameIndex)
			GuildLeader:Print(strjoin(" ",GLDNIChoice,"has been removed from the Invite Queue. The list will update when the interface closes."))

		else
			GuildLeader:Print(strjoin(" ",GLDNIChoice,"is not in the Invite Queue. If you still see them the list will update when the interface closes."))
		end
else
GuildLeader:Print("ERROR! You must select a name!")
end
end)
DNIframe:AddChild(removeDNIbutton)

local DNIDropDown = GUI:Create("Dropdown")
DNIDropDown:SetList(GuildLeader.db.profile.GLDNIt)
DNIDropDown:SetWidth(150)
DNIDropDown:SetCallback("OnValueChanged", function(DNIChoice)
 for k,v in pairs(DNIChoice) do 
 if (k=="value") then 
 GLDNIChoiceIndex=v 
 end
 end
 for k,v in pairs(GuildLeader.db.profile.GLDNIt) do
 if GLDNIChoiceIndex==k then
 GLDNIChoice=v
 end
 end
  end)
DNIframe:AddChild(DNIDropDown)

local purgeDNIbutton = GUI:Create("Button")
purgeDNIbutton:SetText("Purge List")
purgeDNIbutton:SetWidth(150)
purgeDNIbutton:SetCallback("OnClick", function()
if GuildLeader.db.profile.GLDNIt~={} then
GuildLeader.db.profile.GLDNIt = {}
GuildLeader:Print("The Do Not Invite List has been purged")
else
GuildLeader:Print("The Do Not Invite List is empty. It will update when the interface closes.")
end
end)
DNIframe:AddChild(purgeDNIbutton)
end

function GuildLeader:BlackUI()
local Blackframe = GUI:Create("Frame")
Blackframe:SetTitle("Black List Control")
Blackframe:SetCallback("OnClose", function(widget) GUI:Release(widget) end)
Blackframe:SetWidth(350)
Blackframe:SetHeight(200)
Blackframe:SetLayout("Flow")

local addBlackbutton = GUI:Create("Button")
addBlackbutton:SetText("Add Name")
addBlackbutton:SetWidth(150)
addBlackbutton:SetCallback("OnClick", function()
if GLBlackAddName~=nil then
if string.match(GLBlackAddName, "-") then
else
GLBlackAddName = strjoin("-",GLBlackAddName,GetRealmName());
end
if CheckTable(GuildLeader.db.profile.GLBlackt, GLBlackAddName)==1 then
table.insert(GuildLeader.db.profile.GLBlackt, GLBlackAddName)
GLBlackt=GuildLeader.db.profile.GLBlackt
pairsByKeysBlack(GLBlackt)
GuildLeader:Print(strjoin(" ",GLBlackAddName,"has been added to the Black List."))
if GuildLeader.db.profile.pruneannounce==3 then
SendChatMessage(strjoin(" ",GLBlackAddName,"has been added to the Black List and Banned from the guild! They will be autokicked if invited back!"),"guild", nil,"GUILD")
end
if GuildLeader.db.profile.pruneannounce==2 then
SendChatMessage(strjoin(" ",GLBlackAddName,"has been added to the Black List and Banned from the guild! They will be autokicked if invited back!"),"officer", nil,"OFFICER")
end
else
GuildLeader:Print(strjoin(" ",GLBlackAddName,"is on the Black List. The list will update when the interface closes."))
end
else
GuildLeader:Print("ERROR! You must type a name!")
end
end)
Blackframe:AddChild(addBlackbutton)

local addBlack = GUI:Create("EditBox")
addBlack:SetLabel("Insert Name:")
addBlack:SetWidth(150)
addBlack:SetCallback("OnEnterPressed", function(GLBlacktext) 
for k,v in pairs(GLBlacktext) do 
 if (k=="lasttext") then 
 GLBlackAddName=v
 end
 end
end)
Blackframe:AddChild(addBlack)

local removeBlackbutton = GUI:Create("Button")
removeBlackbutton:SetText("Remove Name")
removeBlackbutton:SetWidth(150)
removeBlackbutton:SetCallback("OnClick", function()
if GLBlackChoice~=nil then
indexValue=CheckTable(GuildLeader.db.profile.GLBlackt, GLBlackChoice)
if indexValue~=0 then
RemoveTableValue(GuildLeader.db.profile.GLBlackt, indexValue)
GuildLeader:Print(strjoin(" ",GLBlackChoice,"was removed from the Black List. The list will update when the interface closes."))
if GuildLeader.db.profile.pruneannounce==3 then
SendChatMessage(strjoin(" ",GLBlackChoice,"has been removed from the Black List and is no longer Banned from the guild!"),"guild", nil,"GUILD")
end
if GuildLeader.db.profile.pruneannounce==2 then
SendChatMessage(strjoin(" ",GLBlackChoice,"has been removed from the Black List and is no longer Banned from the guild!"),"officer", nil,"OFFICER")
end
RemoveTableValue(GuildLeader.db.profile.GLBlackt, indexValue)
else
GuildLeader:Print(strjoin(" ",GLBlackChoice,"is not on the Black List. The list will update when the interface closes."))
end
else
GuildLeader:Print("ERROR! You must select a name!")
end
end)
Blackframe:AddChild(removeBlackbutton)

local BlackDropDown = GUI:Create("Dropdown")
BlackDropDown:SetList(GuildLeader.db.profile.GLBlackt)
BlackDropDown:SetWidth(150)
BlackDropDown:SetCallback("OnValueChanged", function(BlackChoice)
 for k,v in pairs(BlackChoice) do 
 if (k=="value") then 
 GLBlackChoiceindex=v 
 end
 end
 for k,v in pairs(GuildLeader.db.profile.GLBlackt) do
 if GLBlackChoiceindex==k then
 GLBlackChoice=v
 end
 end
  end)
Blackframe:AddChild(BlackDropDown)

local purgeBlackbutton = GUI:Create("Button")
purgeBlackbutton:SetText("Purge List")
purgeBlackbutton:SetWidth(150)
purgeBlackbutton:SetCallback("OnClick", function()
if GuildLeader.db.profile.GLBlackt~={} then
GuildLeader.db.profile.GLBlackt = {}
GuildLeader:Print("The Black List has been purged. The list will update when the interface closes.")
else
GuildLeader:Print("The Black List is empty. It will update when the interface closes.")
end
end)
Blackframe:AddChild(purgeBlackbutton)
end

function GuildLeader:PruneExemptUI()
local PruneExemptframe = GUI:Create("Frame")
PruneExemptframe:SetTitle("Prune Exemption List Control")
PruneExemptframe:SetCallback("OnClose", function(widget) GUI:Release(widget) end)
PruneExemptframe:SetWidth(350)
PruneExemptframe:SetHeight(200)
PruneExemptframe:SetLayout("Flow")

local addPruneExemptbutton = GUI:Create("Button")
addPruneExemptbutton:SetText("Add Name")
addPruneExemptbutton:SetWidth(150)
addPruneExemptbutton:SetCallback("OnClick", function()
if GLPruneExemptAddName~=nil then
if string.match(GLPruneExemptAddName, "-") then
else
GLPruneExemptAddName = strjoin("-",GLPruneExemptAddName,GetRealmName());
end
if CheckTable(GuildLeader.db.profile.GLPruneExemptt, GLPruneExemptAddName)==0 then
table.insert(GuildLeader.db.profile.GLPruneExemptt, GLPruneExemptAddName)
GLPruneExemptt=GuildLeader.db.profile.GLPruneExemptt
pairsByKeysPruneExempt(GLPruneExemptt)
GuildLeader:Print(strjoin(" ",GLPruneExemptAddName,"has been added to the Prune Exemption List. The list will update when the interface closes."))
else
GuildLeader:Print(strjoin(" ",GLPruneExemptAddName,"is on the Prune Exemption List. The list will update when the interface closes."))
end
else
GuildLeader:Print("ERROR! You must type a name!")
end
end)
PruneExemptframe:AddChild(addPruneExemptbutton)

local addPruneExempt = GUI:Create("EditBox")
addPruneExempt:SetLabel("Insert Name:")
addPruneExempt:SetWidth(150)
addPruneExempt:SetCallback("OnEnterPressed", function(GLPruneExempttext) 
for k,v in pairs(GLPruneExempttext) do 
 if (k=="lasttext") then 
 GLPruneExemptAddName=v
 end
 end
end)
PruneExemptframe:AddChild(addPruneExempt)

local removePruneExemptbutton = GUI:Create("Button")
removePruneExemptbutton:SetText("Remove Name")
removePruneExemptbutton:SetWidth(150)
removePruneExemptbutton:SetCallback("OnClick", function()
if GLPruneExemptChoice~=nil then
indexValue=CheckTable(GuildLeader.db.profile.GLBlackt, GLBlackChoice)
if indexValue~=0 then
RemoveTableValue(GuildLeader.db.profile.GLPruneExemptt, indexValue)
GuildLeader:Print(strjoin(" ",GLPruneExemptChoice,"was removed from the Prune Exemption List. The list will update when the interface closes."))
else
GuildLeader:Print(strjoin(" ",GLPruneExemptChoice,"is not on the Prune Exemption List. The list will update when the interface closes."))
end
else
GuildLeader:Print("ERROR! You must select a name!")
end
end)
PruneExemptframe:AddChild(removePruneExemptbutton)

local PruneExemptDropDown = GUI:Create("Dropdown")
PruneExemptDropDown:SetList(GuildLeader.db.profile.GLPruneExemptt)
PruneExemptDropDown:SetWidth(150)
PruneExemptDropDown:SetCallback("OnValueChanged", function(PruneExemptChoice)
 for k,v in pairs(PruneExemptChoice) do 
 if (k=="value") then 
 GLPruneExemptChoiceindex=v 
 end
 end
 for k,v in pairs(GuildLeader.db.profile.GLPruneExemptt) do
 if GLPruneExemptChoiceindex==k then
 GLPruneExemptChoice=v
 end
 end
  end)
PruneExemptframe:AddChild(PruneExemptDropDown)

local purgePruneExemptbutton = GUI:Create("Button")
purgePruneExemptbutton:SetText("Purge List")
purgePruneExemptbutton:SetWidth(150)
purgePruneExemptbutton:SetCallback("OnClick", function()
if GuildLeader.db.profile.GLPruneExemptt~={} then
GuildLeader.db.profile.GLPruneExemptt = {}
GuildLeader:Print("The Prune Exemption List has been purged")
else
GuildLeader:Print("The Prune Exemption List is empty. It will update when the interface closes.")
end
end)
PruneExemptframe:AddChild(purgePruneExemptbutton)
end

function GuildLeader:DemoteExemptUI()
local DemoteExemptframe = GUI:Create("Frame")
DemoteExemptframe:SetTitle("Demote Exemption List Control")
DemoteExemptframe:SetCallback("OnClose", function(widget) GUI:Release(widget) end)
DemoteExemptframe:SetWidth(350)
DemoteExemptframe:SetHeight(200)
DemoteExemptframe:SetLayout("Flow")

local addDemoteExemptbutton = GUI:Create("Button")
addDemoteExemptbutton:SetText("Add Name")
addDemoteExemptbutton:SetWidth(150)
addDemoteExemptbutton:SetCallback("OnClick", function()
if GLDemoteExemptAddName~=nil then
if string.match(GLDemoteExemptAddName, "-") then
else
GLDemoteExemptAddName = strjoin("-",GLDemoteExemptAddName,GetRealmName());
end
if CheckTable(GuildLeader.db.profile.GLDemoteExemptt, GLDemoteExemptAddName)==0 then
table.insert(GuildLeader.db.profile.GLDemoteExemptt, GLDemoteExemptAddName)
GLDemoteExemptt=GuildLeader.db.profile.GLDemoteExemptt
pairsByKeysDemoteExempt(GLDemoteExemptt)
GuildLeader:Print(strjoin(" ",GLDemoteExemptAddName,"has been added to the Demote Exemption List. The list will update when the interface closes."))
else
GuildLeader:Print(strjoin(" ",GLDemoteExemptAddName,"is on the Demote Exemption List. The list will update when the interface closes."))
end
else
GuildLeader:Print("ERROR! You must type a name!")
end
end)
DemoteExemptframe:AddChild(addDemoteExemptbutton)

local addDemoteExempt = GUI:Create("EditBox")
addDemoteExempt:SetLabel("Insert Name:")
addDemoteExempt:SetWidth(150)
addDemoteExempt:SetCallback("OnEnterPressed", function(GLDemoteExempttext) 
for k,v in pairs(GLDemoteExempttext) do 
 if (k=="lasttext") then 
 GLDemoteExemptAddName=v
 end
 end
end)
DemoteExemptframe:AddChild(addDemoteExempt)

local removeDemoteExemptbutton = GUI:Create("Button")
removeDemoteExemptbutton:SetText("Remove Name")
removeDemoteExemptbutton:SetWidth(150)
removeDemoteExemptbutton:SetCallback("OnClick", function()
if GLDemoteExemptChoice~=nil then
indexValue=CheckTable(GuildLeader.db.profile.GLBlackt, GLBlackChoice)
if indexValue~=0 then
RemoveTableValue(GuildLeader.db.profile.GLDemoteExemptt, indexValue)
GuildLeader:Print(strjoin(" ",GLDemoteExemptChoice,"was removed from the Demote Exemption List. The list will update when the interface closes."))
else
GuildLeader:Print(strjoin(" ",GLDemoteExemptChoice,"is not on the Demote Exemption List. The list will update when the interface closes."))
end
else
GuildLeader:Print("ERROR! You must select a name!")
end
end)
DemoteExemptframe:AddChild(removeDemoteExemptbutton)

local DemoteExemptDropDown = GUI:Create("Dropdown")
DemoteExemptDropDown:SetList(GuildLeader.db.profile.GLDemoteExemptt)
DemoteExemptDropDown:SetWidth(150)
DemoteExemptDropDown:SetCallback("OnValueChanged", function(DemoteExemptChoice)
 for k,v in pairs(DemoteExemptChoice) do 
 if (k=="value") then 
 GLDemoteExemptChoiceindex=v 
 end
 end
 for k,v in pairs(GuildLeader.db.profile.GLDemoteExemptt) do
 if GLDemoteExemptChoiceindex==k then
 GLDemoteExemptChoice=v
 end
 end
  end)
DemoteExemptframe:AddChild(DemoteExemptDropDown)

local purgeDemoteExemptbutton = GUI:Create("Button")
purgeDemoteExemptbutton:SetText("Purge List")
purgeDemoteExemptbutton:SetWidth(150)
purgeDemoteExemptbutton:SetCallback("OnClick", function()
if GuildLeader.db.profile.GLDemoteExemptt~={} then
GuildLeader.db.profile.GLDemoteExemptt = {}
GuildLeader:Print("The Demote Exemption List has been purged")
else
GuildLeader:Print("The Demote Exemption List is empty. It will update when the interface closes.")
end
end)
DemoteExemptframe:AddChild(purgeDemoteExemptbutton)
end

--Table Sorters--
function pairsByKeysIQ(GLIQt)
	local GLIQtsort = {}
		for k,v in pairs(GLIQt) do table.insert(GLIQtsort, v) end
		table.sort(GLIQtsort)
		local i = 0      -- iterator variable
		local iter = function ()   -- iterator function
			i = i + 1
			if GLIQtsort[i] == nil then return nil
			else return GLIQtsort[i], t[GLIQtsort[i]]
			end
		end
		GuildLeader.db.profile.GLIQt=GLIQtsort
end

function pairsByKeysDNI(GLDNIt)
	local GLDNItsort = {}
		for k,v in pairs(GLDNIt) do table.insert(GLDNItsort, v) end
		table.sort(GLDNItsort)
		local i = 0      -- iterator variable
		local iter = function ()   -- iterator function
			i = i + 1
			if GLDNItsort[i] == nil then return nil
			else return GLDNItsort[i], t[GLDNItsort[i]]
			end
		end
		GuildLeader.db.profile.GLDNIt=GLDNItsort
end

function pairsByKeysBlack(GLBlackt)
	local GLBlacktsort = {}
		for k,v in pairs(GLBlackt) do table.insert(GLBlacktsort, v) end
		table.sort(GLBlacktsort)
		local i = 0      -- iterator variable
		local iter = function ()   -- iterator function
			i = i + 1
			if GLBlacktsort[i] == nil then return nil
			else return GLBlacktsort[i], t[GLBlacktsort[i]]
			end
		end
		GuildLeader.db.profile.GLBlackt=GLBlacktsort
end

function pairsByKeysPruneExempt(GLPruneExemptt)
	local GLPruneExempttsort = {}
		for k,v in pairs(GLPruneExemptt) do table.insert(GLPruneExempttsort, v) end
		table.sort(GLPruneExempttsort)
		local i = 0      -- iterator variable
		local iter = function ()   -- iterator function
			i = i + 1
			if GLPruneExempttsort[i] == nil then return nil
			else return GLPruneExempttsort[i], t[GLPruneExempttsort[i]]
			end
		end
		GuildLeader.db.profile.GLPruneExemptt=GLPruneExempttsort
end

function pairsByKeysDemoteExempt(GLDemoteExemptt)
	local GLDemoteExempttsort = {}
		for k,v in pairs(GLDemoteExemptt) do table.insert(GLDemoteExempttsort, v) end
		table.sort(GLDemoteExempttsort)
		local i = 0      -- iterator variable
		local iter = function ()   -- iterator function
			i = i + 1
			if GLDemoteExempttsort[i] == nil then return nil
			else return GLDemoteExempttsort[i], t[GLDemoteExempttsort[i]]
			end
		end
		GuildLeader.db.profile.GLDemoteExemptt=GLDemoteExempttsort
end
 
 function Cleantables()
	uncleanGLIQt = GuildLeader.db.profile.GLIQt
	cleanGLIQt = {}
	table.foreach(uncleanGLIQt,function(k,v) 
		if string.match(v,"-") then
			table.insert(cleanGLIQt,v)
		else
			newv = strjoin("-",v,GetRealmName())
			table.insert(cleanGLIQt,newv)
		end
 end)
	GuildLeader.db.profile.GLIQt = cleanGLIQt
	
	uncleanGLDNIt = GuildLeader.db.profile.GLDNIt
	cleanGLDNIt = {}
	table.foreach(uncleanGLDNIt,function(k,v) 
		if string.match(v,"-") then
			table.insert(cleanGLDNIt,v)
		else
			newv = strjoin("-",v,GetRealmName())
			table.insert(cleanGLDNIt,newv)
		end
 end)
	GuildLeader.db.profile.GLDNIt = cleanGLDNIt
	
	uncleanGLBlackt = GuildLeader.db.profile.GLBlackt
	cleanGLBlackt = {}
	table.foreach(uncleanGLBlackt,function(k,v) 
		if string.match(v,"-") then
			table.insert(cleanGLBlackt,v)
		else
			newv = strjoin("-",v,GetRealmName())
			table.insert(cleanGLBlackt,newv)
		end
 end)
	GuildLeader.db.profile.GLBlackt = cleanGLBlackt
	
	uncleanGLPruneExemptt = GuildLeader.db.profile.GLPruneExemptt
	cleanGLPruneExemptt = {}
	table.foreach(uncleanGLPruneExemptt,function(k,v) 
		if string.match(v,"-") then
			table.insert(cleanGLPruneExemptt,v)
		else
			newv = strjoin("-",v,GetRealmName())
			table.insert(cleanGLPruneExemptt,newv)
		end
 end)
	GuildLeader.db.profile.GLPruneExemptt = cleanGLPruneExemptt
	
	uncleanGLDemoteExemptt = GuildLeader.db.profile.GLDemoteExemptt
	cleanGLDemoteExemptt = {}
	table.foreach(uncleanGLDemoteExemptt,function(k,v) 
		if string.match(v,"-") then
			table.insert(cleanGLDemoteExemptt,v)
		else
			newv = strjoin("-",v,GetRealmName())
			table.insert(cleanGLDemoteExemptt,newv)
		end
 end)
	GuildLeader.db.profile.GLDemoteExemptt = cleanGLDemoteExemptt
 end

--Setup functions--
function GuildLeader:GetGuildName()
	local guildName, guildRankName, guildRankIndex = GetGuildInfo("player")
	return guildName
 end

function GuildLeader:OnInitialize()
	C_GuildInfo.GuildRoster()
	GuildNameTest=GuildLeader:GetGuildName()
    GuildLeader.db = LibStub("AceDB-3.0"):New("GuildLeaderDB", {}, "Default")
    GuildLeader.db:RegisterDefaults({
        profile = {
            lasttime = {},
            guild = "",
			active = true,
			cityspam = false,
			zonespam = false,
			outpvpspam = false,
			between = 3,
			message = "",
			citychannel = 2,
			zonechannel = 1,
			whisperinvite = false,
			whisperonly = false,
			atuomatewho = false,
			sendginvite = false,
			targetclass = false,
			whispmessage = "",
			minlevel = 1,
			maxlevel = 60,
			DKsearch = false,
			DHsearch = false,
			Druidsearch = false,
			Huntersearch = false,
			Magesearch = false,
			Monksearch = false,
			Paladinsearch = false,
			Priestsearch = false,
			Roguesearch = false,
			Shamansearch = false,
			Warlocksearch = false,
			Warriorsearch = false,
			membercap = 1000,
			welcomeannounce = 1,
			welcomewhisp = "",
			declinewhisp = "",
			removeinactive = false,
			removelevels = false,
			automateprune = false,
			daysinactive = 365,
			levelthreshold = 1,
			pruneannounce = 1,
			exemptalt = false,
			exemptranks = false,
			removefromdnil = false,
			exemptrank1 = false,
			exemptrank2 = false,
			exemptrank3 = false,
			exemptrank4 = false,
			exemptrank5 = false,
			exemptrank6 = false,
			exemptrank7 = false,
			exemptrank8 = false,
			exemptrank9 = false,
			automatepromote = false,
			demotemode = false,
			promoteannounce = 1,
			promotelevel = false,
			rank1promotesearch = false,
			rank2promotesearch = false,
			rank3promotesearch = false,
			rank4promotesearch = false,
			rank5promotesearch = false,
			rank6promotesearch = false,
			rank7promotesearch = false,
			rank8promotesearch = false,
			rank9promotesearch = false,
			rank1promote = false,
			rank2promote = false,
			rank3promote = false,
			rank4promote = false,
			rank5promote = false,
			rank6promote = false,
			rank7promote = false,
			rank8promote = false,
			rank1level = 1,
			rank2level = 1,
			rank3level = 1,
			rank4level = 1,
			rank5level = 1,
			rank6level = 1,
			rank7level = 1,
			rank8level = 1,
			announcement1 = "",
			announcementtimer1 = 60,
			announcementto1 = 1,
			announcementborder1 = 1,
			announcement2 = "",
			announcementtimer2 = 60,
			announcementto2 = 1,
			announcementborder2 = 1,
			announcement3 = "",
			announcementtimer3 = 60,
			announcementto3 = 1,
			announcementborder3 = 1,
			announcement4 = "",
			announcementtimer4 = 60,
			announcementto4 = 1,
			announcementborder4 = 1,
			announcement5 = "",
			announcementtimer5 = 60,
			announcementto5 = 1,
			announcementborder5 = 1,
			nextannouncemessage = "",
			nextannouncetime = 0,
			nextannouncechannel = 1,
			nextannounceborder = 1,
			lastannounced = 0,
			announcenext = 0,
			lastanntime = 0,
			GLPruneExemptt = {},
			GLDemoteExemptt = {},
			GLBlackt = {},
			GLDNIt = {},
			GLIQt = {},
			CurrentGuildLeader = "",
			isOfficer = C_GuildInfo.isOfficer,
			canInvite = canGuildInvite;
        },
    })
	if not GuildLeader.version then GuildLeader.version = tonumber(GetAddOnMetadata("GuildLeader", "X-Build")) end
    GuildLeader.optionsframe = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("GuildLeader", "Guild Leader")
	LibStub("AceConfig-3.0"):RegisterOptionsTable("GuildLeader", options)
	if (GuildLeader.db.profile.version ~= GuildLeader.version) then 
		GuildLeader.db.profile.lasttime = {}
		GuildLeader.db.profile.version = GuildLeader.version
	end		
	active = GuildLeader.db.profile.active
end

function GuildLeader:OnEnable()
	C_GuildInfo.GuildRoster()
	if GuildLeader:GetGuildName()~=nil then
	GuildLeader.db:SetProfile(strjoin("","<",GuildLeader:GetGuildName(),">"," of ",GetRealmName()))
	else
	GuildLeader.db:SetProfile("Default")
	end
	if GuildLeader:GetGuildName() == nil then
		GuildLeader:ScheduleTimer("OnEnable", .1)
		return
	end
	GuildLeader:TurnSelfOn()
end

function GuildLeader:TurnSelfOn()
	GuildLeader:RegisterEvent("CHAT_MSG_CHANNEL_NOTICE")
	GuildLeader:ScheduleRepeatingTimer("MasterTimer", 30)
	GuildLeader:Print("Loaded and Fully Operational! Type /gl to manage your options.")
	Cleantables()
end

--Automation Functions--
function GuildLeader:GetTime()
	local hours,minutes = GetGameTime()
	local caldate = C_DateAndTime.GetCurrentCalendarTime()
	local m = caldate.month
	local d = caldate.monthDay
	local y = caldate.year
	--local _, m, d, y = C_Calendar.GetDate()
	return ((d + math.floor( ( 153*m - 457 ) / 5 ) + 365*y + math.floor( y / 4 ) - math.floor( y / 100 ) + math.floor( y / 400 ) + 1721118.5) * 1440) +(hours*60)+(minutes)
end

function GuildLeader:MasterTimer()
if GuildLeader.db.profile.automateprune==true then
GuildLeader:GKRun()--Pruning
end
if GuildLeader.db.profile.automatepromote==true then
GuildLeader:ScheduleTimer("GLPromoteErrorChecking", 5)
end
GuildLeader:ScheduleTimer("RunAnnouncemnts", 10)
GuildLeader:ScheduleTimer("CheckZone", 15)
end

--Registered Event Functions--
local GLframe = CreateFrame("FRAME", "GuildLeader");
GLframe:RegisterEvent("CHAT_MSG_SYSTEM");
GLframe:RegisterEvent("ADDON_LOADED");
local function GLWelcome(self, event, ...)
	if event == "CHAT_MSG_SYSTEM" then 
		local msg = ...;
		local PlayerName, PlayerRealm = UnitName("Player")
		if (msg and msg ~= nil) then
			if ((string.find(msg, "has joined the guild") ~= nil)) then
				starts, ends = string.find(msg," ")
				args1 = string.sub(msg, 0, starts-1)
				if (args1 ~= UnitName("player"))then
				if GuildLeader.db.profile.welcomeannounce==3 then
				SendChatMessage(strjoin(" ","Please welcome our newest member",args1), "GUILD", nil, arg2);
				end
				if GuildLeader.db.profile.welcomeannounce==2 then
				SendChatMessage(strjoin(" ","Please welcome our newest member",args1), "OFFICER", nil, arg2);
				end
				SendChatMessage(GuildLeader.db.profile.welcomewhisp,"WHISPER",nil,args1) 
				end
				end
			if ((string.find(msg, strjoin("",PlayerName," has joined the guild"))==1)) then
				GuildLeader.db:SetProfile(strjoin("","<",GuildLeader:GetGuildName(),">"," of ",GetRealmName()))
				GuildLeader:RegisterMyToons()
				end
			if ((string.find(msg, strjoin("",PlayerName," has left the guild"))==1)) or ((string.find(msg, strjoin("",PlayerName," has been kicked out of the guild by"))==1)) then
				GuildLeader.db:SetProfile("Default")
				end
			if ((string.find(msg, '" not found.') ~= nil)) then
				starts, ends = string.find(msg," ")
				args1 = string.sub(msg, 2, -13)
				if (args1 ~= UnitName("player"))then
				indexValue=CheckTable(GuildLeader.db.profile.GLDNIt, args1)
				if indexValue~=0 then
				RemoveTableValue(GuildLeader.db.profile.GLDNIt, indexValue)
				GuildLeader:Print(strjoin(" ",args1,"could not be found and was removed from the Do Not Invite List!"))
				end
				end
				end
			if ((string.find(msg, "declines your guild invitation.") ~= nil)) then
				starts, ends = string.find(msg," ")
				args1 = string.sub(msg, 0, -33)
				if (args1 ~= UnitName("player"))then
				SendChatMessage(GuildLeader.db.profile.declinewhisp,"WHISPER",nil,args1) 
				end
				end
			if ((string.find(msg, "is declining all guild invitations") ~= nil)) then
				starts, ends = string.find(msg," ")
				args1 = string.sub(msg, 0, starts-1)
				if (args1 ~= UnitName("player"))then
				SendChatMessage(GuildLeader.db.profile.declinewhisp,"WHISPER",nil,args1) 
				end
				end
				--You have invited xxxx to join your guild.
				--123456789012345678  123456789012345678901
			if ((string.find(msg, "You have invited") ~= nil)) and ((string.find(msg, "to join your guild.") ~= nil)) then
				args1 = string.sub(msg, 18, -21)
				if (args1 ~= UnitName("player"))then
				SendChatMessage(GuildLeader.db.profile.whispmessage,"WHISPER",nil,args1)
				end
				end
			end
		end	
	end	
GLframe:SetScript("OnEvent", GLWelcome);

--*RECRUITMENT*--
local f = CreateFrame("frame")
f:RegisterEvent("CHAT_MSG_WHISPER")
f:SetScript("OnEvent", function(self,event,arg1,arg2)
if string.match(arg2, "-") then
else
arg2 = strjoin("-",arg2,GetRealmName());
end
if GuildLeader.db.profile.isOfficer==true or GuildLeader.db.profile.canInvite==true then
if GetNumGuildMembers()<=999 and GuildLeader.db.profile.membercap>GetNumGuildMembers() and arg1:lower():match("lf guild") and GuildLeader.db.profile.whisperinvite==true then
    if CheckTable(GuildLeader.db.profile.GLBlackt, arg2)==0 then
        if CheckTable(GuildLeader.db.profile.GLIQt, arg2)==0 then
			table.insert(GuildLeader.db.profile.GLIQt, arg2)
			GLIQt=GuildLeader.db.profile.GLIQt
			pairsByKeysIQ(GLIQt)
			end
		if CheckTable(GuildLeader.db.profile.GLIQt, arg2)~=0 then
			SendChatMessage("You are already added to the Invite Queue. Please wait for the next round of invites. Thank you.","WHISPER",nil,arg2)
		else
        SendChatMessage("Added to Invite Queue. If you do not get an invite shortly it may be because you are already in a guild, on a trial account or you are incorrectly flagged as being in a guild. If you think it is the last reason, log out and back in then try again!","WHISPER",nil,arg2) 
		end
    else
        SendChatMessage("Invitation Denied! You are currently banned from this guild!","WHISPER",nil,arg2)
    end
    elseif (GetNumGuildMembers()>=1000 or GuildLeader.db.profile.membercap<=GetNumGuildMembers()) and arg1:lower():match("lf guild") and GuildLeader.db.profile.whisperinvite==true then
    SendChatMessage("Invitation Denied! The guild is currently full!","WHISPER",nil,arg2)
    end
    end
end)

--Zone Recruitment Functions--
function GuildLeader:CHAT_MSG_CHANNEL_NOTICE(what, a, b, c, d, e, f, number, channel)
GuildLeader:ScheduleTimer("CheckZone", 5)
end
function GuildLeader:CheckZone()
if GetNumGuildMembers()<=999 and GuildLeader.db.profile.membercap>GetNumGuildMembers() then
local inInstance, instanceType = IsInInstance()
if inInstance==false then
if (GuildLeader:IsCity())==true then
GLzone="City"
elseif (GuildLeader:IsCity())~=true then
GLzone=(GetZoneText())
end
end
if GLzone=="City" and GuildLeader.db.profile.cityspam==true then
GuildLeader:CheckTime(GLzone)
end
if GLzone~="City" and GuildLeader.db.profile.zonespam==true then
if GetZonePVPInfo()~="combat" then
GuildLeader:CheckTime(GLzone)
end
if GetZonePVPInfo()=="Combat" and GuildLeader.db.profile.outpvpspam==true then
GuildLeader:CheckTime(GLzone)
end
end
end
end


function GuildLeader:IsCity()
if (GetZoneText())=="Stormwind City" then
return true
elseif (GetZoneText())=="Darnassus" then
return true
elseif (GetZoneText())=="City of Ironforge" then
return true
elseif (GetZoneText())=="The Exodar" then
return true
elseif (GetZoneText())=="Shrine of Seven Stars" then
return true
elseif (GetZoneText())=="Stormshield" then
return true
elseif (GetZoneText())=="Lunarfall" then
return true
elseif (GetZoneText())=="Orgrimmar" then
return true
elseif (GetZoneText())=="Thunder Bluff" then
return true
elseif (GetZoneText())=="Undercity" then
return true
elseif (GetZoneText())=="Silvermoon City" then
return true
elseif (GetZoneText())=="Shrine of Two Moons" then
return true
elseif (GetZoneText())=="Warspear" then
return true
elseif (GetZoneText())=="Frostwall" then
return true
elseif (GetZoneText())=="Dalaran" then
return true
elseif (GetZoneText())=="Shattrath City" then
return true
elseif GetZoneText()=="Zuldazar" then
if GetSubZoneText()=="Dazar'alor" or "Terrace of Crafters" or "The Royal Armory" then
return true
end
elseif GetZoneText()=="Dazar'alor" then
return true
elseif GetZoneText()=="Boralus Harbor" then
return true
else
return false
end
end

function GuildLeader:CheckTime(GLzone)
if GLzone==nil then
	if (GuildLeader:IsCity())==true then
	GLzone="City"
	elseif (GuildLeader:IsCity())~=true then
	GLzone=(GetZoneText())
	end
end
end
 
function GuildLeader:SpamZone(GLzone)
if GLzone=="City" then 
number=GuildLeader.db.profile.citychannel
else
number=GuildLeader.db.profile.zonechannel
end
if GuildLeader.db.profile.outpvpspam==true and GLzone~="City" then
	number=3
end
SendChatMessage(GuildLeader.db.profile.message,"CHANNEL",nil,number)
GuildLeader.db.profile.lasttime[GLzone]=GuildLeader:GetTime()
end

--Character Recruitment Functions--
function GuildLeader:RunWhoSearch()
if IsGuildLeader()==true or IsGuildLeader()~=true then
if GuildLeader.db.profile.targetclass==true and GuildLeader.db.profile.DKsearch==false and GuildLeader.db.profile.DHsearch==false and GuildLeader.db.profile.Druidsearch==false and GuildLeader.db.profile.Huntersearch==false and GuildLeader.db.profile.Magesearch==false and GuildLeader.db.profile.Paladinsearch==false and GuildLeader.db.profile.Priestsearch==false and GuildLeader.db.profile.Roguesearch==false and GuildLeader.db.profile.Shamansearch==false and GuildLeader.db.profile.Warlocksearch==false and GuildLeader.db.profile.Warriorsearch==false then
GuildLeader:Print('ERROR! You must select a specific class if you opt to target specific classes!')
else
if WhoCycle==1 then
GuildLeader:Print('Character Recruitment Cycle Already In Progress')
else
WhoHalt=0
WhoCycle=0
LevelChecking=0
ClassChecking=0
RaceClassChecking=0
ToonLevelCheck=0
ToonClassCheck=0
ToonRaceClassCheck=0
GuildLeader:LevelRangeSearch()
end
end
else
GuildLeader:Print('Character Recruitment Cycle did NOT start! Only Guild Leaders can use this function!')
end
end

function GuildLeader:LevelRangeSearch()
if GetNumGuildMembers()<=999 and GuildLeader.db.profile.membercap>GetNumGuildMembers() then
if WhoCycle==0 then
GuildLeader:Print('Starting Character Recruitment Cycle')
if GuildLeader.db.profile.minlevel+4>=GuildLeader.db.profile.maxlevel and GuildLeader.db.profile.minlevel<GuildLeader.db.profile.maxlevel then
ToonMinLevel=GuildLeader.db.profile.minlevel
ToonMaxLevel=GuildLeader.db.profile.maxlevel
ToonLevel=strjoin('',ToonMinLevel,'-',ToonMaxLevel)
WhoCycle=1
GuildLeader:SendWhoLevel()
elseif GuildLeader.db.profile.minlevel+4<GuildLeader.db.profile.maxlevel then
ToonMinLevel=GuildLeader.db.profile.maxlevel-4
ToonMaxLevel=GuildLeader.db.profile.maxlevel
ToonLevel=strjoin('',ToonMinLevel,'-',ToonMaxLevel)
WhoCycle=1
GuildLeader:SendWhoLevel()
elseif GuildLeader.db.profile.minlevel==GuildLeader.db.profile.maxlevel then
ToonMinLevel=GuildLeader.db.profile.minlevel
ToonMaxLevel=GuildLeader.db.profile.maxlevel
ToonLevel=GuildLeader.db.profile.minlevel
GuildLeader:SendWhoLevel()
WhoCycle=1
end

elseif WhoCycle==1 then

if ToonMaxLevel-4<=GuildLeader.db.profile.minlevel and ToonMaxLevel>GuildLeader.db.profile.minlevel then
ToonMinLevel=GuildLeader.db.profile.minlevel
ToonLevel=strjoin('',ToonMinLevel,'-',ToonMaxLevel)
GuildLeader:SendWhoLevel()
elseif ToonMaxLevel-4>GuildLeader.db.profile.minlevel then
ToonMinLevel=ToonMaxLevel-4
ToonLevel=strjoin('',ToonMinLevel,'-',ToonMaxLevel)
GuildLeader:SendWhoLevel()
elseif ToonMaxLevel==GuildLeader.db.profile.minlevel then
ToonLevel=GuildLeader.db.profile.minlevel
ToonMinLevel=GuildLeader.db.profile.minlevel
GuildLeader:SendWhoLevel()
elseif ToonMaxLevel<GuildLeader.db.profile.minlevel then
WhoCycle=0
end
end
else
GuildLeader:Print('Character Recruitment Will Not Run. Guild Population is at maximum.')
LevelChecking=0
ClassChecking=0
RaceClassChecking=0
ToonLevelCheck=0
ToonClassCheck=0
ToonRaceClassCheck=0
WhoCycle=0
end
end

function GuildLeader:LevelSearch()
LevelChecking=1
if ToonLevelCheck==0 then
ToonLevelCheck=1
GuildLeader:LevelSearch()
elseif ToonLevelCheck==1 and ToonMaxLevel>=GuildLeader.db.profile.minlevel then
ToonLevel=ToonMaxLevel
GuildLeader:SendWhoLevel()
elseif ToonLevelCheck==2 and ToonMaxLevel-1>=GuildLeader.db.profile.minlevel then
ToonLevel=ToonMaxLevel-1
GuildLeader:SendWhoLevel()
elseif ToonLevelCheck==3 and ToonMaxLevel-2>=GuildLeader.db.profile.minlevel then
ToonLevel=ToonMaxLevel-2
GuildLeader:SendWhoLevel()
elseif ToonLevelCheck==4 and ToonMaxLevel-3>=GuildLeader.db.profile.minlevel then
ToonLevel=ToonMaxLevel-3
GuildLeader:SendWhoLevel()
elseif ToonLevelCheck==5 and ToonMaxLevel-4>=GuildLeader.db.profile.minlevel then
ToonLevel=ToonMaxLevel-4
GuildLeader:SendWhoLevel()
elseif ToonLevelCheck==6 or ToonLevel<=GuildLeader.db.profile.minlevel then
LevelChecking=0
ToonMaxLevel=ToonMinLevel-1
GuildLeader:LevelRangeSearch()
end
end

--Class Controls--
function GuildLeader:ClassControl()
ClassChecking=1
if ToonClassCheck==0 then
ToonClassCheck=1
GuildLeader:ClassControl()
elseif ToonClassCheck==1 then
if GuildLeader.db.profile.DKsearch==true or GuildLeader.db.profile.targetclass==false then
ToonClass = 'c-\"Death Knight\" '
ToonClassName = 'Death Knights'
GuildLeader:SendWhoClass()
else
ToonClassCheck=2
GuildLeader:ClassControl()
end
elseif ToonClassCheck==2 then
if GuildLeader.db.profile.DHsearch==true or GuildLeader.db.profile.targetclass==false then
ToonClass = 'c-\"Demon Hunter\" '
ToonClassName = 'Demon Hunter'
GuildLeader:SendWhoClass()
else
ToonClassCheck=3
GuildLeader:ClassControl()
end
elseif ToonClassCheck==3 then
if GuildLeader.db.profile.Druidsearch==true or GuildLeader.db.profile.targetclass==false then
ToonClass = 'c-\"Druid\" '
ToonClassName = 'Druids'
GuildLeader:SendWhoClass()
else
ToonClassCheck=4
GuildLeader:ClassControl()
end
elseif ToonClassCheck==4 then
if GuildLeader.db.profile.Huntersearch==true or GuildLeader.db.profile.targetclass==false then
ToonClass = 'c-\"Hunter\" '
ToonClassName = 'Hunters'
GuildLeader:SendWhoClass()
else
ToonClassCheck=5
GuildLeader:ClassControl()
end
elseif ToonClassCheck==5 then
if GuildLeader.db.profile.Magesearch==true or GuildLeader.db.profile.targetclass==false then
ToonClass = 'c-\"Mage\" '
ToonClassName = 'Mages'
GuildLeader:SendWhoClass()
else
ToonClassCheck=6
GuildLeader:ClassControl()
end
elseif ToonClassCheck==6 then
if GuildLeader.db.profile.Monksearch==true or GuildLeader.db.profile.targetclass==false then
ToonClass = 'c-\"Monk\" '
ToonClassName = 'Monk'
GuildLeader:SendWhoClass()
else
ToonClassCheck=7
GuildLeader:ClassControl()
end
elseif ToonClassCheck==7 then
if GuildLeader.db.profile.Paladinsearch==true or GuildLeader.db.profile.targetclass==false then
ToonClass = 'c-\"Paladin\" '
ToonClassName = 'Paladins'
GuildLeader:SendWhoClass()
else
ToonClassCheck=8
GuildLeader:ClassControl()
end
elseif ToonClassCheck==8 then
if GuildLeader.db.profile.Priestsearch==true or GuildLeader.db.profile.targetclass==false then
ToonClass = 'c-\"Priest\" '
ToonClassName = 'Priests'
GuildLeader:SendWhoClass()
else
ToonClassCheck=9
GuildLeader:ClassControl()
end
elseif ToonClassCheck==9 then
if GuildLeader.db.profile.Roguesearch==true or GuildLeader.db.profile.targetclass==false then
ToonClass = 'c-\"Rogue\" '
ToonClassName = 'Rogues'
GuildLeader:SendWhoClass()
else
ToonClassCheck=10
GuildLeader:ClassControl()
end
elseif ToonClassCheck==10 then
if GuildLeader.db.profile.Shamansearch==true or GuildLeader.db.profile.targetclass==false then
ToonClass = 'c-\"Shaman\" '
ToonClassName = 'Shaman'
GuildLeader:SendWhoClass()
else
ToonClassCheck=11
GuildLeader:ClassControl()
end
elseif ToonClassCheck==11 then
if GuildLeader.db.profile.Warlocksearch==true or GuildLeader.db.profile.targetclass==false then
ToonClass = 'c-\"Warlock\" '
ToonClassName = 'Warlocks'
GuildLeader:SendWhoClass()
else
ToonClassCheck=12
GuildLeader:ClassControl()
end
elseif ToonClassCheck==12 then
if GuildLeader.db.profile.Warriorsearch==true or GuildLeader.db.profile.targetclass==false then
ToonClass = 'c-\"Warrior\" '
ToonClassName = 'Warriors'
GuildLeader:SendWhoClass()
else
ToonClassCheck=13
GuildLeader:ClassControl()
end
elseif ToonClassCheck==13 then
ClassChecking=0
ToonLevelCheck=ToonLevelCheck+1
GuildLeader:LevelSearch()
end
end

--Race/Class Controls--
function GuildLeader:RaceClassControl()
RaceClassChecking=1
if ToonRaceClassCheck==0 then
ToonRaceClassCheck=ToonRaceClassCheck+1
GuildLeader:RaceClassControl()
elseif ToonRaceClassCheck>=1 then
if ToonClassCheck==1 then
GuildLeader:DKRaceSearch()
elseif ToonClassCheck==2 then
GuildLeader:DHRaceSearch()
elseif ToonClassCheck==3 then
GuildLeader:DruidRaceSearch()
elseif ToonClassCheck==4 then
GuildLeader:HunterRaceSearch()
elseif ToonClassCheck==5 then
GuildLeader:MageRaceSearch()
elseif ToonClassCheck==6 then
GuildLeader:MonkRaceSearch()
elseif ToonClassCheck==7 then
GuildLeader:PaladinRaceSearch()
elseif ToonClassCheck==8 then
GuildLeader:PriestRaceSearch()
elseif ToonClassCheck==9 then
GuildLeader:RogueRaceSearch()
elseif ToonClassCheck==10 then
GuildLeader:ShamanRaceSearch()
elseif ToonClassCheck==11 then
GuildLeader:WarlockRaceSearch()
elseif ToonClassCheck==12 then
GuildLeader:WarriorRaceSearch()
end
end
end

function GuildLeader:DKRaceSearch()
if UnitFactionGroup("player")=="Alliance" then
if ToonRaceClassCheck==1 then
ToonRace = 'r-\"Draenei\" '
ToonRaceName = 'Draenei'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==2 then
ToonRace = 'r-\"Dwarf\" '
ToonRaceName = 'Dwarf'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==3 then
ToonRace = 'r-\"Gnome\" '
ToonRaceName = 'Gnome'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==4 then
ToonRace = 'r-\"Human\" '
ToonRaceName = 'Human'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==5 then
ToonRace = 'r-\"Night elf\" '
ToonRaceName = 'Night elf'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==6 then
ToonRace = 'r-\"Worgen\" '
ToonRaceName = 'Worgen'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==7 then
RaceClassChecking=0
ToonClassCheck=ToonClassCheck+1
GuildLeader:ClassControl()
end
elseif UnitFactionGroup("player")=="Horde" then
if ToonRaceClassCheck==1 then
ToonRace = 'r-\"Blood elf\" '
ToonRaceName = 'Blood Elf'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==2 then
ToonRace = 'r-\"Goblin\" '
ToonRaceName = 'Goblin'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==3 then
ToonRace = 'r-\"Orc\" '
ToonRaceName = 'Orc'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==4 then
ToonRace = 'r-\"Tauren\" '
ToonRaceName = 'Tauren'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==5 then
ToonRace = 'r-\"Troll\" '
ToonRaceName = 'Troll'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==6 then
ToonRace = 'r-\"Undead\" '
ToonRaceName = 'Undead'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==7 then
RaceClassChecking=0
ToonClassCheck=ToonClassCheck+1
GuildLeader:ClassControl()
end
end
end

function GuildLeader:DHRaceSearch()
if UnitFactionGroup("player")=="Alliance" then
if ToonRaceClassCheck==1 then
ToonRace = 'r-\"Night elf\" '
ToonRaceName = 'Night elf'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==2 then
RaceClassChecking=0
ToonClassCheck=ToonClassCheck+1
GuildLeader:ClassControl()
end
elseif UnitFactionGroup("player")=="Horde" then
if ToonRaceClassCheck==1 then
ToonRace = 'r-\"Blood elf\" '
ToonRaceName = 'Blood Elf'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==2 then
RaceClassChecking=0
ToonClassCheck=ToonClassCheck+1
GuildLeader:ClassControl()
end
end
end

function GuildLeader:DruidRaceSearch()
if UnitFactionGroup("player")=="Alliance" then
if ToonRaceClassCheck==1 then
ToonRace = 'r-\"Night elf\" '
ToonRaceName = 'Night elf'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==2 then
ToonRace = 'r-\"Worgen\" '
ToonRaceName = 'Worgen'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==3 then
RaceClassChecking=0
ToonClassCheck=ToonClassCheck+1
GuildLeader:ClassControl()
end
elseif UnitFactionGroup("player")=="Horde" then
if ToonRaceClassCheck==1 then
ToonRace = 'r-\"Tauren\" '
ToonRaceName = 'Tauren'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==2 then
ToonRace = 'r-\"Troll\" '
ToonRaceName = 'Troll'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==3 then
RaceClassChecking=0
ToonClassCheck=ToonClassCheck+1
GuildLeader:ClassControl()
end
end
end

function GuildLeader:HunterRaceSearch()
if UnitFactionGroup("player")=="Alliance" then
if ToonRaceClassCheck==1 then
ToonRace = 'r-\"Draenei\" '
ToonRaceName = 'Draenei'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==2 then
ToonRace = 'r-\"Dwarf\" '
ToonRaceName = 'Dwarf'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==3 then
ToonRace = 'r-\"Human\" '
ToonRaceName = 'Human'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==4 then
ToonRace = 'r-\"Night elf\" '
ToonRaceName = 'Night elf'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==5 then
ToonRace = 'r-\"Pandaren\" '
ToonRaceName = 'Pandaren'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==6 then
ToonRace = 'r-\"Worgen\" '
ToonRaceName = 'Worgen'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==7 then
RaceClassChecking=0
ToonClassCheck=ToonClassCheck+1
GuildLeader:ClassControl()
end
elseif UnitFactionGroup("player")=="Horde" then
if ToonRaceClassCheck==1 then
ToonRace = 'r-\"Blood elf\" '
ToonRaceName = 'Blood Elf'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==2 then
ToonRace = 'r-\"Goblin\" '
ToonRaceName = 'Goblin'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==3 then
ToonRace = 'r-\"Orc\" '
ToonRaceName = 'Orc'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==4 then
ToonRace = 'r-\"Pandaren\" '
ToonRaceName = 'Pandaren'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==5 then
ToonRace = 'r-\"Tauren\" '
ToonRaceName = 'Tauren'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==6 then
ToonRace = 'r-\"Troll\" '
ToonRaceName = 'Troll'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==7 then
ToonRace = 'r-\"Undead\" '
ToonRaceName = 'Undead'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==8 then
RaceClassChecking=0
ToonClassCheck=ToonClassCheck+1
GuildLeader:ClassControl()
end
end
end

function GuildLeader:MageRaceSearch()
if UnitFactionGroup("player")=="Alliance" then
if ToonRaceClassCheck==1 then
ToonRace = 'r-\"Draenei\" '
ToonRaceName = 'Draenei'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==2 then
ToonRace = 'r-\"Gnome\" '
ToonRaceName = 'Gnome'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==3 then
ToonRace = 'r-\"Human\" '
ToonRaceName = 'Human'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==4 then
ToonRace = 'r-\"Night elf\" '
ToonRaceName = 'Night elf'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==5 then
ToonRace = 'r-\"Pandaren\" '
ToonRaceName = 'Pandaren'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==6 then
RaceClassChecking=0
ToonClassCheck=ToonClassCheck+1
GuildLeader:ClassControl()
end
elseif UnitFactionGroup("player")=="Horde" then
if ToonRaceClassCheck==1 then
ToonRace = 'r-\"Blood elf\" '
ToonRaceName = 'Blood Elf'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==2 then
ToonRace = 'r-\"Pandaren\" '
ToonRaceName = 'Pandaren'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==3 then
ToonRace = 'r-\"Troll\" '
ToonRaceName = 'Troll'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==4 then
ToonRace = 'r-\"Undead\" '
ToonRaceName = 'Undead'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==5 then
RaceClassChecking=0
ToonClassCheck=ToonClassCheck+1
GuildLeader:ClassControl()
end
end
end

function GuildLeader:MonkRaceSearch()
if UnitFactionGroup("player")=="Alliance" then
if ToonRaceClassCheck==1 then
ToonRace = 'r-\"Draenei\" '
ToonRaceName = 'Draenei'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==2 then
ToonRace = 'r-\"Dwarf\" '
ToonRaceName = 'Dwarf'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==3 then
ToonRace = 'r-\"Gnome\" '
ToonRaceName = 'Gnome'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==4 then
ToonRace = 'r-\"Human\" '
ToonRaceName = 'Human'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==5 then
ToonRace = 'r-\"Night elf\" '
ToonRaceName = 'Night elf'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==6 then
ToonRace = 'r-\"Pandaren\" '
ToonRaceName = 'Pandaren'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==7 then
RaceClassChecking=0
ToonClassCheck=ToonClassCheck+1
GuildLeader:ClassControl()
end
elseif UnitFactionGroup("player")=="Horde" then
if ToonRaceClassCheck==1 then
ToonRace = 'r-\"Blood elf\" '
ToonRaceName = 'Blood Elf'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==2 then
ToonRace = 'r-\"Orc\" '
ToonRaceName = 'Orc'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==3 then
ToonRace = 'r-\"Pandaren\" '
ToonRaceName = 'Pandaren'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==4 then
ToonRace = 'r-\"Tauren\" '
ToonRaceName = 'Tauren'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==5 then
ToonRace = 'r-\"Troll\" '
ToonRaceName = 'Troll'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==6 then
ToonRace = 'r-\"Undead\" '
ToonRaceName = 'Undead'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==7 then
RaceClassChecking=0
ToonClassCheck=ToonClassCheck+1
GuildLeader:ClassControl()
end
end
end

function GuildLeader:PaladinRaceSearch()
if UnitFactionGroup("player")=="Alliance" then
if ToonRaceClassCheck==1 then
ToonRace = 'r-\"Draenei\" '
ToonRaceName = 'Draenei'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==2 then
ToonRace = 'r-\"Dwarf\" '
ToonRaceName = 'Dwarf'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==3 then
ToonRace = 'r-\"Human\" '
ToonRaceName = 'Human'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==4 then
RaceClassChecking=0
ToonClassCheck=ToonClassCheck+1
GuildLeader:ClassControl()
end
elseif UnitFactionGroup("player")=="Horde" then
if ToonRaceClassCheck==1 then
ToonRace = 'r-\"Blood elf\" '
ToonRaceName = 'Blood Elf'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==2 then
ToonRace = 'r-\"Tauren\" '
ToonRaceName = 'Tauren'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==3 then
RaceClassChecking=0
ToonClassCheck=ToonClassCheck+1
GuildLeader:ClassControl()
end
end
end

function GuildLeader:PriestRaceSearch()
if UnitFactionGroup("player")=="Alliance" then
if ToonRaceClassCheck==1 then
ToonRace = 'r-\"Draenei\" '
ToonRaceName = 'Draenei'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==2 then
ToonRace = 'r-\"Dwarf\" '
ToonRaceName = 'Dwarf'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==3 then
ToonRace = 'r-\"Gnome\" '
ToonRaceName = 'Gnome'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==4 then
ToonRace = 'r-\"Human\" '
ToonRaceName = 'Human'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==5 then
ToonRace = 'r-\"Night elf\" '
ToonRaceName = 'Night elf'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==6 then
ToonRace = 'r-\"Pandaren\" '
ToonRaceName = 'Pandaren'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==7 then
ToonRace = 'r-\"Worgen\" '
ToonRaceName = 'Worgen'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==8 then
RaceClassChecking=0
ToonClassCheck=ToonClassCheck+1
GuildLeader:ClassControl()
end
elseif UnitFactionGroup("player")=="Horde" then
if ToonRaceClassCheck==1 then
ToonRace = 'r-\"Blood elf\" '
ToonRaceName = 'Blood Elf'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==2 then
ToonRace = 'r-\"Goblin\" '
ToonRaceName = 'Goblin'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==3 then
ToonRace = 'r-\"Pandaren\" '
ToonRaceName = 'Pandaren'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==4 then
ToonRace = 'r-\"Tauren\" '
ToonRaceName = 'Tauren'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==5 then
ToonRace = 'r-\"Troll\" '
ToonRaceName = 'Troll'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==6 then
ToonRace = 'r-\"Undead\" '
ToonRaceName = 'Undead'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==7 then
RaceClassChecking=0
ToonClassCheck=ToonClassCheck+1
GuildLeader:ClassControl()
end
end
end

function GuildLeader:RogueRaceSearch()
if UnitFactionGroup("player")=="Alliance" then
if ToonRaceClassCheck==1 then
ToonRace = 'r-\"Dwarf\" '
ToonRaceName = 'Dwarf'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==2 then
ToonRace = 'r-\"Gnome\" '
ToonRaceName = 'Gnome'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==3 then
ToonRace = 'r-\"Human\" '
ToonRaceName = 'Human'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==4 then
ToonRace = 'r-\"Night elf\" '
ToonRaceName = 'Night elf'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==5 then
ToonRace = 'r-\"Pandaren\" '
ToonRaceName = 'Pandaren'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==6 then
ToonRace = 'r-\"Worgen\" '
ToonRaceName = 'Worgen'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==7 then
RaceClassChecking=0
ToonClassCheck=ToonClassCheck+1
GuildLeader:ClassControl()
end
elseif UnitFactionGroup("player")=="Horde" then
if ToonRaceClassCheck==1 then
ToonRace = 'r-\"Blood elf\" '
ToonRaceName = 'Blood Elf'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==2 then
ToonRace = 'r-\"Goblin\" '
ToonRaceName = 'Goblin'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==3 then
ToonRace = 'r-\"Orc\" '
ToonRaceName = 'Orc'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==4 then
ToonRace = 'r-\"Pandaren\" '
ToonRaceName = 'Pandaren'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==5 then
ToonRace = 'r-\"Troll\" '
ToonRaceName = 'Troll'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==6 then
ToonRace = 'r-\"Undead\" '
ToonRaceName = 'Undead'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==7 then
RaceClassChecking=0
ToonClassCheck=ToonClassCheck+1
GuildLeader:ClassControl()
end
end
end

function GuildLeader:ShamanRaceSearch()
if UnitFactionGroup("player")=="Alliance" then
if ToonRaceClassCheck==1 then
ToonRace = 'r-\"Draenei\" '
ToonRaceName = 'Draenei'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==2 then
ToonRace = 'r-\"Dwarf\" '
ToonRaceName = 'Dwarf'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==3 then
ToonRace = 'r-\"Pandaren\" '
ToonRaceName = 'Pandaren'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==4 then
RaceClassChecking=0
ToonClassCheck=ToonClassCheck+1
GuildLeader:ClassControl()
end
elseif UnitFactionGroup("player")=="Horde" then
if ToonRaceClassCheck==1 then
ToonRace = 'r-\"Goblin\" '
ToonRaceName = 'Goblin'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==2 then
ToonRace = 'r-\"Orc\" '
ToonRaceName = 'Orc'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==3 then
ToonRace = 'r-\"Pandaren\" '
ToonRaceName = 'Pandaren'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==4 then
ToonRace = 'r-\"Tauren\" '
ToonRaceName = 'Tauren'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==5 then
ToonRace = 'r-\"Troll\" '
ToonRaceName = 'Troll'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==6 then
RaceClassChecking=0
ToonClassCheck=ToonClassCheck+1
GuildLeader:ClassControl()
end
end
end

function GuildLeader:WarlockRaceSearch()
if UnitFactionGroup("player")=="Alliance" then
if ToonRaceClassCheck==1 then
ToonRace = 'r-\"Dwarf\" '
ToonRaceName = 'Dwarf'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==2 then
ToonRace = 'r-\"Gnome\" '
ToonRaceName = 'Gnome'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==3 then
ToonRace = 'r-\"Human\" '
ToonRaceName = 'Human'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==4 then
ToonRace = 'r-\"Night elf\" '
ToonRaceName = 'Night elf'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==5 then
RaceClassChecking=0
ToonClassCheck=ToonClassCheck+1
GuildLeader:ClassControl()
end
elseif UnitFactionGroup("player")=="Horde" then
if ToonRaceClassCheck==1 then
ToonRace = 'r-\"Blood elf\" '
ToonRaceName = 'Blood Elf'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==2 then
ToonRace = 'r-\"Goblin\" '
ToonRaceName = 'Goblin'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==3 then
ToonRace = 'r-\"Orc\" '
ToonRaceName = 'Orc'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==4 then
ToonRace = 'r-\"Troll\" '
ToonRaceName = 'Troll'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==5 then
ToonRace = 'r-\"Undead\" '
ToonRaceName = 'Undead'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==6 then
RaceClassChecking=0
ToonClassCheck=ToonClassCheck+1
GuildLeader:ClassControl()
end
end
end

function GuildLeader:WarriorRaceSearch()
if UnitFactionGroup("player")=="Alliance" then
if ToonRaceClassCheck==1 then
ToonRace = 'r-\"Draenei\" '
ToonRaceName = 'Draenei'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==2 then
ToonRace = 'r-\"Dwarf\" '
ToonRaceName = 'Dwarf'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==3 then
ToonRace = 'r-\"Gnome\" '
ToonRaceName = 'Gnome'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==4 then
ToonRace = 'r-\"Human\" '
ToonRaceName = 'Human'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==5 then
ToonRace = 'r-\"Night elf\" '
ToonRaceName = 'Night elf'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==6 then
ToonRace = 'r-\"Pandaren\" '
ToonRaceName = 'Pandaren'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==7 then
ToonRace = 'r-\"Worgen\" '
ToonRaceName = 'Worgen'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==8 then
RaceClassChecking=0
ToonClassCheck=ToonClassCheck+1
GuildLeader:ClassControl()
end
elseif UnitFactionGroup("player")=="Horde" then
if ToonRaceClassCheck==1 then
ToonRace = 'r-\"Blood elf\" '
ToonRaceName = 'Blood Elf'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==2 then
ToonRace = 'r-\"Goblin\" '
ToonRaceName = 'Goblin'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==3 then
ToonRace = 'r-\"Orc\" '
ToonRaceName = 'Orc'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==4 then
ToonRace = 'r-\"Pandaren\" '
ToonRaceName = 'Pandaren'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==5 then
ToonRace = 'r-\"Tauren\" '
ToonRaceName = 'Tauren'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==6 then
ToonRace = 'r-\"Troll\" '
ToonRaceName = 'Troll'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==7 then
ToonRace = 'r-\"Undead\" '
ToonRaceName = 'Undead'
GuildLeader:SendWhoRaceClass()
elseif ToonRaceClassCheck==8 then
RaceClassChecking=0
ToonClassCheck=ToonClassCheck+1
GuildLeader:ClassControl()
end
end
end

--Types of Who Searches--

function GuildLeader:SendWhoLevel()
--Make sure we aren't halting
if WhoHalt==nil or WhoHalt==0 then
--Make sure we aren't at member capture
if GetNumGuildMembers()<=999 and GuildLeader.db.profile.membercap>GetNumGuildMembers() then
--Check if we have failed
if WhoFailed==1 then
GuildLeader.ScheduleTimer("WhoFailure", 10)
elseif WhoFailed==2 then
GuildLeader:ScheduleTimer("WhoFailure2", 10)
elseif WhoFailed==3 then
GuildLeader:ScheduleTimer("WhoFailure3", 10)
end
--Set up Hiding Who results and hooking our own code.
FriendsFrame:UnregisterEvent("WHO_LIST_UPDATE")
C_FriendList.SetWhoToUi(true)
--Determine what who to send
C_FriendList.SendWho(ToonLevel)
GuildLeader:RegisterEvent("WHO_LIST_UPDATE",function(self, event)
GuildLeader:CheckWho()
end)
end
--We have halted somewhere!
else
GuildLeader:UnregisterEvent("WHO_LIST_UPDATE")
FriendsFrame:RegisterEvent("WHO_LIST_UPDATE")
end
end

function GuildLeader:CheckWho()
	C_GuildInfo.C_GuildInfo.GuildRoster()
	if GetNumGuildMembers()<=999 and GuildLeader.db.profile.membercap>GetNumGuildMembers() then
		local totalcount,numwhos = GetNumWhoResults()
		if totalcount<=49 and LevelChecking==0 and ClassChecking==0 and RaceClassChecking==0 then
			GuildLeader:WhoInvite()
			ToonMaxLevel=ToonMinLevel-1
			--GuildLeader:LevelRangeSearch()
		elseif totalcount<=49 and LevelChecking==1 and ClassChecking==0 and RaceClassChecking==0 then
			GuildLeader:WhoInvite()
			ToonLevelCheck=ToonLevelCheck+1
			--GuildLeader:LevelSearch()
		elseif totalcount<=49 and LevelChecking==1 and ClassChecking==1 and RaceClassChecking==0 then
			GuildLeader:WhoInvite()
			ToonClassCheck=ToonClassCheck+1
			GuildLeader:ClassControl()
		elseif totalcount<=49 and LevelChecking==1 and ClassChecking==1 and RaceClassChecking==1 then
			GuildLeader:WhoInvite()
			ToonRaceClassCheck=ToonRaceClassCheck+1
			GuildLeader:RaceClassControl()
		elseif totalcount==50 and LevelChecking==0 and ClassChecking==0 and RaceClassChecking==0 then
			GuildLeader:WhoInvite()
			ToonLevelCheck=0
			--GuildLeader:LevelSearch()
		elseif totalcount==50 and LevelChecking==1 and ClassChecking==0 and RaceClassChecking==0 then
			GuildLeader:WhoInvite()
			ToonClassCheck=0
			GuildLeader:ClassControl()
		elseif totalcount>=50 and LevelChecking==1 and ClassChecking==1 and RaceClassChecking==0 then
			GuildLeader:WhoInvite()
			ToonRaceClassCheck=0
			GuildLeader:RaceClassControl()
		elseif totalcount>=50 and LevelChecking==1 and ClassChecking==1 and RaceClassChecking==1 then
			GuildLeader:WhoInvite()
			ToonRaceClassCheck=ToonRaceClassCheck+1
			GuildLeader:RaceClassControl()
		elseif totalcount==0 then
			WhoFailed=1
		end
	end
end



function GuildLeader:SendWhoClass()
--Make sure we aren't halting
if WhoHalt==nil or WhoHalt==0 then
	--Make sure we aren't at member capture
	if GetNumGuildMembers()<=999 and GuildLeader.db.profile.membercap>GetNumGuildMembers() then
	--Check if we have failed
	if WhoFailed==1 then
	GuildLeader.ScheduleTimer("WhoFailure", 10)
	elseif WhoFailed==2 then
	GuildLeader:ScheduleTimer("WhoFailure2", 10)
	elseif WhoFailed==3 then
	GuildLeader:ScheduleTimer("WhoFailure3", 10)
	end
	--Set up Hiding Who results and hooking our own code.
	FriendsFrame:UnregisterEvent("WHO_LIST_UPDATE")
	C_FriendList.SetWhoToUi(true)
	--Determine what who to send
	C_FriendList.SendWho(strjoin(" ",ToonLevel,ToonClass))
	GuildLeader:RegisterEvent("WHO_LIST_UPDATE",function(self, event)
	GuildLeader:CheckWho()
	end)
	end
	--We have halted somewhere!
	else
	GuildLeader:UnregisterEvent("WHO_LIST_UPDATE")
	FriendsFrame:RegisterEvent("WHO_LIST_UPDATE")
	end
end

function GuildLeader:SendWhoRaceClass()
--Make sure we aren't halting
if WhoHalt==nil or WhoHalt==0 then
	--Make sure we aren't at member capture
	if GetNumGuildMembers()<=999 and GuildLeader.db.profile.membercap>GetNumGuildMembers() then
	--Check if we have failed
	if WhoFailed==1 then
	GuildLeader.ScheduleTimer("WhoFailure", 10)
	elseif WhoFailed==2 then
	GuildLeader:ScheduleTimer("WhoFailure2", 10)
	elseif WhoFailed==3 then
	GuildLeader:ScheduleTimer("WhoFailure3", 10)
	end
	--Set up Hiding Who results and hooking our own code.
	FriendsFrame:UnregisterEvent("WHO_LIST_UPDATE")
	C_FriendList.SetWhoToUi(true)
	--Determine what who to send
	C_FriendList.SendWho(strjoin(" ",ToonLevel,ToonClass,ToonRace))
	GuildLeader:RegisterEvent("WHO_LIST_UPDATE",function(self, event)
	GuildLeader:CheckWho()
	end)
	end
	--We have halted somewhere!
	else
	GuildLeader:UnregisterEvent("WHO_LIST_UPDATE")
	FriendsFrame:RegisterEvent("WHO_LIST_UPDATE")
	end
end

--WHO FAILURE--
function GuildLeader:WhoFailure()
if WhoReturned==0 then
GuildLeader:Print("ATTENTION: Server did NOT return search results. Sending Again (2nd Attempt)")
WhoFailed=1
if ClassChecking==0 and RaceClassChecking==0 then
GuildLeader:SendWhoLevel()
elseif ClassChecking==1 and RaceClassChecking==0 then
GuildLeader:SendWhoClass()
elseif ClassChecking==1 and RaceClassChecking==1 then
GuildLeader:SendWhoRaceClass()
end
end
end

function GuildLeader:WhoFailure2()
GuildLeader:Print("ATTENTION: Server did NOT return search results. Sending Again (3rd Attempt)")
if ClassChecking==0 and RaceClassChecking==0 then
GuildLeader:SendWhoLevel()
elseif ClassChecking==1 and RaceClassChecking==0 then
GuildLeader:SendWhoClass()
elseif ClassChecking==1 and RaceClassChecking==1 then
GuildLeader:SendWhoRaceClass()
end
end

function GuildLeader:WhoFailure3()
if WhoReturned==0 then
GuildLeader:Print("ATTENTION: Server did NOT return search results. Permanent Failure! Ending Who Recruitment Cycle")
GuildLeader:UnregisterEvent("WHO_LIST_UPDATE")
WhoFailed=3
WhoCycle=0
end
end

--Who Invite Functions--

function GuildLeader:WhoResultsCheck()
C_GuildInfo.GuildRoster()
if GetNumGuildMembers()<=999 and GuildLeader.db.profile.membercap>GetNumGuildMembers() then
local totalcount,numwhos = GetNumWhoResults()
if totalcount<=49 and LevelChecking==0 and ClassChecking==0 and RaceClassChecking==0 then
GuildLeader:WhoInvite()
ToonMaxLevel=ToonMinLevel-1
GuildLeader:LevelRangeSearch()
elseif totalcount<=49 and LevelChecking==1 and ClassChecking==0 and RaceClassChecking==0 then
GuildLeader:WhoInvite()
ToonLevelCheck=ToonLevelCheck+1
GuildLeader:LevelSearch()
elseif totalcount<=49 and LevelChecking==1 and ClassChecking==1 and RaceClassChecking==0 then
GuildLeader:WhoInvite()
ToonClassCheck=ToonClassCheck+1
GuildLeader:ClassControl()
elseif totalcount<=49 and LevelChecking==1 and ClassChecking==1 and RaceClassChecking==1 then
GuildLeader:WhoInvite()
ToonRaceClassCheck=ToonRaceClassCheck+1
GuildLeader:RaceClassControl()
elseif totalcount==50 and LevelChecking==0 and ClassChecking==0 and RaceClassChecking==0 then
GuildLeader:WhoInvite()
ToonLevelCheck=0
GuildLeader:LevelSearch()
elseif totalcount==50 and LevelChecking==1 and ClassChecking==0 and RaceClassChecking==0 then
GuildLeader:WhoInvite()
ToonClassCheck=0
GuildLeader:ClassControl()
elseif totalcount>=50 and LevelChecking==1 and ClassChecking==1 and RaceClassChecking==0 then
GuildLeader:WhoInvite()
ToonRaceClassCheck=0
GuildLeader:RaceClassControl()
elseif totalcount>=50 and LevelChecking==1 and ClassChecking==1 and RaceClassChecking==1 then
GuildLeader:WhoInvite()
ToonRaceClassCheck=ToonRaceClassCheck+1
GuildLeader:RaceClassControl()
elseif totalcount==0 then
WhoFailed=1
end
else
GuildLeader:Print('Character Recruitment Cycle Complete. Guild Population is at Maximum')
LevelChecking=0
ClassChecking=0
RaceClassChecking=0
ToonLevelCheck=0
ToonClassCheck=0
ToonRaceClassCheck=0
WhoCycle=0
end
end

function GuildLeader:WhoInvite()
if GetNumGuildMembers()<=999 and GuildLeader.db.profile.membercap>GetNumGuildMembers() then
freshinvite=0
guildedinvite=0
dnioverrided=0
for i=1,GetNumWhoResults() do local whoname,whoguild,wholevel,whorace,whoclass,whozone,whoclassFileName = GetWhoInfo(i)
if string.match(whoname, "-") then
else
whoname = strjoin("-",whoname,GetRealmName());
end
if GuildLeader.db.profile.targetclass==false or (GuildLeader.db.profile.targetclass==true and GuildLeader.db.profile.DKsearch==true and whoclass=='Death Knight') or (GuildLeader.db.profile.targetclass==true and GuildLeader.db.profile.DHsearch==true and whoclass=='Demon Hunter') or (GuildLeader.db.profile.targetclass==true and GuildLeader.db.profile.Druidsearch==true and whoclass=='Druid') or (GuildLeader.db.profile.targetclass==true and GuildLeader.db.profile.Huntersearch==true and whoclass=='Hunter') or (GuildLeader.db.profile.targetclass==true and GuildLeader.db.profile.Magesearch==true and whoclass=='Mage') or (GuildLeader.db.profile.targetclass==true and GuildLeader.db.profile.Paladinsearch==true and whoclass=='Paladin') or (GuildLeader.db.profile.targetclass==true and GuildLeader.db.profile.Priestsearch==true and whoclass=='Priest') or (GuildLeader.db.profile.targetclass==true and GuildLeader.db.profile.Roguesearch==true and whoclass=='Rogue') or (GuildLeader.db.profile.targetclass==true and GuildLeader.db.profile.Shamansearch==true and whoclass=='Shaman') or (GuildLeader.db.profile.targetclass==true and GuildLeader.db.profile.Warlocksearch==true and whoclass=='Warlock') or (GuildLeader.db.profile.targetclass==true and GuildLeader.db.profile.Warriorsearch==true and whoclass=='Warrior') then
if whoguild=="" then
if CheckTable(GLInstancet, whozone)==0 then
if CheckTable(GuildLeader.db.profile.GLDNIt, whoname)==0 then
if CheckTable(GuildLeader.db.profile.GLBlackt, whoname)==0 then
if whoguild=="" then
if CheckTable(GuildLeader.db.profile.GLIQt, whoname)==0 then
GuildLeader:Print(strjoin(" ",whoname,'is NOT in a Guild! They have been added to the Invite Queue!'))
table.insert(GuildLeader.db.profile.GLIQt, whoname)
GLIQt=GuildLeader.db.profile.GLIQt
pairsByKeysIQ(GLIQt)
end
end
if whoguild~="" then
guildedinvite=guildedinvite+1
end
if CheckTable(GuildLeader.db.profile.GLDNIt, whoname)~=0 then
dnioverrided=dnioverrided+1
end
freshinvite=freshinvite+1
end
end
end
end
end
end

else
GuildLeader:Print('Character Recruitment Cycle Complete. Guild Population is at Maximum')
LevelChecking=0
ClassChecking=0
RaceClassChecking=0
ToonLevelCheck=0
ToonClassCheck=0
ToonRaceClassCheck=0
WhoCycle=0
end
LevelChecking=0
ClassChecking=0
RaceClassChecking=0
ToonLevelCheck=0
ToonClassCheck=0
ToonRaceClassCheck=0
WhoCycle=0
GuildLeader:UnregisterEvent("WHO_LIST_UPDATE")
FriendsFrame:RegisterEvent("WHO_LIST_UPDATE")
GuildLeader:Print('Character Recruitment Cycle Complete. Done Searching')
end

GLInstancet = {}

--Manual Invite Script--
function GuildLeader:InviteAction()
if #(GuildLeader.db.profile.GLIQt)~=0 then
for k,v in pairs(GuildLeader.db.profile.GLIQt) do
if 1==k then
GLIQtop=v
end
if string.match(GLIQtop, "-") then
else
GLIQtop = strjoin("-",GLIQtop,GetRealmName());
end
if CheckTable(GuildLeader.db.profile.GLDNIt, GLIQtop)==0 then
table.insert(GuildLeader.db.profile.GLDNIt, GLIQtop)
GLDNIt=GuildLeader.db.profile.GLDNIt
pairsByKeysDNI(GLDNIt)
end
end
if GuildLeader.db.profile.whisperonly==false then
GuildInvite(GLIQtop)
else
SendChatMessage(GuildLeader.db.profile.whispmessage,"WHISPER",nil,GLIQtop)
end
indexValue=CheckTable(GuildLeader.db.profile.GLIQt, GLIQtop)
RemoveTableValue(GuildLeader.db.profile.GLIQt, indexValue)
else
end
end

--*PRUNING*--
function GuildLeader:GKRun()
if IsGuildLeader()==true or IsGuildLeader()~=true then
C_GuildInfo.GuildRoster()
GuildLeader:GKLevelCalc()
GuildLeader:GKInactivityCalc()
GuildLeader:GKAltExemptTable()
GuildLeader:GKRankExemptTable()
GuildLeader:GKKickTable()
else
GuildLeader:Print('Member Prune Cycle did NOT start! Only Guild Leaders can use this function!')
end
end

--Level and Inactivity Calc--
function GuildLeader:GKLevelCalc()
GKlvl=GuildLeader.db.profile.levelthreshold
GuildLeader:GKByLevelTable()
end

function GuildLeader:GKInactivityCalc()
if GuildLeader.db.profile.daysinactive<=365 and GuildLeader.db.profile.daysinactive>=360 then
GKy=1
GKm=0
GKd=0
GuildLeader:GKParseTime()
GuildLeader:GKByInactivityTable()
elseif GuildLeader.db.profile.daysinactive<360 and GuildLeader.db.profile.daysinactive>=330 then
GKy=0
GKm=11
GKd=GuildLeader.db.profile.daysinactive-(30*11)
GuildLeader:GKParseTime()
GuildLeader:GKByInactivityTable()
elseif GuildLeader.db.profile.daysinactive<330 and GuildLeader.db.profile.daysinactive>=300 then
GKy=0
GKm=10
GKd=GuildLeader.db.profile.daysinactive-(30*10)
GuildLeader:GKParseTime()
GuildLeader:GKByInactivityTable()
elseif GuildLeader.db.profile.daysinactive<300 and GuildLeader.db.profile.daysinactive>=270 then
GKy=0
GKm=9
GKd=GuildLeader.db.profile.daysinactive-(30*9)
GuildLeader:GKParseTime()
GuildLeader:GKByInactivityTable()
elseif GuildLeader.db.profile.daysinactive<270 and GuildLeader.db.profile.daysinactive>=240 then
GKy=0
GKm=8
GKd=GuildLeader.db.profile.daysinactive-(30*8)
GuildLeader:GKParseTime()
GuildLeader:GKByInactivityTable()
elseif GuildLeader.db.profile.daysinactive<240 and GuildLeader.db.profile.daysinactive>=210 then
GKy=0
GKm=7
GKd=GuildLeader.db.profile.daysinactive-(30*7)
GuildLeader:GKParseTime()
GuildLeader:GKByInactivityTable()
elseif GuildLeader.db.profile.daysinactive<210 and GuildLeader.db.profile.daysinactive>=180 then
GKy=0
GKm=6
GKd=GuildLeader.db.profile.daysinactive-(30*6)
GuildLeader:GKParseTime()
GuildLeader:GKByInactivityTable()
elseif GuildLeader.db.profile.daysinactive<180 and GuildLeader.db.profile.daysinactive>=150 then
GKy=0
GKm=5
GKd=GuildLeader.db.profile.daysinactive-(30*5)
GuildLeader:GKParseTime()
GuildLeader:GKByInactivityTable()
elseif GuildLeader.db.profile.daysinactive<150 and GuildLeader.db.profile.daysinactive>=120 then
GKy=0
GKm=4
GKd=GuildLeader.db.profile.daysinactive-(30*4)
GuildLeader:GKParseTime()
GuildLeader:GKByInactivityTable()
elseif GuildLeader.db.profile.daysinactive<120 and GuildLeader.db.profile.daysinactive>=90 then
GKy=0
GKm=3
GKd=GuildLeader.db.profile.daysinactive-(30*3)
GuildLeader:GKParseTime()
GuildLeader:GKByInactivityTable()
elseif GuildLeader.db.profile.daysinactive<90 and GuildLeader.db.profile.daysinactive>=60 then
GKy=0
GKm=2
GKd=GuildLeader.db.profile.daysinactive-(30*2)
GuildLeader:GKParseTime()
GuildLeader:GKByInactivityTable()
elseif GuildLeader.db.profile.daysinactive<60 and GuildLeader.db.profile.daysinactive>=30 then
GKy=0
GKm=1
GKd=GuildLeader.db.profile.daysinactive-30
GuildLeader:GKParseTime()
GuildLeader:GKByInactivityTable()
elseif GuildLeader.db.profile.daysinactive<30 and GuildLeader.db.profile.daysinactive>=1 then
GKy=0
GKm=0
GKd=GuildLeader.db.profile.daysinactive
GuildLeader:GKParseTime()
GuildLeader:GKByInactivityTable()
else
end
end

function GuildLeader:GKParseTime()
if GKm>0 and GKd==0 then
GKm1=GKm
GKd1=GKd
GKm2=GKm
GKd2=GKd
elseif GKm>0 and GKd>0 then
GKm1=GKm
GKd1=GKd
GKm2=GKm+1
GKd2=0
elseif GKm==0 and GKd>0 then
GKm1=GKm
GKd1=GKd
GKm2=GKm+1
GKd2=0
elseif GKy==1 and GKm==0 and GKd==0 then
GKm1=99
GKd1=99
GKm2=99
GKd2=99
else
end
end

--Kick Table Generators--
function GuildLeader:GKByLevelTable()
GKlvlt = {}
for i=1,GetNumGuildMembers(true) do local name,_,_,level = GetGuildRosterInfo(i);
if GuildLeader.db.profile.removelevels==true and level<=GKlvl then 
tinsert(GKlvlt, i);
end
end
end

function GuildLeader:GKByInactivityTable()
GKInactivet = {}
for i=1,GetNumGuildMembers() do local y,m,d=GetGuildRosterLastOnline(i)
if y then
if GuildLeader.db.profile.removeinactive==true and ((y>=0 and m==GKm1 and d>=GKd1) or (y>=0 and m>=GKm2 and d>=GKd2) or (y>=1 and m>=0 and d>=0)) then 
tinsert(GKInactivet, i)
end
end
end
end

--Exemption Table Generators--
function GuildLeader:GKAltExemptTable()
GKAltt = {}
for i=1,GetNumGuildMembers(true) do local name,_,_,_,_,_,note,officer = GetGuildRosterInfo(i);
if GuildLeader.db.profile.exemptalt==true and (string.find(note, "Alt")~=nil or string.find(note, "AlT")~=nil or string.find(note, "ALt")~=nil or string.find(note, "ALT")~=nil or string.find(note, "aLt")~=nil or string.find(note, "aLT")~=nil or string.find(note, "alt")~=nil or string.find(note, "alT")~=nil or string.find(officer, "Alt")~=nil or string.find(officer, "AlT")~=nil or string.find(officer, "ALt")~=nil or string.find(officer, "ALT")~=nil or string.find(officer, "aLt")~=nil or string.find(officer, "aLT")~=nil or string.find(officer, "alt")~=nil or string.find(officer, "alT")~=nil) then 
tinsert(GKAltt, i);
end
end
end

function GuildLeader:GKRankExemptTable()
GKRankt = {}
for i=1,GetNumGuildMembers(true) do local name,rank,rankindex = GetGuildRosterInfo(i);
if GuildLeader.db.profile.exemptranks==true and (rankindex==0 or (GuildLeader.db.profile.exemptrank1==true and rankindex==1) or (GuildLeader.db.profile.exemptrank2==true and rankindex==2) or (GuildLeader.db.profile.exemptrank3==true and rankindex==3) or (GuildLeader.db.profile.exemptrank4==true and rankindex==4) or (GuildLeader.db.profile.exemptrank5==true and rankindex==5) or (GuildLeader.db.profile.exemptrank6==true and rankindex==6) or (GuildLeader.db.profile.exemptrank7==true and rankindex==7) or (GuildLeader.db.profile.exemptrank8==true and rankindex==8) or (GuildLeader.db.profile.exemptrank9==true and rankindex==9)) then 
tinsert(GKRankt, i);
end
end
end


--Kick Functions--
function GuildLeader:GKKickTable()
GKKickt = {}
blacklistkick=0
inactivekick=0
lowlevelkick=0
lowinactivekick=0
removeprunednil=0
for i=1,GetNumGuildMembers(true) do local name,_,_,level = GetGuildRosterInfo(i);
if CheckTable(GuildLeader.db.profile.GLBlackt, name)~=0 then
table.insert(GKKickt, name)
blacklistkick=blacklistkick+1
end
if CheckTable(GKAltt, i)==0 and CheckTable(GKRankt, i)==0 and CheckTable(GKKickt, name)==0 and CheckTable(GuildLeader.db.profile.GLPruneExemptt, name)==0 then
if CheckTable(GKInactivet, i)~=0 and GuildLeader.db.profile.removelevels==false then
table.insert(GKKickt, name)
inactivekick=inactivekick+1
elseif CheckTable(GKlvlt, i)~=0 and GuildLeader.db.profile.removeinactive==false then
table.insert(GKKickt, name)
lowlevelkick=lowlevelkick+1
elseif CheckTable(GKlvlt, i)~=0 and CheckTable(GKInactivet, i)~=0 then
table.insert(GKKickt, name)
lowinactivekick=lowinactivekick+1
end
end
end
for k,v in pairs(GKKickt) do 
indexValue=CheckTable(GuildLeader.db.profile.GLDNIt, v)
if indexValue~=0 and GuildLeader.db.profile.removefromdnil==true then
RemoveTableValue(GuildLeader.db.profile.GLDNIt, indexValue)
GLDNIt=GuildLeader.db.profile.GLDNIt
pairsByKeysDNI(GLDNIt)
removeprunednil=removeprunednil+1
end
GuildUninvite(v) 
end
if GuildLeader.db.profile.pruneannounce==3 then
GuildLeader:GKKickStatsGuildAnnounce()
end
if GuildLeader.db.profile.pruneannounce==2 then
GuildLeader:GKKickStatsOfficerAnnounce()
end
end

function GuildLeader:GKKickStatsGuildAnnounce()
if removeprunednil>0 then
SendChatMessage(strjoin(" ",removeprunednil,"members were removed from the Do Not Invite List"),"guild", nil,"GUILD")
end
if blacklistkick>0 then
SendChatMessage(strjoin(" ",blacklistkick,"members were removed from the guild because they were on the black list!"),"guild", nil,"GUILD")
end
if inactivekick>0 then
SendChatMessage(strjoin(" ",inactivekick,"members were removed from the guild because they were offline for",GuildLeader.db.profile.daysinactive,"or more consecutive days!"),"guild", nil,"GUILD")
end
if lowlevelkick>0 then
SendChatMessage(strjoin(" ",lowlevelkick,"members were removed from the guild because they were at or below level",GuildLeader.db.profile.levelthreshold,"!"),"guild", nil,"GUILD")
end
if lowinactivekick>0 then
SendChatMessage(strjoin(" ",lowinactivekick,"members were removed from the guild because they were offline for",GuildLeader.db.profile.daysinactive,"or more consecutive days AND they were at or below level",GuildLeader.db.profile.levelthreshold,"!"),"guild", nil,"GUILD")
end
end

function GuildLeader:GKKickStatsOfficerAnnounce()
if removeprunednil>0 then
SendChatMessage(strjoin(" ",removeprunednil,"members were removed from the Do Not Invite List"),"officer", nil,"OFFICER")
end
if blacklistkick>0 then
SendChatMessage(strjoin(" ",blacklistkick,"members were removed from the guild because they were on the black list!"),"officer", nil,"OFFICER")
end
if inactivekick>0 then
SendChatMessage(strjoin(" ",inactivekick,"members were removed from the guild because they were offline for",GuildLeader.db.profile.daysinactive,"or more consecutive days!"),"officer", nil,"OFFICER")
end
if lowlevelkick>0 then
SendChatMessage(strjoin(" ",lowlevelkick,"members were removed from the guild because they were at or below level",GuildLeader.db.profile.levelthreshold,"!"),"officer", nil,"OFFICER")
end
if lowinactivekick>0 then
SendChatMessage(strjoin(" ",lowinactivekick,"members were removed from the guild because they were offline for",GuildLeader.db.profile.daysinactive,"or more consecutive days AND they were at or below level",GuildLeader.db.profile.levelthreshold,"!"),"officer", nil,"OFFICER")
end
end


--*PROMOTION*--
function GuildLeader:GLPromoteErrorChecking()
GuildLeader:GLPromoteErrorCheckingLevel()
end

--BY LEVEL--
function GuildLeader:GLPromoteErrorCheckingLevel()
if IsGuildLeader()==true or IsGuildLeader()~=true then
GPERROR=0
if GuildLeader.db.profile.rank1promote==true then
if GuildLeader.db.profile.rank1level==GuildLeader.db.profile.rank2level and GuildLeader.db.profile.rank2promote==true then
GPERROR=1
end
if GuildLeader.db.profile.rank1level==GuildLeader.db.profile.rank3level and GuildLeader.db.profile.rank3promote==true then
GPERROR=1
end
if GuildLeader.db.profile.rank1level==GuildLeader.db.profile.rank4level and GuildLeader.db.profile.rank4promote==true then
GPERROR=1
end
if GuildLeader.db.profile.rank1level==GuildLeader.db.profile.rank5level and GuildLeader.db.profile.rank5promote==true then
GPERROR=1
end
if GuildLeader.db.profile.rank1level==GuildLeader.db.profile.rank6level and GuildLeader.db.profile.rank6promote==true then
GPERROR=1
end
if GuildLeader.db.profile.rank1level==GuildLeader.db.profile.rank7level and GuildLeader.db.profile.rank7promote==true then
GPERROR=1
end
if GuildLeader.db.profile.rank1level==GuildLeader.db.profile.rank8level and GuildLeader.db.profile.rank8promote==true then
GPERROR=1
end
end
if GuildLeader.db.profile.rank2promote==true then
if GuildLeader.db.profile.rank2level==GuildLeader.db.profile.rank3level and GuildLeader.db.profile.rank3promote==true then
GPERROR=1
end
if GuildLeader.db.profile.rank2level==GuildLeader.db.profile.rank4level and GuildLeader.db.profile.rank4promote==true then
GPERROR=1
end
if GuildLeader.db.profile.rank2level==GuildLeader.db.profile.rank5level and GuildLeader.db.profile.rank5promote==true then
GPERROR=1
end
if GuildLeader.db.profile.rank2level==GuildLeader.db.profile.rank6level and GuildLeader.db.profile.rank6promote==true then
GPERROR=1
end
if GuildLeader.db.profile.rank2level==GuildLeader.db.profile.rank7level and GuildLeader.db.profile.rank7promote==true then
GPERROR=1
end
if GuildLeader.db.profile.rank2level==GuildLeader.db.profile.rank8level and GuildLeader.db.profile.rank8promote==true then
GPERROR=1
end
end
if GuildLeader.db.profile.rank3promote==true then
if GuildLeader.db.profile.rank3level==GuildLeader.db.profile.rank4level and GuildLeader.db.profile.rank4promote==true then
GPERROR=1
end
if GuildLeader.db.profile.rank3level==GuildLeader.db.profile.rank5level and GuildLeader.db.profile.rank5promote==true then
GPERROR=1
end
if GuildLeader.db.profile.rank3level==GuildLeader.db.profile.rank6level and GuildLeader.db.profile.rank6promote==true then
GPERROR=1
end
if GuildLeader.db.profile.rank3level==GuildLeader.db.profile.rank7level and GuildLeader.db.profile.rank7promote==true then
GPERROR=1
end
if GuildLeader.db.profile.rank3level==GuildLeader.db.profile.rank8level and GuildLeader.db.profile.rank8promote==true then
GPERROR=1
end
end
if GuildLeader.db.profile.rank4promote==true then
if GuildLeader.db.profile.rank4level==GuildLeader.db.profile.rank5level and GuildLeader.db.profile.rank5promote==true then
GPERROR=1
end
if GuildLeader.db.profile.rank4level==GuildLeader.db.profile.rank6level and GuildLeader.db.profile.rank6promote==true then
GPERROR=1
end
if GuildLeader.db.profile.rank4level==GuildLeader.db.profile.rank7level and GuildLeader.db.profile.rank7promote==true then
GPERROR=1
end
if GuildLeader.db.profile.rank4level==GuildLeader.db.profile.rank8level and GuildLeader.db.profile.rank8promote==true then
GPERROR=1
end
end
if GuildLeader.db.profile.rank5promote==true then
if GuildLeader.db.profile.rank5level==GuildLeader.db.profile.rank6level and GuildLeader.db.profile.rank6promote==true then
GPERROR=1
end
if GuildLeader.db.profile.rank5level==GuildLeader.db.profile.rank7level and GuildLeader.db.profile.rank7promote==true then
GPERROR=1
end
if GuildLeader.db.profile.rank5level==GuildLeader.db.profile.rank8level and GuildLeader.db.profile.rank8promote==true then
GPERROR=1
end
end
if GuildLeader.db.profile.rank6promote==true then
if GuildLeader.db.profile.rank6level==GuildLeader.db.profile.rank7level and GuildLeader.db.profile.rank7promote==true then
GPERROR=1
end
if GuildLeader.db.profile.rank6level==GuildLeader.db.profile.rank8level and GuildLeader.db.profile.rank8promote==true then
GPERROR=1
end
end
if GuildLeader.db.profile.rank7promote==true then
if GuildLeader.db.profile.rank7level==GuildLeader.db.profile.rank8level and GuildLeader.db.profile.rank8promote==true then
GPERROR=1
end
end
GuildLeader:GLPromoteLevel()
else
GuildLeader:Print('Member Promotion Cycle did NOT start! Only Guild Leaders can use this function!')
end
end

function GuildLeader:GLPromoteLevel()
C_GuildInfo.GuildRoster()
if GPERROR~=1 then
ANNOUNCErank1promote=0
ANNOUNCErank2promote=0
ANNOUNCErank3promote=0
ANNOUNCErank3promote=0
ANNOUNCErank4promote=0
ANNOUNCErank5promote=0
ANNOUNCErank6promote=0
ANNOUNCErank7promote=0
ANNOUNCErank8promote=0
ANNOUNCErankdemote=0
C_GuildInfo.GuildRoster()
for i=1,GetNumGuildMembers(true) do local name,rankn,ranki,level = GetGuildRosterInfo(i);
if (GuildLeader.db.profile.rank1promotesearch==true and ranki+1==2) or (GuildLeader.db.profile.rank2promotesearch==true and ranki+1==3) or (GuildLeader.db.profile.rank3promotesearch==true and ranki+1==4) or (GuildLeader.db.profile.rank4promotesearch==true and ranki+1==5) or (GuildLeader.db.profile.rank5promotesearch==true and ranki+1==6) or (GuildLeader.db.profile.rank6promotesearch==true and ranki+1==7) or (GuildLeader.db.profile.rank7promotesearch==true and ranki+1==8) or (GuildLeader.db.profile.rank8promotesearch==true and ranki+1==9) or (GuildLeader.db.profile.rank9promotesearch==true and ranki+1==10) then
if GuildLeader.db.profile.rank1promote==true and level/GuildLeader.db.profile.rank1level>=1 and IsGuildRankAssignmentAllowed(ranki,2)==true then
if level/GuildLeader.db.profile.rank2level<1 or level/GuildLeader.db.profile.rank2level>level/GuildLeader.db.profile.rank1level or GuildLeader.db.profile.rank2promote~=true or GuildControlGetNumGuildRanks()<3 then
if level/GuildLeader.db.profile.rank3level<1 or level/GuildLeader.db.profile.rank3level>level/GuildLeader.db.profile.rank1level or GuildLeader.db.profile.rank3promote~=true or GuildControlGetNumGuildRanks()<4 then
if level/GuildLeader.db.profile.rank4level<1 or level/GuildLeader.db.profile.rank4level>level/GuildLeader.db.profile.rank1level or GuildLeader.db.profile.rank4promote~=true or GuildControlGetNumGuildRanks()<5 then
if level/GuildLeader.db.profile.rank5level<1 or level/GuildLeader.db.profile.rank5level>level/GuildLeader.db.profile.rank1level or GuildLeader.db.profile.rank5promote~=true or GuildControlGetNumGuildRanks()<6 then
if level/GuildLeader.db.profile.rank6level<1 or level/GuildLeader.db.profile.rank6level>level/GuildLeader.db.profile.rank1level or GuildLeader.db.profile.rank6promote~=true or GuildControlGetNumGuildRanks()<7 then
if level/GuildLeader.db.profile.rank7level<1 or level/GuildLeader.db.profile.rank7level>level/GuildLeader.db.profile.rank1level or GuildLeader.db.profile.rank7promote~=true or GuildControlGetNumGuildRanks()<8 then
if level/GuildLeader.db.profile.rank8level<1 or level/GuildLeader.db.profile.rank8level>level/GuildLeader.db.profile.rank1level or GuildLeader.db.profile.rank8promote~=true or GuildControlGetNumGuildRanks()<9 then
SetGuildMemberRank(i,2)
if ranki+1>2 then
ANNOUNCErank1promote=ANNOUNCErank1promote+1
end
end
end
end
end
end
end
end
end
if GuildLeader.db.profile.rank2promote==true and level/GuildLeader.db.profile.rank2level>=1 and GuildControlGetNumRanks()>3 and IsGuildRankAssignmentAllowed(ranki,3)==true and (ranki+1>3 or (ranki+1<3 and GuildLeader.db.profile.demotemode==true and CheckTable(GuildLeader.db.profile.GLDemoteExemptt, name)==0)) then
if level/GuildLeader.db.profile.rank1level<1 or level/GuildLeader.db.profile.rank1level>level/GuildLeader.db.profile.rank2level or GuildLeader.db.profile.rank1promote~=true then
if level/GuildLeader.db.profile.rank3level<1 or level/GuildLeader.db.profile.rank3level>level/GuildLeader.db.profile.rank2level or GuildLeader.db.profile.rank3promote~=true or GuildControlGetNumGuildRanks()<4 then
if level/GuildLeader.db.profile.rank4level<1 or level/GuildLeader.db.profile.rank4level>level/GuildLeader.db.profile.rank2level or GuildLeader.db.profile.rank4promote~=true or GuildControlGetNumGuildRanks()<5 then
if level/GuildLeader.db.profile.rank5level<1 or level/GuildLeader.db.profile.rank5level>level/GuildLeader.db.profile.rank2level or GuildLeader.db.profile.rank5promote~=true or GuildControlGetNumGuildRanks()<6 then
if level/GuildLeader.db.profile.rank6level<1 or level/GuildLeader.db.profile.rank6level>level/GuildLeader.db.profile.rank2level or GuildLeader.db.profile.rank6promote~=true or GuildControlGetNumGuildRanks()<7 then
if level/GuildLeader.db.profile.rank7level<1 or level/GuildLeader.db.profile.rank7level>level/GuildLeader.db.profile.rank2level or GuildLeader.db.profile.rank7promote~=true or GuildControlGetNumGuildRanks()<8 then
if level/GuildLeader.db.profile.rank8level<1 or level/GuildLeader.db.profile.rank8level>level/GuildLeader.db.profile.rank2level or GuildLeader.db.profile.rank8promote~=true or GuildControlGetNumGuildRanks()<9 then
SetGuildMemberRank(i,3)
if ranki+1>3 then
ANNOUNCErank2promote=ANNOUNCErank2promote+1
end
if ranki+1<3 then
ANNOUNCErankdemote=ANNOUNCErankdemote+1
end
end
end
end
end
end
end
end
end
if GuildLeader.db.profile.rank3promote==true and level/GuildLeader.db.profile.rank3level>=1 and GuildControlGetNumRanks()>4 and IsGuildRankAssignmentAllowed(ranki,4)==true and (ranki+1>4 or (ranki+1<4 and GuildLeader.db.profile.demotemode==true and CheckTable(GuildLeader.db.profile.GLDemoteExemptt, name)==0)) then
if level/GuildLeader.db.profile.rank2level<1 or level/GuildLeader.db.profile.rank2level>level/GuildLeader.db.profile.rank3level or GuildLeader.db.profile.rank2promote~=true then
if level/GuildLeader.db.profile.rank1level<1 or level/GuildLeader.db.profile.rank1level>level/GuildLeader.db.profile.rank3level or GuildLeader.db.profile.rank1promote~=true then
if level/GuildLeader.db.profile.rank4level<1 or level/GuildLeader.db.profile.rank4level>level/GuildLeader.db.profile.rank3level or GuildLeader.db.profile.rank4promote~=true or GuildControlGetNumGuildRanks()<5 then
if level/GuildLeader.db.profile.rank5level<1 or level/GuildLeader.db.profile.rank5level>level/GuildLeader.db.profile.rank3level or GuildLeader.db.profile.rank5promote~=true or GuildControlGetNumGuildRanks()<6 then
if level/GuildLeader.db.profile.rank6level<1 or level/GuildLeader.db.profile.rank6level>level/GuildLeader.db.profile.rank3level or GuildLeader.db.profile.rank6promote~=true or GuildControlGetNumGuildRanks()<7 then
if level/GuildLeader.db.profile.rank7level<1 or level/GuildLeader.db.profile.rank7level>level/GuildLeader.db.profile.rank3level or GuildLeader.db.profile.rank7promote~=true or GuildControlGetNumGuildRanks()<8 then
if level/GuildLeader.db.profile.rank8level<1 or level/GuildLeader.db.profile.rank8level>level/GuildLeader.db.profile.rank3level or GuildLeader.db.profile.rank8promote~=true or GuildControlGetNumGuildRanks()<9 then
SetGuildMemberRank(i,4)
if ranki+1>4 then
ANNOUNCErank3promote=ANNOUNCErank3promote+1
end
if ranki+1<4 then
ANNOUNCErankdemote=ANNOUNCErankdemote+1
end
end
end
end
end
end
end
end
end
if GuildLeader.db.profile.rank4promote==true and level/GuildLeader.db.profile.rank4level>=1 and GuildControlGetNumRanks()>5 and IsGuildRankAssignmentAllowed(ranki,5)==true and (ranki+1>5 or (ranki+1<5 and GuildLeader.db.profile.demotemode==true and CheckTable(GuildLeader.db.profile.GLDemoteExemptt, name)==0)) then
if level/GuildLeader.db.profile.rank2level<1 or level/GuildLeader.db.profile.rank2level>level/GuildLeader.db.profile.rank4level or GuildLeader.db.profile.rank2promote~=true then
if level/GuildLeader.db.profile.rank3level<1 or level/GuildLeader.db.profile.rank3level>level/GuildLeader.db.profile.rank4level or GuildLeader.db.profile.rank3promote~=true then
if level/GuildLeader.db.profile.rank1level<1 or level/GuildLeader.db.profile.rank1level>level/GuildLeader.db.profile.rank4level or GuildLeader.db.profile.rank1promote~=true then
if level/GuildLeader.db.profile.rank5level<1 or level/GuildLeader.db.profile.rank5level>level/GuildLeader.db.profile.rank4level or GuildLeader.db.profile.rank5promote~=true or GuildControlGetNumGuildRanks()<6 then
if level/GuildLeader.db.profile.rank6level<1 or level/GuildLeader.db.profile.rank6level>level/GuildLeader.db.profile.rank4level or GuildLeader.db.profile.rank6promote~=true or GuildControlGetNumGuildRanks()<7 then
if level/GuildLeader.db.profile.rank7level<1 or level/GuildLeader.db.profile.rank7level>level/GuildLeader.db.profile.rank4level or GuildLeader.db.profile.rank7promote~=true or GuildControlGetNumGuildRanks()<8 then
if level/GuildLeader.db.profile.rank8level<1 or level/GuildLeader.db.profile.rank8level>level/GuildLeader.db.profile.rank4level or GuildLeader.db.profile.rank8promote~=true or GuildControlGetNumGuildRanks()<9 then
SetGuildMemberRank(i,5)
if ranki+1>5 then
ANNOUNCErank4promote=ANNOUNCErank4promote+1
end
if ranki+1<5 then
ANNOUNCErankdemote=ANNOUNCErankdemote+1
end
end
end
end
end
end
end
end
end
if GuildLeader.db.profile.rank5promote==true and level/GuildLeader.db.profile.rank5level>=1 and GuildControlGetNumRanks()>6 and IsGuildRankAssignmentAllowed(ranki,6)==true and (ranki+1>6 or (ranki+1<6 and GuildLeader.db.profile.demotemode==true and CheckTable(GuildLeader.db.profile.GLDemoteExemptt, name)==0)) then
if level/GuildLeader.db.profile.rank2level<1 or level/GuildLeader.db.profile.rank2level>level/GuildLeader.db.profile.rank5level or GuildLeader.db.profile.rank2promote~=true then
if level/GuildLeader.db.profile.rank3level<1 or level/GuildLeader.db.profile.rank3level>level/GuildLeader.db.profile.rank5level or GuildLeader.db.profile.rank3promote~=true then
if level/GuildLeader.db.profile.rank4level<1 or level/GuildLeader.db.profile.rank4level>level/GuildLeader.db.profile.rank5level or GuildLeader.db.profile.rank4promote~=true then
if level/GuildLeader.db.profile.rank1level<1 or level/GuildLeader.db.profile.rank1level>level/GuildLeader.db.profile.rank5level or GuildLeader.db.profile.rank1promote~=true then
if level/GuildLeader.db.profile.rank6level<1 or level/GuildLeader.db.profile.rank6level>level/GuildLeader.db.profile.rank5level or GuildLeader.db.profile.rank6promote~=true or GuildControlGetNumGuildRanks()<7 then
if level/GuildLeader.db.profile.rank7level<1 or level/GuildLeader.db.profile.rank7level>level/GuildLeader.db.profile.rank5level or GuildLeader.db.profile.rank7promote~=true or GuildControlGetNumGuildRanks()<8 then
if level/GuildLeader.db.profile.rank8level<1 or level/GuildLeader.db.profile.rank8level>level/GuildLeader.db.profile.rank5level or GuildLeader.db.profile.rank8promote~=true or GuildControlGetNumGuildRanks()<9 then
SetGuildMemberRank(i,6)
if ranki+1>6 then
ANNOUNCErank5promote=ANNOUNCErank5promote+1
end
if ranki+1<6 then
ANNOUNCErankdemote=ANNOUNCErankdemote+1
end
end
end
end
end
end
end
end
end
if GuildLeader.db.profile.rank6promote==true and level/GuildLeader.db.profile.rank6level>=1 and GuildControlGetNumRanks()>7 and IsGuildRankAssignmentAllowed(ranki,7)==true and (ranki+1>7 or (ranki+1<7 and GuildLeader.db.profile.demotemode==true and CheckTable(GuildLeader.db.profile.GLDemoteExemptt, name)==0)) then
if level/GuildLeader.db.profile.rank2level<1 or level/GuildLeader.db.profile.rank2level>level/GuildLeader.db.profile.rank6level or GuildLeader.db.profile.rank2promote~=true then
if level/GuildLeader.db.profile.rank3level<1 or level/GuildLeader.db.profile.rank3level>level/GuildLeader.db.profile.rank6level or GuildLeader.db.profile.rank3promote~=true then
if level/GuildLeader.db.profile.rank4level<1 or level/GuildLeader.db.profile.rank4level>level/GuildLeader.db.profile.rank6level or GuildLeader.db.profile.rank4promote~=true then
if level/GuildLeader.db.profile.rank5level<1 or level/GuildLeader.db.profile.rank5level>level/GuildLeader.db.profile.rank6level or GuildLeader.db.profile.rank5promote~=true then
if level/GuildLeader.db.profile.rank1level<1 or level/GuildLeader.db.profile.rank1level>level/GuildLeader.db.profile.rank6level or GuildLeader.db.profile.rank1promote~=true then
if level/GuildLeader.db.profile.rank7level<1 or level/GuildLeader.db.profile.rank7level>level/GuildLeader.db.profile.rank6level or GuildLeader.db.profile.rank7promote~=true or GuildControlGetNumGuildRanks()<8 then
if level/GuildLeader.db.profile.rank8level<1 or level/GuildLeader.db.profile.rank8level>level/GuildLeader.db.profile.rank6level or GuildLeader.db.profile.rank8promote~=true or GuildControlGetNumGuildRanks()<9 then
SetGuildMemberRank(i,7)
if ranki+1>7 then
ANNOUNCErank6promote=ANNOUNCErank6promote+1
end
if ranki+1<7 then
ANNOUNCErankdemote=ANNOUNCErankdemote+1
end
end
end
end
end
end
end
end
end
if GuildLeader.db.profile.rank7promote==true and level/GuildLeader.db.profile.rank7level>=1 and GuildControlGetNumRanks()>8 and IsGuildRankAssignmentAllowed(ranki,8)==true and (ranki+1>8 or (ranki+1<8 and GuildLeader.db.profile.demotemode==true and CheckTable(GuildLeader.db.profile.GLDemoteExemptt, name)==0)) then
if level/GuildLeader.db.profile.rank2level<1 or level/GuildLeader.db.profile.rank2level>level/GuildLeader.db.profile.rank7level or GuildLeader.db.profile.rank2promote~=true then
if level/GuildLeader.db.profile.rank3level<1 or level/GuildLeader.db.profile.rank3level>level/GuildLeader.db.profile.rank7level or GuildLeader.db.profile.rank3promote~=true then
if level/GuildLeader.db.profile.rank4level<1 or level/GuildLeader.db.profile.rank4level>level/GuildLeader.db.profile.rank7level or GuildLeader.db.profile.rank4promote~=true then
if level/GuildLeader.db.profile.rank5level<1 or level/GuildLeader.db.profile.rank5level>level/GuildLeader.db.profile.rank7level or GuildLeader.db.profile.rank5promote~=true then
if level/GuildLeader.db.profile.rank6level<1 or level/GuildLeader.db.profile.rank6level>level/GuildLeader.db.profile.rank7level or GuildLeader.db.profile.rank6promote~=true then
if level/GuildLeader.db.profile.rank1level<1 or level/GuildLeader.db.profile.rank1level>level/GuildLeader.db.profile.rank7level or GuildLeader.db.profile.rank1promote~=true then
if level/GuildLeader.db.profile.rank8level<1 or level/GuildLeader.db.profile.rank8level>level/GuildLeader.db.profile.rank7level or GuildLeader.db.profile.rank8promote~=true or GuildControlGetNumGuildRanks()<9 then
SetGuildMemberRank(i,8)
if ranki+1>8 then
ANNOUNCErank7promote=ANNOUNCErank7promote+1
end
if ranki+1<8 then
ANNOUNCErankdemote=ANNOUNCErankdemote+1
end
end
end
end
end
end
end
end
end
if GuildLeader.db.profile.rank8promote==true and level/GuildLeader.db.profile.rank8level>=1 and GuildControlGetNumRanks()>9 and IsGuildRankAssignmentAllowed(ranki,9)==true and (ranki+1>9 or (ranki+1<9 and GuildLeader.db.profile.demotemode==true and CheckTable(GuildLeader.db.profile.GLDemoteExemptt, name)==0)) then
if level/GuildLeader.db.profile.rank2level<1 or level/GuildLeader.db.profile.rank2level>level/GuildLeader.db.profile.rank8level or GuildLeader.db.profile.rank2promote~=true then
if level/GuildLeader.db.profile.rank3level<1 or level/GuildLeader.db.profile.rank3level>level/GuildLeader.db.profile.rank8level or GuildLeader.db.profile.rank3promote~=true then
if level/GuildLeader.db.profile.rank4level<1 or level/GuildLeader.db.profile.rank4level>level/GuildLeader.db.profile.rank8level or GuildLeader.db.profile.rank4promote~=true then
if level/GuildLeader.db.profile.rank5level<1 or level/GuildLeader.db.profile.rank5level>level/GuildLeader.db.profile.rank8level or GuildLeader.db.profile.rank5promote~=true then
if level/GuildLeader.db.profile.rank6level<1 or level/GuildLeader.db.profile.rank6level>level/GuildLeader.db.profile.rank8level or GuildLeader.db.profile.rank6promote~=true then
if level/GuildLeader.db.profile.rank7level<1 or level/GuildLeader.db.profile.rank7level>level/GuildLeader.db.profile.rank8level or GuildLeader.db.profile.rank7promote~=true then
if level/GuildLeader.db.profile.rank1level<1 or level/GuildLeader.db.profile.rank1level>level/GuildLeader.db.profile.rank8level or GuildLeader.db.profile.rank1promote~=true then
SetGuildMemberRank(i,9)
if ranki+1>9 then
ANNOUNCErank8promote=ANNOUNCErank8promote+1
end
if ranki+1<9 then
ANNOUNCErankdemote=ANNOUNCErankdemote+1
end
end
end
end
end
end
end
end
end
if GuildControlGetNumRanks()==10 and ranki+1<10 and IsGuildRankAssignmentAllowed(ranki,10)==true and GuildLeader.db.profile.demotemode==true and CheckTable(GuildLeader.db.profile.GLDemoteExemptt, name)==0 then
if level/GuildLeader.db.profile.rank1level<1 or GuildLeader.db.profile.rank1promote~=true then
if level/GuildLeader.db.profile.rank2level<1 or GuildLeader.db.profile.rank2promote~=true then
if level/GuildLeader.db.profile.rank3level<1 or GuildLeader.db.profile.rank3promote~=true then
if level/GuildLeader.db.profile.rank4level<1 or GuildLeader.db.profile.rank4promote~=true then
if level/GuildLeader.db.profile.rank5level<1 or GuildLeader.db.profile.rank5promote~=true then
if level/GuildLeader.db.profile.rank6level<1 or GuildLeader.db.profile.rank6promote~=true then
if level/GuildLeader.db.profile.rank7level<1 or GuildLeader.db.profile.rank7promote~=true then
if level/GuildLeader.db.profile.rank8level<1 or GuildLeader.db.profile.rank8promote~=true then
SetGuildMemberRank(i,10)
if ranki+1<10 then
ANNOUNCErankdemote=ANNOUNCErankdemote+1
end
end
end
end
end
end
end
end
end
end
if GuildControlGetNumRanks()==9 and ranki+1<9 and IsGuildRankAssignmentAllowed(ranki,9)==true and GuildLeader.db.profile.demotemode==true and CheckTable(GuildLeader.db.profile.GLDemoteExemptt, name)==0 then
if level/GuildLeader.db.profile.rank1level<1 or GuildLeader.db.profile.rank1promote~=true then
if level/GuildLeader.db.profile.rank2level<1 or GuildLeader.db.profile.rank2promote~=true then
if level/GuildLeader.db.profile.rank3level<1 or GuildLeader.db.profile.rank3promote~=true then
if level/GuildLeader.db.profile.rank4level<1 or GuildLeader.db.profile.rank4promote~=true then
if level/GuildLeader.db.profile.rank5level<1 or GuildLeader.db.profile.rank5promote~=true then
if level/GuildLeader.db.profile.rank6level<1 or GuildLeader.db.profile.rank6promote~=true then
if level/GuildLeader.db.profile.rank7level<1 or GuildLeader.db.profile.rank7promote~=true then
SetGuildMemberRank(i,9)
if ranki+1<9 then
ANNOUNCErankdemote=ANNOUNCErankdemote+1
end
end
end
end
end
end
end
end
end
if GuildControlGetNumRanks()==8 and ranki+1<8 and IsGuildRankAssignmentAllowed(ranki,8)==true and GuildLeader.db.profile.demotemode==true and CheckTable(GuildLeader.db.profile.GLDemoteExemptt, name)==0 then
if level/GuildLeader.db.profile.rank1level<1 or GuildLeader.db.profile.rank1promote~=true then
if level/GuildLeader.db.profile.rank2level<1 or GuildLeader.db.profile.rank2promote~=true then
if level/GuildLeader.db.profile.rank3level<1 or GuildLeader.db.profile.rank3promote~=true then
if level/GuildLeader.db.profile.rank4level<1 or GuildLeader.db.profile.rank4promote~=true then
if level/GuildLeader.db.profile.rank5level<1 or GuildLeader.db.profile.rank5promote~=true then
if level/GuildLeader.db.profile.rank6level<1 or GuildLeader.db.profile.rank6promote~=true then
SetGuildMemberRank(i,8)
if ranki+1<8 then
ANNOUNCErankdemote=ANNOUNCErankdemote+1
end
end
end
end
end
end
end
end
if GuildControlGetNumRanks()==7 and ranki+1<7 and IsGuildRankAssignmentAllowed(ranki,7)==true and GuildLeader.db.profile.demotemode==true and CheckTable(GuildLeader.db.profile.GLDemoteExemptt, name)==0 then
if level/GuildLeader.db.profile.rank1level<1 or GuildLeader.db.profile.rank1promote~=true then
if level/GuildLeader.db.profile.rank2level<1 or GuildLeader.db.profile.rank2promote~=true then
if level/GuildLeader.db.profile.rank3level<1 or GuildLeader.db.profile.rank3promote~=true then
if level/GuildLeader.db.profile.rank4level<1 or GuildLeader.db.profile.rank4promote~=true then
if level/GuildLeader.db.profile.rank5level<1 or GuildLeader.db.profile.rank5promote~=true then
SetGuildMemberRank(i,7)
if ranki+1<7 then
ANNOUNCErankdemote=ANNOUNCErankdemote+1
end
end
end
end
end
end
end
if GuildControlGetNumRanks()==6 and ranki+1<6 and IsGuildRankAssignmentAllowed(ranki,6)==true and GuildLeader.db.profile.demotemode==true and CheckTable(GuildLeader.db.profile.GLDemoteExemptt, name)==0 then
if level/GuildLeader.db.profile.rank1level<1 or GuildLeader.db.profile.rank1promote~=true then
if level/GuildLeader.db.profile.rank2level<1 or GuildLeader.db.profile.rank2promote~=true then
if level/GuildLeader.db.profile.rank3level<1 or GuildLeader.db.profile.rank3promote~=true then
if level/GuildLeader.db.profile.rank4level<1 or GuildLeader.db.profile.rank4promote~=true then
SetGuildMemberRank(i,6)
if ranki+1<6 then
ANNOUNCErankdemote=ANNOUNCErankdemote+1
end
end
end
end
end
end
if GuildControlGetNumRanks()==5 and ranki+1<5 and IsGuildRankAssignmentAllowed(ranki,5)==true and GuildLeader.db.profile.demotemode==true and CheckTable(GuildLeader.db.profile.GLDemoteExemptt, name)==0 then
if level/GuildLeader.db.profile.rank1level<1 or GuildLeader.db.profile.rank1promote~=true then
if level/GuildLeader.db.profile.rank2level<1 or GuildLeader.db.profile.rank2promote~=true then
if level/GuildLeader.db.profile.rank3level<1 or GuildLeader.db.profile.rank3promote~=true then
SetGuildMemberRank(i,5)
if ranki+1<5 then
ANNOUNCErankdemote=ANNOUNCErankdemote+1
end
end
end
end
end
if GuildControlGetNumRanks()==4 and ranki+1<4 and IsGuildRankAssignmentAllowed(ranki,4)==true and GuildLeader.db.profile.demotemode==true and CheckTable(GuildLeader.db.profile.GLDemoteExemptt, name)==0 then
if level/GuildLeader.db.profile.rank1level<1 or GuildLeader.db.profile.rank1promote~=true then
if level/GuildLeader.db.profile.rank2level<1 or GuildLeader.db.profile.rank2promote~=true then
SetGuildMemberRank(i,4)
if ranki+1<4 then
ANNOUNCErankdemote=ANNOUNCErankdemote+1
end
end
end
end
if GuildControlGetNumRanks()==3 and ranki+1<3 and IsGuildRankAssignmentAllowed(ranki,3)==true and GuildLeader.db.profile.demotemode==true and CheckTable(GuildLeader.db.profile.GLDemoteExemptt, name)==0 then
if level/GuildLeader.db.profile.rank1level<1 or GuildLeader.db.profile.rank1promote~=true then
SetGuildMemberRank(i,3)
if ranki+1<3 then
ANNOUNCErankdemote=ANNOUNCErankdemote+1
end
end
end
end
end
if GuildLeader.db.profile.promoteannounce==3 then
GuildLeader:GLPromoteStatsGuildAnnounceLevel()
end
if GuildLeader.db.profile.promoteannounce==2 then
GuildLeader:GLPromoteStatsOfficerAnnounceLevel()
end
else
GuildLeader:Print("ERROR! Multiple Active Ranks have EQUAL Level Requirements! Change your settings and try again.")
if GuildLeader.db.profile.automatepromote==true then
GuildLeader:Print("Disabling Automatic Promotions!")
GuildLeader.db.profile.automatepromote=false
end
end
end

function GuildLeader:GLPromoteStatsGuildAnnounceLevel()
if ANNOUNCErank1promote>0 then
SendChatMessage(strjoin(" ",ANNOUNCErank1promote,"Members were promoted to",GuildControlGetRankName(2),"for reaching LEVEL",GuildLeader.db.profile.rank1level,"!"),"guild", nil,"GUILD")
end
if ANNOUNCErank2promote>0 then
SendChatMessage(strjoin(" ",ANNOUNCErank2promote,"Members were promoted to",GuildControlGetRankName(3),"for reaching LEVEL",GuildLeader.db.profile.rank2level,"!"),"guild", nil,"GUILD")
end
if ANNOUNCErank3promote>0 then
SendChatMessage(strjoin(" ",ANNOUNCErank3promote,"Members were promoted to",GuildControlGetRankName(4),"for reaching LEVEL",GuildLeader.db.profile.rank3level,"!"),"guild", nil,"GUILD")
end
if ANNOUNCErank4promote>0 then
SendChatMessage(strjoin(" ",ANNOUNCErank4promote,"Members were promoted to",GuildControlGetRankName(5),"for reaching LEVEL",GuildLeader.db.profile.rank4level,"!"),"guild", nil,"GUILD")
end
if ANNOUNCErank5promote>0 then
SendChatMessage(strjoin(" ",ANNOUNCErank5promote,"Members were promoted to",GuildControlGetRankName(6),"for reaching LEVEL",GuildLeader.db.profile.rank5level,"!"),"guild", nil,"GUILD")
end
if ANNOUNCErank6promote>0 then
SendChatMessage(strjoin(" ",ANNOUNCErank6promote,"Members were promoted to",GuildControlGetRankName(7),"for reaching LEVEL",GuildLeader.db.profile.rank6level,"!"),"guild", nil,"GUILD")
end
if ANNOUNCErank7promote>0 then
SendChatMessage(strjoin(" ",ANNOUNCErank7promote,"Members were promoted to",GuildControlGetRankName(8),"for reaching LEVEL",GuildLeader.db.profile.rank7level,"!"),"guild", nil,"GUILD")
end
if ANNOUNCErank8promote>0 then
SendChatMessage(strjoin(" ",ANNOUNCErank8promote,"Members were promoted to",GuildControlGetRankName(9),"for reaching LEVEL",GuildLeader.db.profile.rank8level,"!"),"guild", nil,"GUILD")
end
if ANNOUNCErankdemote>0 then
SendChatMessage(strjoin(" ",ANNOUNCErankdemote,"Members were demoted for having a Level that is LESS then the rank requires!"),"guild", nil,"GUILD")
end
end

function GuildLeader:GLPromoteStatsOfficerAnnounceLevel()
if ANNOUNCErank1promote>0 then
SendChatMessage(strjoin(" ",ANNOUNCErank1promote,"Members were promoted to",GuildControlGetRankName(2),"for reaching LEVEL",GuildLeader.db.profile.rank1level,"!"),"officer", nil,"OFFICER")
end
if ANNOUNCErank2promote>0 then
SendChatMessage(strjoin(" ",ANNOUNCErank2promote,"Members were promoted to",GuildControlGetRankName(3),"for reaching LEVEL",GuildLeader.db.profile.rank2level,"!"),"officer", nil,"OFFICER")
end
if ANNOUNCErank3promote>0 then
SendChatMessage(strjoin(" ",ANNOUNCErank3promote,"Members were promoted to",GuildControlGetRankName(4),"for reaching LEVEL",GuildLeader.db.profile.rank3level,"!"),"officer", nil,"OFFICER")
end
if ANNOUNCErank4promote>0 then
SendChatMessage(strjoin(" ",ANNOUNCErank4promote,"Members were promoted to",GuildControlGetRankName(5),"for reaching LEVEL",GuildLeader.db.profile.rank4level,"!"),"officer", nil,"OFFICER")
end
if ANNOUNCErank5promote>0 then
SendChatMessage(strjoin(" ",ANNOUNCErank5promote,"Members were promoted to",GuildControlGetRankName(6),"for reaching LEVEL",GuildLeader.db.profile.rank5level,"!"),"officer", nil,"OFFICER")
end
if ANNOUNCErank6promote>0 then
SendChatMessage(strjoin(" ",ANNOUNCErank6promote,"Members were promoted to",GuildControlGetRankName(7),"for reaching LEVEL",GuildLeader.db.profile.rank6level,"!"),"officer", nil,"OFFICER")
end
if ANNOUNCErank7promote>0 then
SendChatMessage(strjoin(" ",ANNOUNCErank7promote,"Members were promoted to",GuildControlGetRankName(8),"for reaching LEVEL",GuildLeader.db.profile.rank7level,"!"),"officer", nil,"OFFICER")
end
if ANNOUNCErank8promote>0 then
SendChatMessage(strjoin(" ",ANNOUNCErank8promote,"Members were promoted to",GuildControlGetRankName(9),"for reaching LEVEL",GuildLeader.db.profile.rank8level,"!"),"officer", nil,"OFFICER")
end
if ANNOUNCErankdemote>0 then
SendChatMessage(strjoin(" ",ANNOUNCErankdemote,"Members were demoted for having a Level that is LESS then the rank requires!"),"officer", nil,"OFFICER")
end
end

--*ANNOUNCEMENTS*--
function GuildLeader:RunAnnouncemnts()
if AnnouncementsActivated~=1 and ValidMessages~=1 then--Announcements
GuildLeader:AnnouncementsActivate()
else
GuildLeader:NextAnnouncementValid()
end
end
--Load & Reload Functions--
function GuildLeader:AnnouncementsActivate()
GuildLeader:AnnouncementsFindValid()
if (GuildLeader.db.profile.lastannounced==0 or GuildLeader.db.profile.announcenext==0) and ValidMessages==1 then
GuildLeader:DetermineNextAnnouncement()
GuildLeader:AnnouncementsActivate()
elseif (GuildLeader.db.profile.lastannounced==0 or GuildLeader.db.profile.announcenext==0) and ValidMessages==0 then
AnnouncementsActivated=0
else
end
if GuildLeader.db.profile.lastannounced~=0 and GuildLeader.db.profile.announcenext~=0 and ValidMessages==1 then
AnnouncementsActivated=1
GuildLeader:NextAnnouncementValid()
else
AnnouncementsActivated=0
end
end

function GuildLeader:NextAnnouncementValid()
if GuildLeader.db.profile.announcenext==1 then
if GuildLeader.db.profile.announcement1~="" and (GuildLeader.db.profile.announcementto1==2 or GuildLeader.db.profile.announcementto1==3) then
GuildLeader.db.profile.nextannouncemessage=GuildLeader.db.profile.announcement1
GuildLeader.db.profile.nextannouncetime=GuildLeader.db.profile.announcementtimer1
GuildLeader.db.profile.nextannouncechannel=GuildLeader.db.profile.announcementto1
GuildLeader.db.profile.nextannounceborder=GuildLeader.db.profile.announcementborder1
GuildLeader:CheckTimeAnnouncement()
else
GuildLeader:AnnouncementsFindValid()
if ValidMessages==1 then
GuildLeader:DetermineNextAnnouncement()
else
AnnouncementsActivated=0
end
end
end
if GuildLeader.db.profile.announcenext==2 then 
if GuildLeader.db.profile.announcement2~="" and (GuildLeader.db.profile.announcementto2==2 or GuildLeader.db.profile.announcementto2==3) then
GuildLeader.db.profile.nextannouncemessage=GuildLeader.db.profile.announcement2
GuildLeader.db.profile.nextannouncetime=GuildLeader.db.profile.announcementtimer2
GuildLeader.db.profile.nextannouncechannel=GuildLeader.db.profile.announcementto2
GuildLeader.db.profile.nextannounceborder=GuildLeader.db.profile.announcementborder2
GuildLeader:CheckTimeAnnouncement()
else
GuildLeader:AnnouncementsFindValid()
if ValidMessages==1 then
GuildLeader:DetermineNextAnnouncement()
else
AnnouncementsActivated=0
end
end
end
if GuildLeader.db.profile.announcenext==3 then
if GuildLeader.db.profile.announcement3~="" and (GuildLeader.db.profile.announcementto3==2 or GuildLeader.db.profile.announcementto3==3) then
GuildLeader.db.profile.nextannouncemessage=GuildLeader.db.profile.announcement3
GuildLeader.db.profile.nextannouncetime=GuildLeader.db.profile.announcementtimer3
GuildLeader.db.profile.nextannouncechannel=GuildLeader.db.profile.announcementto3
GuildLeader.db.profile.nextannounceborder=GuildLeader.db.profile.announcementborder3
GuildLeader:CheckTimeAnnouncement()
else
GuildLeader:AnnouncementsFindValid()
if ValidMessages==1 then
GuildLeader:DetermineNextAnnouncement()
else
AnnouncementsActivated=0
end
end
end
if GuildLeader.db.profile.announcenext==4 then
if GuildLeader.db.profile.announcement4~="" and (GuildLeader.db.profile.announcementto4==2 or GuildLeader.db.profile.announcementto4==3) then
GuildLeader.db.profile.nextannouncemessage=GuildLeader.db.profile.announcement4
GuildLeader.db.profile.nextannouncetime=GuildLeader.db.profile.announcementtimer4
GuildLeader.db.profile.nextannouncechannel=GuildLeader.db.profile.announcementto4
GuildLeader.db.profile.nextannounceborder=GuildLeader.db.profile.announcementborder4
GuildLeader:CheckTimeAnnouncement()
else
GuildLeader:AnnouncementsFindValid()
if ValidMessages==1 then
GuildLeader:DetermineNextAnnouncement()
else
AnnouncementsActivated=0
end
end
end
if GuildLeader.db.profile.announcenext==5 then
if GuildLeader.db.profile.announcement5~="" and (GuildLeader.db.profile.announcementto5==2 or GuildLeader.db.profile.announcementto5==3) then
GuildLeader.db.profile.nextannouncemessage=GuildLeader.db.profile.announcement5
GuildLeader.db.profile.nextannouncetime=GuildLeader.db.profile.announcementtimer5
GuildLeader.db.profile.nextannouncechannel=GuildLeader.db.profile.announcementto5
GuildLeader.db.profile.nextannounceborder=GuildLeader.db.profile.announcementborder5
GuildLeader:CheckTimeAnnouncement()
else
GuildLeader:AnnouncementsFindValid()
if ValidMessages==1 then
GuildLeader:DetermineNextAnnouncement()
else
AnnouncementsActivated=0
end
end
end
end

function GuildLeader:AnnouncementsFindValid()
if GuildLeader.db.profile.announcement1~="" and (GuildLeader.db.profile.announcementto1==2 or GuildLeader.db.profile.announcementto1==3) then
Announcement1Valid=1
else
Announcement1Valid=0
end
if GuildLeader.db.profile.announcement2~="" and (GuildLeader.db.profile.announcementto2==2 or GuildLeader.db.profile.announcementto2==3) then
Announcement2Valid=1
else
Announcement2Valid=0
end
if GuildLeader.db.profile.announcement3~="" and (GuildLeader.db.profile.announcementto3==2 or GuildLeader.db.profile.announcementto3==3) then
Announcement3Valid=1
else
Announcement3Valid=0
end
if GuildLeader.db.profile.announcement4~="" and (GuildLeader.db.profile.announcementto4==2 or GuildLeader.db.profile.announcementto4==3) then
Announcement4Valid=1
else
Announcement4Valid=0
end
if GuildLeader.db.profile.announcement5~="" and (GuildLeader.db.profile.announcementto5==2 or GuildLeader.db.profile.announcementto5==3) then
Announcement5Valid=1
else
Announcement5Valid=0
end
if Announcement1Valid==0 and Announcement2Valid==0 and Announcement3Valid==0 and Announcement4Valid==0 and Announcement5Valid==0 then 
ValidMessages=0
else
ValidMessages=1
end
end

function GuildLeader:DetermineNextAnnouncement()
reachedendofcheck=0
GuildLeader:AnnouncementsFindValid()
if GuildLeader.db.profile.lastannounced==5 and Announcement1Valid==1 then
GuildLeader.db.profile.announcenext=1
GuildLeader.db.profile.nextannouncemessage=GuildLeader.db.profile.announcement1
GuildLeader.db.profile.nextannouncetime=GuildLeader.db.profile.announcementtimer1
GuildLeader.db.profile.nextannouncechannel=GuildLeader.db.profile.announcementto1
GuildLeader.db.profile.nextannounceborder=GuildLeader.db.profile.announcementborder1
elseif GuildLeader.db.profile.lastannounced==5 and Announcement1Valid==0 then
GuildLeader.db.profile.lastannounced=1
end
if GuildLeader.db.profile.lastannounced==1 and Announcement2Valid==1 then
GuildLeader.db.profile.announcenext=2
GuildLeader.db.profile.nextannouncemessage=GuildLeader.db.profile.announcement2
GuildLeader.db.profile.nextannouncetime=GuildLeader.db.profile.announcementtimer2
GuildLeader.db.profile.nextannouncechannel=GuildLeader.db.profile.announcementto2
GuildLeader.db.profile.nextannounceborder=GuildLeader.db.profile.announcementborder2
elseif GuildLeader.db.profile.lastannounced==1 and Announcement2Valid==0 then
GuildLeader.db.profile.lastannounced=2
end
if GuildLeader.db.profile.lastannounced==2 and Announcement3Valid==1 then
GuildLeader.db.profile.announcenext=3
GuildLeader.db.profile.nextannouncemessage=GuildLeader.db.profile.announcement3
GuildLeader.db.profile.nextannouncetime=GuildLeader.db.profile.announcementtimer3
GuildLeader.db.profile.nextannouncechannel=GuildLeader.db.profile.announcementto3
GuildLeader.db.profile.nextannounceborder=GuildLeader.db.profile.announcementborder3
elseif GuildLeader.db.profile.lastannounced==2 and Announcement3Valid==0 then
GuildLeader.db.profile.lastannounced=3
end
if GuildLeader.db.profile.lastannounced==3 and Announcement4Valid==1 then
GuildLeader.db.profile.announcenext=4
GuildLeader.db.profile.nextannouncemessage=GuildLeader.db.profile.announcement4
GuildLeader.db.profile.nextannouncetime=GuildLeader.db.profile.announcementtimer4
GuildLeader.db.profile.nextannouncechannel=GuildLeader.db.profile.announcementto4
GuildLeader.db.profile.nextannounceborder=GuildLeader.db.profile.announcementborder4
elseif GuildLeader.db.profile.lastannounced==3 and Announcement4Valid==0 then
GuildLeader.db.profile.lastannounced=4
end
if GuildLeader.db.profile.lastannounced==4 and Announcement5Valid==1 then
GuildLeader.db.profile.announcenext=5
GuildLeader.db.profile.nextannouncemessage=GuildLeader.db.profile.announcement5
GuildLeader.db.profile.nextannouncetime=GuildLeader.db.profile.announcementtimer5
GuildLeader.db.profile.nextannouncechannel=GuildLeader.db.profile.announcementto5
GuildLeader.db.profile.nextannounceborder=GuildLeader.db.profile.announcementborder5
elseif GuildLeader.db.profile.lastannounced==4 and Announcement5Valid==0 then
GuildLeader.db.profile.lastannounced=5
reachedendofcheck=1
if GuildLeader.db.profile.lastannounced==5 and reachedendofcheck==1 and ValidMessages==1 then
GuildLeader:DetermineNextAnnouncement()
end
end
end

--Timer Functions--
function GuildLeader:CheckTimeAnnouncement()
if GuildLeader.db.profile.lastanntime==nil then 
GuildLeader.db.profile.lastanntime=0 
end
lastanndiff=GuildLeader:GetTime()-GuildLeader.db.profile.lastanntime
if lastanndiff>=GuildLeader.db.profile.nextannouncetime then
GuildLeader:ExecuteAnnouncement()
elseif lastanndiff<GuildLeader.db.profile.nextannouncetime then
end
end

--Format Functions--
function GuildLeader:PrintBorder()
if GuildLeader.db.profile.nextannouncechannel==2 then
borderchannel="officer"
bordertarget="OFFICER"
elseif GuildLeader.db.profile.nextannouncechannel==3 then
borderchannel="guild"
bordertarget="GUILD"
end
if GuildLeader.db.profile.nextannouncechannel==2 or GuildLeader.db.profile.nextannouncechannel==3 then
if GuildLeader.db.profile.nextannounceborder==2 then
SendChatMessage("{Star}{Star}{Star}{Star}{Star}{Star}{Star}{Star}{Star}{Star}{Star}{Star}{Star}{Star}{Star}{Star}{Star}{Star}{Star}{Star}",borderchannel, nil,bordertarget)
end
if GuildLeader.db.profile.nextannounceborder==3 then
SendChatMessage("{Circle}{Circle}{Circle}{Circle}{Circle}{Circle}{Circle}{Circle}{Circle}{Circle}{Circle}{Circle}{Circle}{Circle}{Circle}{Circle}{Circle}{Circle}{Circle}{Circle}",borderchannel, nil,bordertarget)
end
if GuildLeader.db.profile.nextannounceborder==4 then
SendChatMessage("{Diamond}{Diamond}{Diamond}{Diamond}{Diamond}{Diamond}{Diamond}{Diamond}{Diamond}{Diamond}{Diamond}{Diamond}{Diamond}{Diamond}{Diamond}{Diamond}{Diamond}{Diamond}{Diamond}{Diamond}",borderchannel, nil,bordertarget)
end
if GuildLeader.db.profile.nextannounceborder==5 then
SendChatMessage("{Triangle}{Triangle}{Triangle}{Triangle}{Triangle}{Triangle}{Triangle}{Triangle}{Triangle}{Triangle}{Triangle}{Triangle}{Triangle}{Triangle}{Triangle}{Triangle}{Triangle}{Triangle}{Triangle}{Triangle}",borderchannel, nil,bordertarget)
end
if GuildLeader.db.profile.nextannounceborder==6 then
SendChatMessage("{Moon}{Moon}{Moon}{Moon}{Moon}{Moon}{Moon}{Moon}{Moon}{Moon}{Moon}{Moon}{Moon}{Moon}{Moon}{Moon}{Moon}{Moon}{Moon}{Moon}",borderchannel, nil,bordertarget)
end
if GuildLeader.db.profile.nextannounceborder==7 then
SendChatMessage("{Square}{Square}{Square}{Square}{Square}{Square}{Square}{Square}{Square}{Square}{Square}{Square}{Square}{Square}{Square}{Square}{Square}{Square}{Square}{Square}",borderchannel, nil,bordertarget)
end
if GuildLeader.db.profile.nextannounceborder==8 then
SendChatMessage("{X}{X}{X}{X}{X}{X}{X}{X}{X}{X}{X}{X}{X}{X}{X}{X}{X}{X}{X}{X}",borderchannel, nil,bordertarget)
end
if GuildLeader.db.profile.nextannounceborder==9 then
SendChatMessage("{Skull}{Skull}{Skull}{Skull}{Skull}{Skull}{Skull}{Skull}{Skull}{Skull}{Skull}{Skull}{Skull}{Skull}{Skull}{Skull}{Skull}{Skull}{Skull}{Skull}",borderchannel, nil,bordertarget)
end
end
end

function GuildLeader:PrintAnnouncement()
nextannvar=GuildLeader.db.profile.nextannouncemessage
if GuildLeader.db.profile.nextannouncechannel==2 then
annchannel="officer"
anntarget="OFFICER"
elseif GuildLeader.db.profile.nextannouncechannel==3 then
annchannel="guild"
anntarget="GUILD"
end
local message, pattern, position;
position = 1;
for i = 1, #nextannvar, 255 do
message = nextannvar:sub(position, position + 254);
if #message < 255 then
pattern = ".+";
else
pattern = "(.+)%s";
end
for capture in message:gmatch(pattern) do
SendChatMessage(capture,annchannel, nil,anntarget)
position = position + #capture + 1;
end
end
end

--Execution Functions--
function GuildLeader:ExecuteAnnouncement()
GuildLeader:PrintBorder()
GuildLeader:PrintAnnouncement()
GuildLeader:PrintBorder()
GuildLeader:LoadNextAnnouncement()
end

function GuildLeader:LoadNextAnnouncement()
if announcementskip~=1 then
GuildLeader.db.profile.lastanntime=GuildLeader:GetTime()
end
GuildLeader.db.profile.lastannounced=GuildLeader.db.profile.announcenext
if GuildLeader.db.profile.lastannounced==5 then 
nextinline=1
else
nextinline=GuildLeader.db.profile.lastannounced+1
end
GuildLeader.db.profile.announcenext=nextinline
GuildLeader:NextAnnouncementValid()
end